# -----------------------------------------------------------------------
# Su-15 JSBSim course system simplified nasal analog

coursesystem=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("systems/coursesystem/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("systems/coursesystem/time-sec").setValue(time_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1) and
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{
		fdm_node.getNode("systems/coursesystem/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/coursesystem/serviceable").setValue(1);
	}

	#Controlability

	if (fdm_node.getNode("breakage/pilot-knocked").getValue()==1)
	{
		fdm_node.getNode("systems/coursesystem/controllable").setValue(0);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/controllable").setValue(1);
	}

	#On

	if (
		(fdm_node.getNode("systems/coursesystem/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/conv-on").getValue()==1) and
		(fdm_node.getNode("systems/rightpanel/course-system-switch").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/switches/power-switch").getValue()==1) or
			(fdm_node.getNode("systems/stick/level-button-switch").getValue()==1)
		)
		)
	{
		fdm_node.getNode("systems/coursesystem/on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/on").setValue(0);
	}

	#Main procedures

	#Common

	fdm_node.getNode("systems/coursesystem/calc/course-diff-deg").setValue(
		fdm_node.getNode("systems/infoline/lock/course-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()		
	);

	course_diff_deg=fdm_node.getNode("systems/coursesystem/calc/course-diff-deg").getValue();
	if (course_diff_deg<-180)
	{
		course_diff_deg=course_diff_deg+360;
	}
	if (course_diff_deg>180)
	{
		course_diff_deg=course_diff_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/calc/course-diff-corr-deg").setValue(course_diff_deg);

	fdm_node.getNode("systems/coursesystem/calc/course-diff-abs").setValue(
		abs(course_diff_deg));

	fdm_node.getNode("systems/coursesystem/calc/heading-inv-deg").setValue(
		fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()-
		180);

	heading_inv_deg=fdm_node.getNode("systems/coursesystem/calc/heading-inv-deg").getValue();
	if (heading_inv_deg<-180)
	{
		heading_inv_deg=heading_inv_deg+360;
	}
	if (heading_inv_deg>180)
	{
		heading_inv_deg=heading_inv_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").setValue(heading_inv_deg);

	fdm_node.getNode("systems/coursesystem/calc/intake-med-pos").setValue(
		(
			fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()+
			fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()
		)/2
	);

	fdm_node.getNode("systems/coursesystem/calc/contrary-deg").setValue(
		fdm_node.getNode("systems/infoline/lock/course-deg").getValue()-
		fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()
	);

	contrary_deg=fdm_node.getNode("systems/coursesystem/calc/contrary-deg").getValue();
	if (contrary_deg<-180)
	{
		contrary_deg=contrary_deg+360;
	}
	if (contrary_deg>180)
	{
		contrary_deg=contrary_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/calc/contrary-corr-deg").setValue(contrary_deg);

	if ((fdm_node.getNode("systems/coursesystem/calc/contrary-corr-deg").getValue()<=(-90)) or
		(fdm_node.getNode("systems/coursesystem/calc/contrary-corr-deg").getValue()>=90))
	{
		fdm_node.getNode("systems/coursesystem/calc/plus-or-minus").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/calc/plus-or-minus").setValue(0);
	}

	ind_ms=
		interpol.lin_inter(
			[
				[0.0,			1.4],
				[5000.0,	1.4],
				[7500.0,	1.5],
				[12000.0,	2.0],
				[15000.0,	2.1]
			],
			fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()
		)*1191*0.2777;
	tgt_ms=fdm_node.getNode("systems/infoline/lock/airspeed-kmh").getValue()*0.2777;
	heading_rad=
		fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
		57.2957795;
	tgt_heading_rad=
		fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
		57.2957795;

	fdm_node.getNode("systems/coursesystem/calc/squares-speed-ms").setValue(
		math.pow(
			(
				math.pow((ind_ms*math.cos(heading_rad)+
					interpol.lin_inter(
						[
							[0.0,	1.0],
							[1.0,	-1.0]
						],
						fdm_node.getNode("systems/coursesystem/calc/plus-or-minus").getValue()
					)*
					tgt_ms*math.cos(tgt_heading_rad)+0.000001), 2)+
				math.pow((ind_ms*math.sin(heading_rad)+
					interpol.lin_inter(
						[
							[0.0,	1.0],
							[1.0,	-1.0]
						],
						fdm_node.getNode("systems/coursesystem/calc/plus-or-minus").getValue()
					)*
					tgt_ms*math.sin(tgt_heading_rad)+0.000001), 2)
				+0.000001
			), 
			0.5)
	);

	fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").setValue(
		fdm_node.getNode("systems/infoline/lock/distance-m").getValue()/
		fdm_node.getNode("systems/coursesystem/calc/squares-speed-ms").getValue()
	);

	fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").setValue(
		fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()*
		fdm_node.getNode("systems/infoline/lock/airspeed-kmh").getValue()*
		0.2777
	);

	#Takeoff

		#calculated always, as used at landing too

	fdm_node.getNode("systems/coursesystem/modes/takeoff/lon-m").setValue(
		(
			(fdm_node.getNode("systems/infoline/lock/distance-m").getValue()+
				1000)*
			math.sin
				(fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/takeoff/alt-m").setValue(
		fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()+
		2000
	);

	fdm_node.getNode("systems/coursesystem/modes/takeoff/lat-m").setValue(
		(
			(fdm_node.getNode("systems/infoline/lock/distance-m").getValue()+
				1000)*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/takeoff/dist-m").setValue(
		math.pow(
			(
				math.pow(fdm_node.getNode("systems/coursesystem/modes/takeoff/lon-m").getValue(), 2)+
				math.pow(fdm_node.getNode("systems/coursesystem/modes/takeoff/lat-m").getValue(), 2)
			), 0.5
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/takeoff/course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/takeoff/lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/takeoff/lat-m").getValue()
		)*
		57.2957795
	);

	course_corr_deg=fdm_node.getNode("systems/coursesystem/modes/takeoff/course-deg").getValue();
	if (course_corr_deg<-180)
	{
		course_corr_deg=course_corr_deg+360;
	}
	if (course_corr_deg>180)
	{
		course_corr_deg=course_corr_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/modes/takeoff/course-corr-deg").setValue(course_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/takeoff/course-diff-deg").setValue(
		fdm_node.getNode("systems/coursesystem/modes/takeoff/course-corr-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()
		);

	course_diff_corr_deg=fdm_node.getNode("systems/coursesystem/modes/takeoff/course-diff-deg").getValue();
	if (course_diff_corr_deg<-180)
	{
		course_diff_corr_deg=course_diff_corr_deg+360;
	}
	if (course_diff_corr_deg>180)
	{
		course_diff_corr_deg=course_diff_corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/takeoff/course-diff-corr-deg").setValue(course_diff_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/takeoff/course-diff-abs-deg").setValue(
		abs(course_diff_corr_deg));

	fdm_node.getNode("systems/coursesystem/modes/takeoff/speed-diff-mach").setValue(
		fdm_node.getNode("systems/coursesystem/modes/takeoff/speed-kmh").getValue()/1191-
		fdm_node.getNode("systems/pitot/mach").getValue()
	);

		#engine

	fdm_node.getNode("systems/coursesystem/modes/takeoff/engine").setValue(
		interpol.lin_inter(
			[
				[-0.05,		0.21],
				[0.0,			0.925]
			],
			fdm_node.getNode("systems/coursesystem/modes/takeoff/speed-diff-mach").getValue()
		)
	);

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{

	#Passing

	fdm_node.getNode("systems/coursesystem/modes/pass/course-deg").setValue(
		fdm_node.getNode("systems/courseindicator/course-input-deg").getValue()
	);

	fdm_node.getNode("systems/coursesystem/modes/pass/lon-m").setValue(
		fdm_node.getNode("systems/courseindicator/distance-m").getValue()*
		math.sin(
			fdm_node.getNode("systems/coursesystem/modes/pass/course-deg").getValue()/
			57.2957795
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/pass/lat-m").setValue(
		fdm_node.getNode("systems/courseindicator/distance-m").getValue()*
		math.cos(
			fdm_node.getNode("systems/coursesystem/modes/pass/course-deg").getValue()/
			57.2957795
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/pass/dist-m").setValue(
		math.pow(
			(
				math.pow(fdm_node.getNode("systems/coursesystem/modes/pass/lon-m").getValue(), 2)+
				math.pow(fdm_node.getNode("systems/coursesystem/modes/pass/lat-m").getValue(), 2)
			), 0.5
		)
	);

	course_corr_deg=fdm_node.getNode("systems/coursesystem/modes/pass/course-deg").getValue();
	if (course_corr_deg<-180)
	{
		course_corr_deg=course_corr_deg+360;
	}
	if (course_corr_deg>180)
	{
		course_corr_deg=course_corr_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/modes/pass/course-corr-deg").setValue(course_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/pass/course-diff-deg").setValue(
		fdm_node.getNode("systems/coursesystem/modes/pass/course-corr-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()
	);

	course_diff_corr_deg=fdm_node.getNode("systems/coursesystem/modes/pass/course-diff-deg").getValue();
	if (course_diff_corr_deg<-180)
	{
		course_diff_corr_deg=course_diff_corr_deg+360;
	}
	if (course_diff_corr_deg>180)
	{
		course_diff_corr_deg=course_diff_corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/pass/course-diff-corr-deg").setValue(course_diff_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/pass/course-diff-abs-deg").setValue(
		abs(course_diff_corr_deg));

	fdm_node.getNode("systems/coursesystem/modes/pass/ailerons-rad").setValue(
		interpol.lin_inter(
			[
				[-180.0,	-0.1],
				[-165.0,	-0.785],
				[-45.0,	-0.785],
				[-15.0,	-0.4],
				[-5.0,	-0.2],
				[0.0,	0.0],
				[5.0,	0.2],
				[15.0,	0.4],
				[45.0,	0.785],
				[165.0,	0.785],
				[180.0,	0.1]
			],
			fdm_node.getNode("systems/coursesystem/modes/pass/course-diff-corr-deg").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/pass/alt-m").setValue(
		interpol.sqr_inter(
			[
				[0.0,			0.8,			1.9,			2.0],
				[0.0,			450.0,		50.0,			450.0],
				[450.0,		450.0,		50.0,			450.0],
				[10000.0,	10000.0,	10000.0,	10000.0],
				[15000.0,	15000.0,	15000.0,	15000.0],
				[18000.0,	10000.0,	15000.0,	18000.0]
			],
			fdm_node.getNode("systems/coursesystem/set/h-distance-m").getValue(),
			fdm_node.getNode("systems/pitot/mach").getValue()
		)
	);

		#vertical speed difference

	fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-m-sec").setValue(
		(		
			fdm_node.getNode("systems/vertspeedometer/v-down-ms").getValue()*
			interpol.lin_inter(
				[
					[300.0,	0.0],
					[600.0,	-1.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)+
		(
			fdm_node.getNode("systems/radioaltimeter/vert-speed-m-s").getValue()*
			interpol.lin_inter(
				[
					[300.0,	1.0],
					[600.0,	0.0],
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)+
		(
			(
				fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()-
				fdm_node.getNode("systems/coursesystem/modes/pass/alt-m").getValue()
			)*
			interpol.lin_inter(
				[
					[-0.785,	0.25],
					[0.0,			0.05],
					[0.785,		0.25]
				],
				fdm_node.getNode("systems/arthorizon/roll-indicated-rad").getValue()
			)*
			interpol.lin_inter(
				[
					[300.0,	0.0],
					[600.0,	1.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)+
		(
			(
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()-
				fdm_node.getNode("systems/coursesystem/modes/pass/alt-m").getValue()
			)*
			interpol.lin_inter(
				[
					[-0.785,	0.5],
					[0.0,			0.1],
					[0.785,		0.5]
				],
				fdm_node.getNode("systems/arthorizon/roll-indicated-rad").getValue()
			)*
			interpol.lin_inter(
				[
					[300.0,	1.0],
					[600.0,	0.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)
	);

		#vertical acceleration

	fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-acc").setValue(
		fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-acc").getValue()
		+(
			-fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-acc").getValue()
			+
			(
				fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-m-sec").getValue()
				-fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-prev").getValue()
			)
			/(tick_sec+0.00001)
		)*0.5
	);

	fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-prev").setValue(
		fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-m-sec").getValue()
	);

		#elevator input

	fdm_node.getNode("systems/coursesystem/modes/pass/elevator-inp").setValue(
		fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-m-sec").getValue()
		+4*fdm_node.getNode("systems/coursesystem/modes/pass/v-speed-diff-acc").getValue()
	);

		#elevator increment

	fdm_node.getNode("systems/coursesystem/modes/pass/elevator-inc").setValue(
		interpol.sps_inter(
			[
				[
					[500.0,		-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.1,		0.1,		0.1,		0.0,		-0.1],
					[-10.0,		0.1,		0.02,		0.02,		0.0,		-0.1],
					[0.0,			0.1,		0.0,		0.0,		0.0,		-0.1],
					[10.0,		0.1,		0.0,		-0.02,	-0.02,	-0.1],
					[100.0,		0.1,		0.0,		-0.1,		-0.1,		-0.1]
				],
				[
					[2000.0,	-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.01,		0.01,		0.01,		0.0,		-0.01],
					[-10.0,		0.01,		0.005,	0.005,	0.0,		-0.01],
					[0.0,			0.01,		0.0,		0.0,		0.0,		-0.01],
					[10.0,		0.01,		0.0,		-0.005,	-0.005,	-0.01],
					[100.0,		0.01,		0.0,		-0.01,	-0.01,	-0.01]				
				]
			],
			fdm_node.getNode("systems/pitot/qbar-psf").getValue(),		
			fdm_node.getNode("systems/coursesystem/modes/pass/elevator-inp").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)
	);

		#speed difference

	fdm_node.getNode("systems/coursesystem/modes/pass/speed-kmh").setValue(
		interpol.sps_inter(
			[
				[
					[0.1,			0.0,	10000.0,	18000.0],
					[0.0,			0.8,	0.8,			0.8],
					[5000.0,	0.8,	0.8,			0.8],
					[10000.0,	0.8,	0.8,			1.0],
					[15000.0,	0.8,	0.8,			2.0]
				],
				[
					[0.2,			0.0,	10000.0,	18000.0],
					[0.0,			0.8,	0.8,			0.8],
					[5000.0,	1.0,	1.0,			1.0],
					[12000.0,	1.6,	1.6,			1.6],
					[15000.0,	1.6,	1.6,			2.0]
				]
			],
			fdm_node.getNode("systems/coursesystem/calc/intake-med-pos").getValue(),
			fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue(),
			fdm_node.getNode("systems/coursesystem/set/h-distance-m").getValue()
		)*1191
	);

	fdm_node.getNode("systems/coursesystem/modes/pass/speed-diff-mach").setValue(
		fdm_node.getNode("systems/coursesystem/modes/pass/speed-kmh").getValue()/1191-
		fdm_node.getNode("systems/pitot/mach").getValue()
	);

		#engine

	fdm_node.getNode("systems/coursesystem/modes/pass/engine").setValue(
		interpol.sps_inter(
			[
				[
					[5000.0,	0.84,		0.85,		1.0],
					[-0.075,	0.21,		0.21,		0.21],
					[-0.07,		0.25,		0.25,		0.25],
					[-0.005,	0.84,		0.84,		0.84],
					[0.0,			0.84,		0.84,		0.84]
				],
				[
					[10000.0,	0.84,		0.85,		1.0],
					[-0.075,	0.21,		0.21,		0.21],
					[-0.07,		0.25,		0.85,		0.85],
					[-0.005,	0.84,		0.95,		0.95],
					[0.0,			1.0,		1.0,		1.0]
				],
			],
			fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/pass/speed-diff-mach").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/pass/engine").getValue()
		)
	);


		#speedbrake

	fdm_node.getNode("systems/coursesystem/modes/pass/speedbrake").setValue(
		interpol.lin_inter(
				[
					[-0.1,		1.0],
					[-0.075,	0.0],
					[0.0,			0.0]
				],
			fdm_node.getNode("systems/coursesystem/modes/pass/speed-diff-mach").getValue()
		)
	);

	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{

	#Convoying

	fdm_node.getNode(
		"systems/coursesystem/modes/convoy/target-heading-plus-deg").setValue(
		fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()+
		90
	);

	corr_deg=
		fdm_node.getNode("systems/coursesystem/modes/convoy/target-heading-plus-deg").getValue();
	if (corr_deg<-180)
	{
		corr_deg=corr_deg+360;
	}
	if (corr_deg>180)
	{
		corr_deg=corr_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/modes/convoy/target-heading-plus-corr-deg").setValue(corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-lon-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			(-0.5)*
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.sin(
				fdm_node.getNode(
					"systems/coursesystem/modes/convoy/target-heading-plus-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-lat-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			(-0.5)*
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.cos(
				fdm_node.getNode(
					"systems/coursesystem/modes/convoy/target-heading-plus-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-dist-m").setValue(
		math.pow(
			(
				math.pow(fdm_node.getNode(
					"systems/coursesystem/modes/convoy/turn-plus-lon-m").getValue(), 2)+
				math.pow(fdm_node.getNode(
					"systems/coursesystem/modes/convoy/turn-plus-lat-m").getValue(), 2)
			), 0.5
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-lat-m").getValue()
		)*
		57.2957795
	);

	fdm_node.getNode(
		"systems/coursesystem/modes/convoy/target-heading-minus-deg").setValue(
		fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()-
		90
	);

	corr_deg=
		fdm_node.getNode("systems/coursesystem/modes/convoy/target-heading-minus-deg").getValue();
	if (corr_deg<-180)
	{
		corr_deg=corr_deg+360;
	}
	if (corr_deg>180)
	{
		corr_deg=corr_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/modes/convoy/target-heading-minus-corr-deg").setValue(corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-lon-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			(-0.5)*
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.sin(
				fdm_node.getNode(
					"systems/coursesystem/modes/convoy/target-heading-minus-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-lat-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			(-0.5)*
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/set/convoy-turn-m").getValue()*
			math.cos(
				fdm_node.getNode(
					"systems/coursesystem/modes/convoy/target-heading-minus-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-dist-m").setValue(
		math.pow(
			(
				math.pow(fdm_node.getNode(
					"systems/coursesystem/modes/convoy/turn-minus-lon-m").getValue(), 2)+
				math.pow(fdm_node.getNode(
					"systems/coursesystem/modes/convoy/turn-minus-lat-m").getValue(), 2)
			), 0.5
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-lat-m").getValue()
		)*
		57.2957795
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/lon-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/modes/convoy/dist-diff-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/lat-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/modes/convoy/dist-diff-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/course-calc-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/convoy/lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/convoy/lat-m").getValue()
		)*
		57.2957795
	);

	if	(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1)
	{
		if
		(
			fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-dist-m").getValue()<
			fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-dist-m").getValue()
		)
		{
			fdm_node.getNode("systems/coursesystem/modes/convoy/course-deg").setValue(
				fdm_node.getNode("systems/coursesystem/modes/convoy/turn-minus-course-deg").getValue()
			);
		}
		else
		{
			fdm_node.getNode("systems/coursesystem/modes/convoy/course-deg").setValue(
				fdm_node.getNode("systems/coursesystem/modes/convoy/turn-plus-course-deg").getValue()
			);
		}
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/convoy/course-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/convoy/course-calc-deg").getValue()
		);
	}

	corr_deg=fdm_node.getNode(
		"systems/coursesystem/modes/convoy/course-deg").getValue();
	if (corr_deg<-180)
	{
		corr_deg=corr_deg+360;
	}
	if (corr_deg>180)
	{
		corr_deg=corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/convoy/course-corr-deg").setValue(corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/convoy/course-diff-deg").setValue(
		fdm_node.getNode("systems/coursesystem/modes/convoy/course-corr-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()
	);

	corr_deg=fdm_node.getNode(
		"systems/coursesystem/modes/convoy/course-diff-deg").getValue();
	if (corr_deg<-180)
	{
		corr_deg=corr_deg+360;
	}
	if (corr_deg>180)
	{
		corr_deg=corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/convoy/course-diff-corr-deg"
		).setValue(corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/convoy/ailerons-rad").setValue(
		interpol.lin_inter(
			[
				[-180.0,	-0.1],
				[-165.0,	-0.785],
				[-45.0,		-1.05],
				[-30.0,		-0.785],
				[-15.0,		-0.4],
				[-5.0,		-0.2],
				[0.0,			0.0],
				[5.0,			0.2],
				[15.0,		0.4],
				[30.0,		0.785],
				[45.0,		1.05],
				[165.0,		0.785],
				[180.0,		0.1]
			],
			fdm_node.getNode(
				"systems/coursesystem/modes/convoy/course-diff-corr-deg").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/alt-m").setValue(
		#part for far targets
		interpol.sqr_inter(
			[
				[0.0,		1.8,			1.9, 			2.0],
				[200.0,	0.0,			0.0,			0.0],
				[400.0,	11000.0,	12000.0,	15000.0]
			],
			fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue(),
			fdm_node.getNode("systems/pitot/mach").getValue()
		)+
		#part for closer targets
		(
			fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()-
			fdm_node.getNode("systems/coursesystem/set/x-distance-m").getValue()*
				math.sin(fdm_node.getNode("systems/coursesystem/set/a-angle-rad").getValue())
		)*
		interpol.lin_inter(
			[
				[200.0,	1.0],
				[400.0,	0.0]
			],
			fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
		)
	);

		#vertical speed difference

	fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-m-sec").setValue(
		(		
			fdm_node.getNode("systems/vertspeedometer/v-down-ms").getValue()*
			(-1)
		)+
		(
			(
				fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()-
				fdm_node.getNode("systems/coursesystem/modes/convoy/alt-m").getValue()
			)*
			0.025*
			interpol.lin_inter(
				[
					[300.0,	0.0],
					[600.0,	1.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)+
		(
			interpol.lin_inter(
				[
					[300.0,	-10.0],
					[600.0,	0.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)
	);

		#vertical acceleration

	fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-acc").setValue(
		fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-acc").getValue()
		+(
			-fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-acc").getValue()
			+
			(
				fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-m-sec").getValue()
				-fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-prev").getValue()
			)
			/(tick_sec+0.00001)
		)*0.5
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-prev").setValue(
		fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-m-sec").getValue()
	);

		#elevator input

	fdm_node.getNode("systems/coursesystem/modes/convoy/elevator-inp").setValue(
		fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-m-sec").getValue()
		+4*fdm_node.getNode("systems/coursesystem/modes/convoy/v-speed-diff-acc").getValue()
	);

		#elevator increment

	fdm_node.getNode("systems/coursesystem/modes/convoy/elevator-inc").setValue(
		interpol.sps_inter(
			[
				[
					[500.0,		-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.1,		0.1,		0.1,		0.0,		-0.1],
					[-10.0,		0.1,		0.02,		0.02,		0.0,		-0.1],
					[0.0,			0.1,		0.0,		0.0,		0.0,		-0.1],
					[10.0,		0.1,		0.0,		-0.02,	-0.02,	-0.1],
					[100.0,		0.1,		0.0,		-0.1,		-0.1,		-0.1]
				],
				[
					[2000.0,	-0.261,		-0.174,	0.0,			0.261,		0.349],
					[-100.0,	0.005,		0.005,	0.005,		0.0,			-0.005],
					[-10.0,		0.005,		0.0025,	0.0025,		0.0,			-0.005],
					[0.0,			0.005,		0.0,		0.0,			0.0,			-0.005],
					[10.0,		0.005,		0.0,		-0.0025,	-0.0025,	-0.005],
					[100.0,		0.005,		0.0,		-0.005,		-0.005,		-0.005]				
				]
			],
			fdm_node.getNode("systems/pitot/qbar-psf").getValue(),		
			fdm_node.getNode("systems/coursesystem/modes/convoy/elevator-inp").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/dist-diff-m").setValue(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()-
			fdm_node.getNode("systems/coursesystem/set/x-distance-m").getValue()
	);

		#speed difference

	fdm_node.getNode("systems/coursesystem/modes/convoy/fast-intercept-mach").setValue(
		(
			(
				fdm_node.getNode("systems/infoline/lock/airspeed-kmh").getValue()*
				0.2777
			)/
			interpol.lin_inter(
				[
					[0.0,			340.29],
					[100.0,		339.91],
					[1000.0,	336.43],
					[5000.0,	320.54],
					[10000.0,	299.53],
					[20000.0,	295.07]
				],
				fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()
			)
		)+
		interpol.lin_inter(
			[
				[-100.0,	-0.1],
				[0.0,			0.0],
				[5000.0,	0.25],
				[20000.0,	1.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/convoy/dist-diff-m").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/pids/convoy-speed-smooth-input").setValue(
			fdm_node.getNode("systems/coursesystem/modes/convoy/fast-intercept-mach").getValue()-
			fdm_node.getNode("systems/coursesystem/pids/convoy-speed-smooth-pos").getValue()
	);

		#rough itegrator for smoothing target speed jumps
		#caused by mp lags

	speed_smooth=
		fdm_node.getNode("systems/coursesystem/pids/convoy-speed-smooth-pos").getValue()+
		fdm_node.getNode("systems/coursesystem/pids/convoy-speed-smooth-input").getValue()*
		0.2*
		tick_sec;
	fdm_node.getNode("systems/coursesystem/pids/convoy-speed-smooth-pos").setValue(speed_smooth);

	fdm_node.getNode("systems/coursesystem/modes/convoy/speed-kmh").setValue(
		(
			interpol.lin_inter(
				[
					[0.0,			1.25],
					[5000.0,	1.4],
					[7500.0,	1.5],
					[12000.0,	1.9],
					[15000.0,	2.0]
				],
				fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()
			)*
			fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()+
			fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()*
			interpol.sps_inter(
				[
					[
						[0.1,				0.0,	1.25,	1.4,	1.5,	1.6,	2.0],
						[0.0,				0.0,	1.25,	1.25,	1.25,	1.25,	1.25],
						[5000.0,		0.0,	1.25,	1.4,	1.4,	1.4,	1.4],
						[7500.0,		0.0,	1.25,	1.4,	1.5,	1.5,	1.5],
						[12000.0,		0.0,	1.25,	1.4,	1.5,	1.6,	1.9],
						[15000.0,		0.0,	1.25,	1.4,	1.5,	1.6,	2.0]
					],
					[
						[0.4,			0.0,	1.25,	1.4,	1.5,	1.6,	2.0],
						[0.0,			0.0,	1.25,	1.25,	1.25,	1.25,	1.25],
						[5000.0,	0.0,	1.25,	1.4,	1.4,	1.4,	1.4],
						[7500.0,	0.0,	1.25,	1.4,	1.5,	1.5,	1.5],
						[12000.0,	1.6,	1.6,	1.6,	1.6,	1.6,	1.9],
						[15000.0,	1.6,	1.6,	1.6,	1.6,	1.6,	2.0]
					]
				],
				fdm_node.getNode("systems/coursesystem/calc/intake-med-pos").getValue(),
				fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue(),
				fdm_node.getNode("systems/coursesystem/pids/convoy-speed-smooth-pos").getValue()
			)
		)*1191
	);

	fdm_node.getNode("systems/coursesystem/modes/convoy/speed-diff-mach").setValue(
		fdm_node.getNode("systems/coursesystem/modes/convoy/speed-kmh").getValue()/1191-
		fdm_node.getNode("systems/pitot/mach").getValue()
	);

		#engine

	fdm_node.getNode("systems/coursesystem/modes/convoy/engine").setValue(
		interpol.sqr_inter(
			[
				[0.0,			0.84,		0.85,		1.0],
				[-0.075,	0.21,		0.21,		0.21],
				[-0.07,		0.25,		0.85,		0.85],
				[-0.005,	0.84,		0.95,		0.95],
				[0.0,			1.0,		1.0,		1.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/convoy/speed-diff-mach").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/convoy/engine").getValue()
		)
	);

		#speedbrake

	fdm_node.getNode("systems/coursesystem/modes/convoy/speedbrake").setValue(
		interpol.lin_inter(
				[
					[-0.1,		1.0],
					[-0.075,	0.0],
					[0.0,			0.0]
				],
			fdm_node.getNode("systems/coursesystem/modes/convoy/speed-diff-mach").getValue()
		)
	);

	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{

	#Intercepting

	#Head to head

	fdm_node.getNode("systems/coursesystem/modes/intercept/plus-lon-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)*
			(
				fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.0],
						[50.0,		0.0],
						[100.0,		1.0],
						[200.0,		1.0],
						[400.0,		1.0]
					],
					fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
				)+
				fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.25],
						[50.0,		0.25],
						[100.0,		0.25]
					],
					fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
				)
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/plus-lat-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)*
			(
				fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.0],
						[50.0,		0.0],
						[100.0,		1.0],
						[200.0,		1.0],
						[400.0,		1.0]
					],
					fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
				)+
				fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.25],
						[50.0,		0.25],
						[100.0,		0.25]
					],
					fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
				)
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/plus-course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/intercept/plus-lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/intercept/plus-lat-m").getValue()
		)*
		57.2957795
	);

	#Head to tail

	fdm_node.getNode("systems/coursesystem/modes/intercept/minus-lon-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)*
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			(
				interpol.lin_inter(
					[
						[50.0,		0.0],
						[500.0,		0.5],
						[1000.0,	0.25]
					],
					fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
				)
			)+
			math.sin(
					fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").getValue()/
				57.2957795
			)*
			(
				fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
				(
					interpol.lin_inter(
						[
							[50.0,		0.0],
							[100.0,		0.75],
							[500.0,		0.5]
						],
						fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
					)
				)
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/minus-lat-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)*
			fdm_node.getNode("systems/coursesystem/calc/awaited-shift-m").getValue()*
			(
				interpol.lin_inter(
					[
						[50.0,		0.0],
						[500.0,		0.5],
						[1000.0,	0.25]
					],
					fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
				)
			)+
			math.cos(
					fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").getValue()/
				57.2957795
			)*
			(
				fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
				(
					interpol.lin_inter(
						[
							[50.0,		0.0],
							[100.0,		0.75],
							[500.0,		0.5]
						],
						fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
					)
				)
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/minus-course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/intercept/minus-lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/intercept/minus-lat-m").getValue()
		)*
		57.2957795
	);

	if (
		(fdm_node.getNode("systems/coursesystem/calc/contrary-corr-deg").getValue()<=(-90)) or
		(fdm_node.getNode("systems/coursesystem/calc/contrary-corr-deg").getValue()>=90)
	)
	{
		fdm_node.getNode("systems/coursesystem/modes/intercept/course-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/plus-course-deg").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/intercept/course-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/minus-course-deg").getValue()
		);
	}

	corr_deg=fdm_node.getNode(
		"systems/coursesystem/modes/intercept/course-deg").getValue();
	if (corr_deg<-180)
	{
		corr_deg=corr_deg+360;
	}
	if (corr_deg>180)
	{
		corr_deg=corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/intercept/course-corr-deg").setValue(corr_deg);

	corr_deg=fdm_node.getNode(
		"systems/coursesystem/modes/intercept/course-deg").getValue();
	if (corr_deg<-180)
	{
		corr_deg=corr_deg+360;
	}
	if (corr_deg>180)
	{
		corr_deg=corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/intercept/course-corr-deg").setValue(corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/intercept/course-diff-deg").setValue(
		fdm_node.getNode("systems/coursesystem/modes/intercept/course-corr-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()
	);

	course_diff_corr_deg=fdm_node.getNode("systems/coursesystem/modes/intercept/course-diff-deg").getValue();
	if (course_diff_corr_deg<-180)
	{
		course_diff_corr_deg=course_diff_corr_deg+360;
	}
	if (course_diff_corr_deg>180)
	{
		course_diff_corr_deg=course_diff_corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/intercept/course-diff-corr-deg").setValue(course_diff_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/intercept/ailerons-rad").setValue(
		interpol.lin_inter(
			[
				[-180.0,	-0.1],
				[-165.0,	-0.785],
				[-45.0,		-1.05],
				[-30.0,		-1.05],
				[-15.0,		-0.785],
				[-5.0,		-0.4],
				[0.0,			0.0],
				[5.0,			0.4],
				[15.0,		0.785],
				[30.0,		1.05],
				[45.0,		1.05],
				[165.0,		0.785],
				[180.0,		0.1]
			],
			fdm_node.getNode(
				"systems/coursesystem/modes/intercept/course-diff-corr-deg").getValue()
		)
	);

	if	(
		(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
	)
	{
		if (fdm_node.getNode("systems/arthorizon/roll-indicated-deg").getValue()>0)
		{
			fdm_node.getNode("systems/coursesystem/modes/intercept/left-or-right").setValue(0);
		}
		else
		{
			fdm_node.getNode("systems/coursesystem/modes/intercept/left-or-right").setValue(1);
		}
	}

	fdm_node.getNode("systems/coursesystem/modes/intercept/aside-ailerons-rad").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,			1.0],
				[0.0,	-1.228,		1.228],
				[0.5,	-1.228,		1.228],
				[0.6,		0.0,			0.0],
				[1.0,		0.0,			0.0]
			],
			fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/intercept/left-or-right").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/alt-calc-m").setValue(
		#part for far targets
		interpol.sqr_inter(
			[
				[0.0,		1.8,			1.9, 			2.0],
				[200.0,	0.0,			0.0,			0.0],
				[400.0,	11000.0,	12000.0,	18000.0]
			],
			fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue(),
			fdm_node.getNode("systems/pitot/mach").getValue()
		)+
		#part for closer low targets
		(
			fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()-
			interpol.lin_inter(
				[
					[0.0,				0.0],
					[12000.0,		12000.0]
				],
				fdm_node.getNode("systems/infoline/lock/distance-m").getValue()
			)*
			math.sin(fdm_node.getNode("systems/coursesystem/set/a-angle-rad").getValue())
		)*
		interpol.sqr_inter(
			[
				[0.0,			200.0,	400.0],
				[11000.0,	1.0,		0.0],
				[12000.0,	0.0, 		0.0]
			],
			fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue(),
			fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
		)+
		#part for closer high targets
		(
			(
				interpol.sps_inter(
					[
						#speedup shell part for high alitude targets
						[
							[1.8,			0.0,	12000.0,	18000.0],
							[0.0,			0.0,	12000.0,	12000.0],
							[12000.0,	0.0,	12000.0,	12000.0],
							[18000.0,	0.0,	12000.0,	12000.0]
						],
						#keeping altitude part for high alitude targets
						[
							[1.9,			0.0,	12000.0,	18000.0],
							[0.0,			0.0,	12000.0,	12000.0],
							[12000.0,	0.0,	12000.0,	12000.0],
							[18000.0,	0.0,	18000.0,	18000.0]
						],
						#gettig up to dynamic shell part for high alitude targets
						[
							[2.0,			0.0, 	12000.0,	18000.0],
							[0.0,			0.0,	12000.0,	18000.0],
							[12000.0,	0.0,	12000.0,	18000.0],
							[18000.0,	0.0,	12000.0,	18000.0]
						],
					],
					fdm_node.getNode("systems/pitot/mach").getValue(),
					fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue(),
					fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()
				)
			)*
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[95.0,	0.0],
					[100.0,	1.0]
				],
				fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
			)+
			#hop part for high alitude targets
			fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()*
			interpol.lin_inter(
				[
					[0.0,		1.0],
					[95.0,	1.0],
					[100.0,	0.0]
				],
				fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
			)
		)*
		interpol.sqr_inter(
			[
				[0.0,			200.0,	400.0],
				[11000.0,	0.0,		0.0],
				[12000.0,	1.0, 		0.0]
			],
			fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue(),
			fdm_node.getNode("systems/coursesystem/calc/reach-time-sec").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/alt-m").setValue(
		#interception part
		interpol.sqr_inter(
			[
				[0.0,			0.0,		1.0],
				[0.0,			0.0,		450.0],
				[450.0,		0.0,		450.0],
				[30000.0,	0.0,		30000.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/intercept/alt-calc-m").getValue(),
			fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()
		)+
		#turnaway part
		fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()*
		interpol.lin_inter(
			[
				[0.0,	1.0],
				[1.0,	0.0]
			],
			fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()
		)
	);

		#vertical speed difference

	fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-m-sec").setValue(
		(		
			fdm_node.getNode("systems/vertspeedometer/v-down-ms").getValue()*
			(-1)
		)+
		(
			(
				fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()-
				fdm_node.getNode("systems/coursesystem/modes/intercept/alt-m").getValue()
			)*
			interpol.lin_inter(
				[
					[0.0,			0.025],
					[18000.0,	0.025],
					[20000.0,	0.05],
					[25000.0,	0.1]
				],
				fdm_node.getNode("systems/coursesystem/modes/intercept/alt-m").getValue()
			)*
			interpol.lin_inter(
				[
					[300.0,	0.0],
					[600.0,	1.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)+
		(
			interpol.lin_inter(
				[
					[300.0,	-10.0],
					[600.0,	0.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)
	);

		#vertical acceleration

	fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-acc").setValue(
		fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-acc").getValue()
		+(
			-fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-acc").getValue()
			+
			(
				fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-m-sec").getValue()
				-fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-prev").getValue()
			)
			/(tick_sec+0.00001)
		)*0.5
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-prev").setValue(
		fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-m-sec").getValue()
	);

		#elevator input

	fdm_node.getNode("systems/coursesystem/modes/intercept/elevator-inp").setValue(
		fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-m-sec").getValue()
		+4*fdm_node.getNode("systems/coursesystem/modes/intercept/v-speed-diff-acc").getValue()
	);

		#elevator increment

	fdm_node.getNode("systems/coursesystem/modes/intercept/elevator-inc").setValue(
		interpol.sps_inter(
			[
				[
					[500.0,		-0.261,	-0.174,	0.0,		0.526,	0.614],
					[-100.0,	0.1,		0.1,		0.1,		0.0,		-0.1],
					[-10.0,		0.1,		0.01,		0.01,		0.0,		-0.1],
					[0.0,			0.1,		0.0,		0.0,		0.0,		-0.1],
					[10.0,		0.1,		0.0,		-0.01,	-0.01,	-0.1],
					[100.0,		0.1,		0.0,		-0.1,		-0.1,		-0.1]
				],
				[
					[2000.0,	-0.261,	-0.174,	0.0,		0.526,	0.614],
					[-100.0,	0.01,		0.01,		0.01,		0.0,		-0.01],
					[-10.0,		0.01,		0.005,	0.005,	0.0,		-0.01],
					[0.0,			0.01,		0.0,		0.0,		0.0,		-0.01],
					[10.0,		0.01,		0.0,		-0.005,	-0.005,	-0.01],
					[100.0,		0.01,		0.0,		-0.01,	-0.01,	-0.01]				
				]
			],
			fdm_node.getNode("systems/pitot/qbar-psf").getValue(),		
			fdm_node.getNode("systems/coursesystem/modes/intercept/elevator-inp").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)
	);

		#speed

	fdm_node.getNode("systems/coursesystem/modes/intercept/speed-kmh").setValue(
		interpol.lin_inter(
			[
				[0.0,			1.4],
				[5000.0,	1.4],
				[7500.0,	1.5],
				[12000.0,	1.9],
				[15000.0,	2.0],
				[18000.0,	2.0]
			],
			fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()
		)*1191
	);

	fdm_node.getNode("systems/coursesystem/modes/intercept/speed-diff-mach").setValue(
		fdm_node.getNode("systems/coursesystem/modes/intercept/speed-kmh").getValue()/1191-
		fdm_node.getNode("systems/pitot/mach").getValue()
	);

		#engine

	fdm_node.getNode("systems/coursesystem/modes/intercept/engine").setValue(
		interpol.sqr_inter(
			[
				[0.0,			0.84,		0.85,		1.0],
				[-0.075,	0.21,		0.21,		0.21],
				[-0.07,		0.25,		0.85,		0.85],
				[-0.005,	0.84,		0.95,		0.95],
				[0.0,			1.0,		1.0,		1.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/intercept/speed-diff-mach").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/intercept/engine").getValue()
		)
	);

		#speedbrake

	fdm_node.getNode("systems/coursesystem/modes/intercept/speedbrake").setValue(
		interpol.lin_inter(
				[
					[-0.1,		1.0],
					[-0.075,	0.0],
					[0.0,			0.0]
				],
			fdm_node.getNode("systems/coursesystem/modes/intercept/speed-diff-mach").getValue()
		)
	);

	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{

	#Glissade

	fdm_node.getNode("systems/coursesystem/modes/gliss/one-lon-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			1.25*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/set/glissade-d-one-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/one-lat-m").setValue(
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			1.25*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/coursesystem/set/glissade-d-one-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/one-dist-m").setValue(
		math.pow(
			(
				math.pow(fdm_node.getNode("systems/coursesystem/modes/gliss/one-lon-m").getValue(), 2)+
				math.pow(fdm_node.getNode("systems/coursesystem/modes/gliss/one-lat-m").getValue(), 2)
			), 0.5
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-lat-m").getValue()
		)*
		57.2957795
	);

	course_corr_deg=fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-deg").getValue();
	if (course_corr_deg<-180)
	{
		course_corr_deg=course_corr_deg+360;
	}
	if (course_corr_deg>180)
	{
		course_corr_deg=course_corr_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-corr-deg").setValue(course_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-diff-deg").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-corr-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()
	);

	course_diff_corr_deg=fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-diff-deg").getValue();
	if (course_diff_corr_deg<-180)
	{
		course_diff_corr_deg=course_diff_corr_deg+360;
	}
	if (course_diff_corr_deg>180)
	{
		course_diff_corr_deg=course_diff_corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/gliss/one-course-diff-corr-deg").setValue(course_diff_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-diff-abs-deg").setValue(
		abs(course_diff_corr_deg));

	fdm_node.getNode("systems/coursesystem/modes/gliss/fin-lon-m").setValue(
		(
			fdm_node.getNode("systems/coursesystem/set/runway-length-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.sin(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/fin-lat-m").setValue(
		(
			fdm_node.getNode("systems/coursesystem/set/runway-length-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/heading-deg").getValue()/
				57.2957795
			)
		)+
		(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()*
			math.cos(
				fdm_node.getNode("systems/infoline/lock/course-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").setValue(
		math.pow(
			(
				math.pow(
					fdm_node.getNode("systems/coursesystem/modes/gliss/fin-lon-m").getValue(), 
				2)+
				math.pow(
					fdm_node.getNode("systems/coursesystem/modes/gliss/fin-lat-m").getValue(), 
				2)
			), 0.5
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/two-lon-m").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/fin-lon-m").getValue()+
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").getValue()*
			0.8*
			math.sin(
				fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/two-lat-m").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/fin-lat-m").getValue()+
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").getValue()*
			0.8*
			math.cos(
				fdm_node.getNode("systems/coursesystem/calc/heading-inv-corr-deg").getValue()/
				57.2957795
			)
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/two-course-deg").setValue(
		math.atan2(
			fdm_node.getNode("systems/coursesystem/modes/gliss/two-lon-m").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/gliss/two-lat-m").getValue()
		)*
		57.2957795
	);

	if	(
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/modes/gliss/course-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-deg").getValue()
		);
		fdm_node.getNode("systems/coursesystem/modes/gliss/dist-m").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-dist-m").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/gliss/course-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/two-course-deg").getValue()
		);
		fdm_node.getNode("systems/coursesystem/modes/gliss/dist-m").setValue(
			fdm_node.getNode("systems/infoline/lock/distance-m").getValue()
		);
	}

	course_corr_deg=fdm_node.getNode("systems/coursesystem/modes/gliss/course-deg").getValue();
	if (course_corr_deg<-180)
	{
		course_corr_deg=course_corr_deg+360;
	}
	if (course_corr_deg>180)
	{
		course_corr_deg=course_corr_deg-360;
	}
	fdm_node.getNode("systems/coursesystem/modes/gliss/course-corr-deg").setValue(course_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/gliss/course-diff-deg").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/course-corr-deg").getValue()-
		fdm_node.getNode("systems/gyrocompass/heading-indicated-deg").getValue()
	);

	course_diff_corr_deg=fdm_node.getNode("systems/coursesystem/modes/gliss/course-diff-deg").getValue();
	if (course_diff_corr_deg<-180)
	{
		course_diff_corr_deg=course_diff_corr_deg+360;
	}
	if (course_diff_corr_deg>180)
	{
		course_diff_corr_deg=course_diff_corr_deg-360;
	}
	fdm_node.getNode(
		"systems/coursesystem/modes/gliss/course-diff-corr-deg").setValue(course_diff_corr_deg);

	fdm_node.getNode("systems/coursesystem/modes/gliss/ailerons-rad").setValue(
		interpol.lin_inter(
			[
				[-180.0,	-0.1],
				[-165.0,	-0.785],
				[-45.0,	-0.785],
				[-15.0,	-0.5],
				[-2.0,	-0.25],
				[0.0,	0.0],
				[2.0,	0.25],
				[15.0,	0.5],
				[45.0,	0.785],
				[165.0,	0.785],
				[180.0,	0.1]
			],
		fdm_node.getNode("systems/coursesystem/modes/gliss/course-diff-corr-deg").getValue()
		)*
		interpol.lin_inter(
			[
				[0.3,		0.75],
				[0.5,		1.0],
				[1.0,		1.0]
			],
			fdm_node.getNode("systems/pitot/mach").getValue()
		)
	);

		#awaited altitude

	fdm_node.getNode("systems/coursesystem/modes/gliss/alt-m").setValue(
		interpol.sqr_inter(
			[
				[0.0,			0.0,		1.0],
				[2000.0,	2000.0,	0.0],
				[3000.0,	2000.0,	40.0],
				[10000.0,	2000.0,	475.0],
				[30000.0,	2000.0,	2000.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").getValue(),
			fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()
		)
	);

		#needed and real altitudes difference

	fdm_node.getNode("systems/coursesystem/modes/gliss/alt-diff-m").setValue(
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/alt-m").getValue()-
			(
				fdm_node.getNode("position/h-sl-ft").getValue()*0.3048-
				fdm_node.getNode("systems/infoline/lock/altitude-sl-m").getValue()
			)
		)*
		interpol.sqr_inter(
			[
				[0.0,			300.0,	600.0],
				[2000.0,	1.0,		1.0],
				[7000.0,	1.0,		1.0],
				[12000.0,	0.0,		1.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").getValue(),
			fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
		)+
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/alt-m").getValue()-
			fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
		)*
		interpol.sqr_inter(
			[
				[0.0,			300.0,	600.0],
				[2000.0,	0.0,		0.0],
				[7000.0,	0.0,		0.0],
				[12000.0,	1.0,		0.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").getValue(),
			fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-m-sec").setValue(
#wanted vertical speed
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/alt-diff-m").getValue()
			*interpol.lin_inter(
				[
					[15.0,		0.0],
					[30.0,		-0.2],
					[100.0,		-0.2],
					[300.0,		-0.2],
					[600.0,		-0.1]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)
#vertical spedoometer vertical speed, high
		+(		
			fdm_node.getNode("systems/vertspeedometer/v-down-ms").getValue()*
			-1.0
		)
#part for wanted vertical speed, very low
		+interpol.lin_inter(
			[
				[0.0,			0.0],
				[15.0,		1.0],
				[30.0,		0.0]
			],
			fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
		)
	);

		#vertical acceleration

	fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-acc").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-acc").getValue()
		+(
			-fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-acc").getValue()
			+
			(
				fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-m-sec").getValue()
				-fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-prev").getValue()
			)
			/(tick_sec+0.00001)
		)*0.5
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-prev").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-m-sec").getValue()
	);

		#elevator input

	fdm_node.getNode("systems/coursesystem/modes/gliss/elevator-inp").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-m-sec").getValue()
		+4*fdm_node.getNode("systems/coursesystem/modes/gliss/v-speed-diff-acc").getValue()
	);

		#elevator increment

	fdm_node.getNode("systems/coursesystem/modes/gliss/elevator-inc").setValue(
		interpol.sps_inter(
			[
				[
					[500.0,		-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.1,		0.1,		0.1,		0.0,		-0.1],
					[-10.0,		0.1,		0.01,		0.01,		0.0,		-0.1],
					[0.0,			0.1,		0.0,		0.0,		0.0,		-0.1],
					[10.0,		0.1,		0.0,		-0.01,	-0.01,	-0.1],
					[100.0,		0.1,		0.0,		-0.1,		-0.1,		-0.1]
				],
				[
					[2000.0,	-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.01,		0.01,		0.01,		0.0,		-0.01],
					[-10.0,		0.01,		0.005,	0.005,	0.0,		-0.01],
					[0.0,			0.01,		0.0,		0.0,		0.0,		-0.01],
					[10.0,		0.01,		0.0,		-0.005,	-0.005,	-0.01],
					[100.0,		0.01,		0.0,		-0.01,	-0.01,	-0.01]				
				]
			],
			fdm_node.getNode("systems/pitot/qbar-psf").getValue(),		
			fdm_node.getNode("systems/coursesystem/modes/gliss/elevator-inp").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)*
		interpol.sqr_inter(
			[
				[0.0,	0.0, 1.0],
				[0.0,	1.0, 0.0],
				[1.0,	0.0, 0.0]
			],
			fdm_node.getNode("gear/unit[1]/WOW").getValue(),
 			fdm_node.getNode("gear/unit[2]/WOW").getValue()
		)*
		interpol.lin_inter(
			[
				[0.0,		0.0],
				[5.0,		0.0],
				[10.0,	1.0],
			],
			fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
		)+
		interpol.sqr_inter(
			[
				[0.0,		-0.001,	0.000,	0.001],
				[0.0,		0.1,		0.0,		-0.01],
				[5.0,		0.1,		0.0,		-0.01],
				[10.0,	0.0,		0.0,		0.0]
			],
			fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)
	);

		#speed

	fdm_node.getNode("systems/coursesystem/modes/gliss/speed-kmh").setValue(
		interpol.sps_inter(
			[
				[
					[8000.0,	1750.0,	2000.0,	10000.0,	20000.0,	30000.0],
					[0.0,			0.8,		0.8,		0.8,			0.8,			0.8],
					[1.0,			0.0,		0.275,		0.275,	0.36,			0.55]
				],
				[
					[10000.0,	1750.0,	2000.0,	10000.0,	20000.0,	30000.0],
					[0.0,			1.6,		1.6, 		1.6,			1.6,			1.6],
					[1.0,			1.6,		1.6,		1.6,			1.6,			1.6]
				],
				[
					[18000.0,	1750.0,	2000.0,	10000.0,	20000.0,	30000.0],
					[0.0,			2.0,		2.0,		2.0,			2.0,			2.0],
					[1.0,			2.0,		2.0,		2.0,			2.0,			2.0]
				]
			],
			fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue(),		
			fdm_node.getNode("systems/coursesystem/state/mode-two").getValue(),
			fdm_node.getNode("systems/coursesystem/modes/gliss/fin-dist-m").getValue()
		)*1191
	);

	fdm_node.getNode("systems/coursesystem/modes/gliss/speed-diff-mach").setValue(
		fdm_node.getNode("systems/coursesystem/modes/gliss/speed-kmh").getValue()/1191-
		fdm_node.getNode("systems/pitot/mach").getValue()
	);

		#engine

	fdm_node.getNode("systems/coursesystem/modes/gliss/engine").setValue(
		interpol.sps_inter(
			[
				[
					[0.0,		0.0,		1.0],
					[0.0,		0.21,		0.21],
					[1.0,		0.21,		0.1]
				],
				[
					[0.025,	0.0,	1.0],
					[0.0,		0.84,	0.84],
					[1.0,		0.84,	0.84]
				]
			],
			fdm_node.getNode("systems/coursesystem/modes/gliss/speed-diff-mach").getValue(),
			fdm_node.getNode("gear/unit[1]/WOW").getValue(),
 			fdm_node.getNode("gear/unit[2]/WOW").getValue()
		)
	);

		#speedbrake

	fdm_node.getNode("systems/coursesystem/modes/gliss/speedbrake").setValue(
		interpol.sqr_inter(
			[
				[0.0,			0.4,	0.45],
				[-0.01,		1.0,	1.0],
				[-0.005,	1.0,	0.5],
				[0.0,			0.0,	0.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/gliss/speed-diff-mach").getValue(),
			fdm_node.getNode("systems/pitot/mach").getValue()
		)
	);

	}

	if	(
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6)
	)
	{

	#Leveling

		#vertical speed difference

	fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-m-sec").setValue(
		(		
			fdm_node.getNode("systems/vertspeedometer/v-down-ms").getValue()*
			interpol.lin_inter(
				[
					[300.0,	0.0],
					[600.0,	-1.0]
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)+
		(
			fdm_node.getNode("systems/radioaltimeter/vert-speed-m-s").getValue()*
			interpol.lin_inter(
				[
					[300.0,	1.0],
					[600.0,	0.0],
				],
				fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()
			)
		)
	);

		#vertical acceleration

	fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-acc").setValue(
		fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-acc").getValue()
		+(
			-fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-acc").getValue()
			+
			(
				fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-m-sec").getValue()
				-fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-prev").getValue()
			)
			/(tick_sec+0.00001)
		)*0.5
	);

	fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-prev").setValue(
		fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-m-sec").getValue()
	);

		#elevator input

	fdm_node.getNode("systems/coursesystem/modes/level/elevator-inp").setValue(
		fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-m-sec").getValue()
		+4*fdm_node.getNode("systems/coursesystem/modes/level/v-speed-diff-acc").getValue()
	);

		#elevator increment

	fdm_node.getNode("systems/coursesystem/modes/level/elevator-inc").setValue(
		interpol.sps_inter(
			[
				[
					[500.0,		-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.1,		0.1,		0.1,		0.0,		-0.1],
					[-10.0,		0.1,		0.02,		0.02,		0.0,		-0.1],
					[0.0,			0.1,		0.0,		0.0,		0.0,		-0.1],
					[10.0,		0.1,		0.0,		-0.02,	-0.02,	-0.1],
					[100.0,		0.1,		0.0,		-0.1,		-0.1,		-0.1]
				],
				[
					[2000.0,	-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.01,		0.01,		0.01,		0.0,		-0.01],
					[-10.0,		0.01,		0.002,	0.002,	0.0,		-0.01],
					[0.0,			0.01,		0.0,		0.0,		0.0,		-0.01],
					[10.0,		0.01,		0.0,		-0.002,	-0.002,	-0.01],
					[100.0,		0.01,		0.0,		-0.01,	-0.01,	-0.01]				
				]
			],
			fdm_node.getNode("systems/pitot/qbar-psf").getValue(),		
			fdm_node.getNode("systems/coursesystem/modes/level/elevator-inp").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)
	);

	#Hopping

	fdm_node.getNode("systems/coursesystem/modes/hop/alt-m").setValue(
		fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()*
		2*
		fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()+
		10000*
		fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()
	);

		#vertical speed difference

	fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-m-sec").setValue(
		(		
			fdm_node.getNode("systems/vertspeedometer/v-down-ms").getValue()*
			(-1)
		)+
		(
			(
				fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()-
				fdm_node.getNode("systems/coursesystem/modes/hop/alt-m").getValue()
			)*
			interpol.lin_inter(
				[
					[-0.785,	0.25],
					[0.0,			0.05],
					[0.785,		0.25]
				],
				fdm_node.getNode("systems/arthorizon/roll-indicated-rad").getValue()
			)
		)
	);

		#vertical acceleration

	fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-acc").setValue(
		fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-acc").getValue()
		+(
			-fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-acc").getValue()
			+
			(
				fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-m-sec").getValue()
				-fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-prev").getValue()
			)
			/(tick_sec+0.00001)
		)*0.5
	);

	fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-prev").setValue(
		fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-m-sec").getValue()
	);

		#elevator input

	fdm_node.getNode("systems/coursesystem/modes/hop/elevator-inp").setValue(
		fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-m-sec").getValue()
		+4*fdm_node.getNode("systems/coursesystem/modes/hop/v-speed-diff-acc").getValue()
	);

		#elevator increment

	fdm_node.getNode("systems/coursesystem/modes/hop/elevator-inc").setValue(
		interpol.sps_inter(
			[
				[
					[500.0,		-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.1,		0.1,		0.1,		0.0,		-0.1],
					[-10.0,		0.1,		0.02,		0.02,		0.0,		-0.1],
					[0.0,			0.1,		0.0,		0.0,		0.0,		-0.1],
					[10.0,		0.1,		0.0,		-0.02,	-0.02,	-0.1],
					[100.0,		0.1,		0.0,		-0.1,		-0.1,		-0.1]
				],
				[
					[2000.0,	-0.261,	-0.174,	0.0,		0.261,	0.349],
					[-100.0,	0.01,		0.01,		0.01,		0.0,		-0.01],
					[-10.0,		0.01,		0.005,	0.005,	0.0,		-0.01],
					[0.0,			0.01,		0.0,		0.0,		0.0,		-0.01],
					[10.0,		0.01,		0.0,		-0.005,	-0.005,	-0.01],
					[100.0,		0.01,		0.0,		-0.01,	-0.01,	-0.01]				
				]
			],
			fdm_node.getNode("systems/pitot/qbar-psf").getValue(),		
			fdm_node.getNode("systems/coursesystem/modes/hop/elevator-inp").getValue(),
			fdm_node.getNode("systems/arthorizon/pitch-indicated-rad").getValue()
		)
	);

		#speed difference

	fdm_node.getNode("systems/coursesystem/modes/hop/speed-diff-mach").setValue(
		interpol.lin_inter(
			[
				[0.0,			0.8],
				[5000.0,	1.0],
				[10000.0,	2.0],
				[18000.0,	2.0]
			],
			fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue(),
		)-
		fdm_node.getNode("systems/pitot/mach").getValue()
	);

		#engine

	fdm_node.getNode("systems/coursesystem/modes/hop/engine").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,		5000.0,	10000.0],
				[0.0,		0.21,		0.21,		0.21],
				[0.05,	0.84,		0.84,		1.0]
			],
			fdm_node.getNode("systems/coursesystem/modes/hop/speed-diff-mach").getValue(),
			fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()
		)
	);

		#speedbrake

	fdm_node.getNode("systems/coursesystem/modes/hop/speedbrake").setValue(
		interpol.lin_inter(
				[
					[-0.2,		1.0],
					[-0.1,		0.0],
					[0.0,			0.0]
				],
			fdm_node.getNode("systems/coursesystem/modes/hop/speed-diff-mach").getValue()
		)
	);

	}

	#Timers

	#retract
	
	if (fdm_node.getNode("systems/coursesystem/timers/retract-pos").getValue()==1.0)
	{
		fdm_node.getNode("systems/coursesystem/timers/retract-input").setValue(0);
	}
	if (
		(
			(fdm_node.getNode("systems/coursesystem/timers/retract-input").getValue()==1) and
 			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
		) and
		(
			(fdm_node.getNode("gear/unit[1]/WOW").getValue()==1) or
 			(fdm_node.getNode("gear/unit[2]/WOW").getValue()==1) 
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/timers/retract-input").setValue(0);
	}
	if (
		(
			(fdm_node.getNode("systems/coursesystem/timers/retract-input").getValue()==0) and
 			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
			(fdm_node.getNode("gear/unit[1]/WOW").getValue()==0) and
 			(fdm_node.getNode("gear/unit[2]/WOW").getValue()==0) 
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/timers/retract-input").setValue(1);
	}

	retract_pos=fdm_node.getNode("systems/coursesystem/timers/retract-pos").getValue();
	if	(
		(retract_pos>0) and
		(fdm_node.getNode("systems/coursesystem/timers/retract-input").getValue()==0)
	)
	{
		retract_pos=retract_pos-tick_sec;
	}
	if	(
		(retract_pos<1) and
		(fdm_node.getNode("systems/coursesystem/timers/retract-input").getValue()==1)
	)
	{
		retract_pos=retract_pos+tick_sec*0.5;
	}
	if	(retract_pos<0)
	{
		retract_pos=0;
	}
	if	(retract_pos>1)
	{
		retract_pos=1;
	}
	fdm_node.getNode("systems/coursesystem/timers/retract-pos").setValue(retract_pos);

	if (
		(fdm_node.getNode("systems/coursesystem/timers/aside-input").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/timers/aside-input").setValue(1);
	}

	if (
		(fdm_node.getNode("systems/coursesystem/on").getValue()==0) or
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()!=4) or
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/timers/aside-input").setValue(0);
	}

	#aside

	aside_pos=fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue();
	if	(
		(aside_pos>0) and
		(fdm_node.getNode("systems/coursesystem/timers/aside-input").getValue()==0)
	)
	{
		aside_pos=aside_pos-tick_sec;
	}
	if	(
		(aside_pos<1) and
		(fdm_node.getNode("systems/coursesystem/timers/aside-input").getValue()==1)
	)
	{
		aside_pos=aside_pos+tick_sec*0.1;
	}
	if	(aside_pos<0)
	{
		aside_pos=0;
	}
	if	(aside_pos>1)
	{
		aside_pos=1;
	}
	fdm_node.getNode("systems/coursesystem/timers/aside-pos").setValue(aside_pos);

	#throttle moving got to be smooth, so kinematic left at jsb code

	#Modes

	#First mode

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==0) or
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) or
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(0);
	}
	
		#takeoff

	if	(
		(
			(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
			(fdm_node.getNode("systems/stabautomate/at-control").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
			(fdm_node.getNode("systems/infoline/on").getValue()==1) and
			(fdm_node.getNode("systems/infoline/code").getValue()==2) and
			(fdm_node.getNode("systems/infoline/lock/id").getValue()!=-1) and
			(fdm_node.getNode("systems/gyrocompass/on").getValue()==1)
		) and
		(
			(fdm_node.getNode("gear/unit[1]/WOW").getValue()==1) or
			(fdm_node.getNode("gear/unit[2]/WOW").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(1);
	}

		#passing

	if	(
		(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
		(fdm_node.getNode("systems/stabautomate/at-control").getValue()==1) and
		(fdm_node.getNode("systems/gyrocompass/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(
			fdm_node.getNode("systems/coursesystem/modes/pass/dist-m").getValue()>
			fdm_node.getNode("systems/coursesystem/set/turn-distance-lim-m").getValue()
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(1);
	}

		#convoy

	if	(
		(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(1);
	}

		#intercept

	if	(
		(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()==0) and
		(fdm_node.getNode("systems/infoline/on").getValue()==1) and
		(fdm_node.getNode("systems/infoline/code").getValue()==0) and
		(fdm_node.getNode("systems/infoline/lock/id").getValue()!=-1)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(1);
	}

		#glissade

	if	(
		(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
		(fdm_node.getNode("systems/stabautomate/at-control").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/infoline/on").getValue()==1) and
		(fdm_node.getNode("systems/infoline/code").getValue()==2) and
		(fdm_node.getNode("systems/infoline/lock/id").getValue()!=-1) and
		(fdm_node.getNode("systems/gyrocompass/on").getValue()==1) and
		(fdm_node.getNode("gear/unit[1]/WOW").getValue()==0) and
		(fdm_node.getNode("gear/unit[2]/WOW").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(1);
	}
		#leveling and hopping

	if	(
		(fdm_node.getNode("systems/stabautomate/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-one").setValue(1);
	}

	#Second mode

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==0) or
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(0);
	}

		#takeoff

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/timers/retract-pos").getValue()>0.9)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		) and
		(
			(
				(fdm_node.getNode("systems/radioaltimeter/on").getValue()==1) and
				(
					fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()>
					fdm_node.getNode("systems/radioaltimeter/emer-alt-m").getValue()
				)
			) or
			(
				(fdm_node.getNode("systems/radioaltimeter/on").getValue()==0) and
				(fdm_node.getNode("systems/altimeter/on").getValue()==1) and
				(
					fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()>
					fdm_node.getNode("systems/coursesystem/set/h-distance-m").getValue()
				)
			)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(0);
	}

		#passing

		#direct angle is not presented

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/courseindicator/mode-deg").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

		#too close to the point

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			fdm_node.getNode("systems/coursesystem/modes/pass/dist-m").getValue()<
			fdm_node.getNode("systems/coursesystem/set/turn-distance-lim-m").getValue()
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

		#convoy

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/calc/plus-or-minus").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/calc/plus-or-minus").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

		#intercept

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/infoline/on").getValue()==1) and
		(fdm_node.getNode("systems/infoline/code").getValue()==0) and
		(fdm_node.getNode("systems/infoline/lock/id").getValue()!=-1) and
		(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()!=1) and
		(
			(fdm_node.getNode("systems/radar/lamps/zero").getValue()!=0) or
			(
				(fdm_node.getNode("systems/radar/lock/approach-time").getValue()>0.0) and
				(
					fdm_node.getNode("systems/radar/lock/distance-m").getValue()<
					fdm_node.getNode("systems/coursesystem/set/aside-distance-m").getValue()
				)
			)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(0);
	}

		#glissade

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-dist-m").getValue()<
			fdm_node.getNode("systems/coursesystem/set/close-distance-lim-m").getValue()
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

		#hopping

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/pitot/mach").getValue()>1.95) and
		(fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()>9000.0) and
		(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>0.95)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(1);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/speedometer/indicated-kmh").getValue()<500.0) and
		(fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue()>10000.0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/mode-two").setValue(0);
	}

	#Error

	if	(fdm_node.getNode("systems/coursesystem/on").getValue()==0)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(0);
	}

		#needed instrumentation is off at common modes

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()!=6) and
		(
			(fdm_node.getNode("systems/stabautomate/on").getValue()==0) or
			(fdm_node.getNode("systems/stabautomate/at-control").getValue()==0) or
			(fdm_node.getNode("systems/gyrocompass/on").getValue()==0) or

			(fdm_node.getNode("systems/pitot/on").getValue()==0) or
			(fdm_node.getNode("systems/intakeindicator/on").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#radioaltimeter is off at takeoff and glissade modes

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5)
		) and
		(fdm_node.getNode("systems/radioaltimeter/on").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#chute is not prepared at glissade mode

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/chutepanel/lock-chute-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#mode switched on the run

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(
			fdm_node.getNode("systems/coursesystem/switches/mode-stored").getValue()!=
			fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#infoline is not on on needeed mode

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()<=1) or
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()>=3)
		) and	
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()!=6) and
		(
			(fdm_node.getNode("systems/infoline/on").getValue()==0) or
			(fdm_node.getNode("systems/infoline/lock/id").getValue()==-1) or
			(fdm_node.getNode("systems/infoline/lock/existed").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#wrong infoline code

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(
			(
				(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
				(fdm_node.getNode("systems/infoline/code").getValue()!=2)
			) or
			(
				(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()>=3) and
				(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()<=4) and
				(fdm_node.getNode("systems/infoline/code").getValue()!=0)
			) or
			(
				(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()>=5) and
				(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()<6) and
				(fdm_node.getNode("systems/infoline/code").getValue()!=2)
			)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#overspeed on first takeoff mode

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) and
		(fdm_node.getNode("systems/pitot/mach").getValue()>0.5)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#landing mode started too close to turn point

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) and
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-dist-m").getValue()<
			fdm_node.getNode("systems/coursesystem/set/turn-distance-lim-m").getValue()
		) and
		(
			fdm_node.getNode("systems/coursesystem/modes/gliss/one-course-diff-abs-deg").getValue()>
			fdm_node.getNode("systems/coursesystem/set/point-course-diff-lim").getValue()
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

		#too low at convoy or iterception mode

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()>=3) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()<=4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/infoline/too-low-to-count").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/state/error").setValue(1);
	}

	#Mode finalization

	fdm_node.getNode("systems/coursesystem/switches/mode-stored").setValue(
		fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()
	);

	#Flags

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5)
		) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-brakes").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-brakes").setValue(0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5)
		) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-flaps").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-flaps").setValue(0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5)
		) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-gears").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-gears").setValue(0);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(
				(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) or
				(
					(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
					(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
					(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()>=0.1) and
					(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()<0.5)
				)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
			(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>0.05) and
			(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()<0.95)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-elevator").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-elevator").setValue(0);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(
					(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
					(
						(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()<0.1) or
						(fdm_node.getNode("systems/coursesystem/timers/aside-pos").getValue()>=0.5)
					)
				)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
			(
				(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()<=0.05) or
				(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>=0.95)
			)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-elevator-inc").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-elevator-inc").setValue(0);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-ailerons").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-ailerons").setValue(0);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>0.95)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-engine").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-engine").setValue(0);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
			(
				(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>0.95)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").setValue(0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/off-mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/flags/control-chute").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/flags/control-chute").setValue(0);
	}

	#Control

	fdm_node.getNode("systems/coursesystem/control/brake-front").setValue(0);

	fdm_node.getNode("systems/coursesystem/calc/brake-left").setValue(
		(-1)*
		fdm_node.getNode("systems/coursesystem/set/brake-factor").getValue()*
		fdm_node.getNode("systems/coursesystem/modes/takeoff/course-diff-corr-deg").getValue()
	);

	fdm_node.getNode("systems/coursesystem/control/brake-left").setValue(
		interpol.sps_inter(
			[
				[
					[1.0,		0.0,	1.0],
					[-1.0,	0.0,	0.0],
					[-0.1,	0.0,	0.0],
					[0.0,		0.0,	0.0],
					[0.1,		0.0,	0.1],
					[1.0,		0.0,	1.0]
				],
				[
					[5.0,		0.0,	1.0],
					[-1.0,	0.0,	0.0],
					[-0.1,	0.0,	0.5],
					[0.0,		0.0,	1.0],
					[0.1,		0.0,	1.0],
					[1.0,		0.0,	1.0]
				]
			],
			fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue(),		
			fdm_node.getNode("systems/coursesystem/calc/brake-left").getValue(),
			fdm_node.getNode("gear/unit[1]/WOW").getValue()
		)
	);

	fdm_node.getNode("systems/coursesystem/calc/brake-right").setValue(
		fdm_node.getNode("systems/coursesystem/set/brake-factor").getValue()*
		fdm_node.getNode("systems/coursesystem/modes/takeoff/course-diff-corr-deg").getValue()
	);

	fdm_node.getNode("systems/coursesystem/control/brake-right").setValue(
		interpol.sps_inter(
			[
				[
					[1.0,		0.0,	1.0],
					[-1.0,	0.0,	0.0],
					[-0.1,	0.0,	0.0],
					[0.0,		0.0,	0.0],
					[0.1,		0.0,	0.1],
					[1.0,		0.0,	1.0]
				],
				[
					[5.0,		0.0,	1.0],
					[-1.0,	0.0,	0.0],
					[-0.1,	0.0,	0.5],
					[0.0,		0.0,	1.0],
					[0.1,		0.0,	1.0],
					[1.0,		0.0,	1.0]
				]
			],
			fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue(),		
			fdm_node.getNode("systems/coursesystem/calc/brake-right").getValue(),
			fdm_node.getNode("gear/unit[2]/WOW").getValue()
		)
	);

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(0.5);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(0.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(0.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(0.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/pitot/mach").getValue()>0.5)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(0.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/pitot/mach").getValue()<=0.5) and
		(fdm_node.getNode("systems/pitot/mach").getValue()>0.4)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(0.5);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/pitot/mach").getValue()<=0.4)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/flaps").setValue(1.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/flags/control-flaps").getValue()==1) and 
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("/controls/flight/flaps").setValue(
			fdm_node.getNode("systems/coursesystem/control/flaps").getValue());
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/gears").setValue(1.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()>50)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/gears").setValue(0.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0) and
		(fdm_node.getNode("systems/pitot/mach").getValue()>0.45)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/gears").setValue(0.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/pitot/mach").getValue()<0.45)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/gears").setValue(1.0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(
			fdm_node.getNode("systems/pitot/mach").getValue()<
			fdm_node.getNode("systems/coursesystem/set/takeoff-pitch-mach").getValue()
		) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator").setValue(0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(
			fdm_node.getNode("systems/pitot/mach").getValue()>=
			fdm_node.getNode("systems/coursesystem/set/takeoff-pitch-mach").getValue()
		) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator").setValue(
			fdm_node.getNode("systems/coursesystem/set/a-angle-rad").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator").setValue(
			fdm_node.getNode("systems/coursesystem/set/a-angle-rad").getValue()*2
		);
	}


	if	(
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>0.05) and
		(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()<0.95)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator").setValue(
			fdm_node.getNode("systems/coursesystem/set/a-angle-rad").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator").setValue(
			fdm_node.getNode("systems/coursesystem/set/a-aside-angle-rad").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator-inc").setValue(
			fdm_node.getNode("systems/coursesystem/modes/pass/elevator-inc").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator-inc").setValue(
			fdm_node.getNode("systems/coursesystem/modes/convoy/elevator-inc").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator-inc").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/elevator-inc").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator-inc").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/elevator-inc").getValue()
		);
	}

	if	(
		(
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
			(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()<=0.05)
		) or
		(
			(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
			(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
			(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator-inc").setValue(
			fdm_node.getNode("systems/coursesystem/modes/level/elevator-inc").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>=0.95)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/elevator-inc").setValue(
			fdm_node.getNode("systems/coursesystem/modes/hop/elevator-inc").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(0);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/takeoff/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(
			fdm_node.getNode("systems/coursesystem/modes/pass/ailerons-rad").getValue()
		);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/pass/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(0);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/pass/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(
			fdm_node.getNode("systems/coursesystem/modes/convoy/ailerons-rad").getValue()
		);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/convoy/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/ailerons-rad").getValue()
		);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/aside-ailerons-rad").getValue()
		);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/ailerons-rad").getValue()
		);
		fdm_node.getNode("systems/coursesystem/control/course-diff-deg").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/course-diff-corr-deg").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/ailerons").setValue(0);
	}

	engine_cmd=fdm_node.getNode("systems/gascontrol/med-throttle-out").getValue();
	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		engine_cmd=fdm_node.getNode("systems/coursesystem/modes/takeoff/engine").getValue();
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/takeoff/engine").setValue(engine_cmd);
	}
	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		engine_cmd=fdm_node.getNode("systems/coursesystem/modes/pass/engine").getValue();
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/pass/engine").setValue(engine_cmd);
	}
	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		engine_cmd=fdm_node.getNode("systems/coursesystem/modes/convoy/engine").getValue();
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/convoy/engine").setValue(engine_cmd);
	}
	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0)
	)
	{
		engine_cmd=fdm_node.getNode("systems/coursesystem/modes/intercept/engine").getValue();
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/intercept/engine").setValue(engine_cmd);
	}
	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		engine_cmd=fdm_node.getNode("systems/coursesystem/modes/gliss/engine").getValue();
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/gliss/engine").setValue(engine_cmd);
	}
	if	(
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>=0.95)
	)
	{
		engine_cmd=fdm_node.getNode("systems/coursesystem/modes/hop/engine").getValue();
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/modes/hop/engine").setValue(engine_cmd);
	}
	fdm_node.getNode("systems/coursesystem/timers/engine-input").setValue(engine_cmd);

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/speedbrake").setValue(0);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==2) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/speedbrake").setValue(
			fdm_node.getNode("systems/coursesystem/modes/pass/speedbrake").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==3) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/speedbrake").setValue(
			fdm_node.getNode("systems/coursesystem/modes/convoy/speedbrake").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==4) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/speedbrake").setValue(
			fdm_node.getNode("systems/coursesystem/modes/intercept/speedbrake").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/on").getValue()==1) and
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==5) and
		(fdm_node.getNode("systems/coursesystem/state/error").getValue()==0) and
		(fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").getValue()==1) and
		(
			(fdm_node.getNode("systems/coursesystem/state/mode-one").getValue()==1) or
			(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/speedbrake").setValue(
			fdm_node.getNode("systems/coursesystem/modes/gliss/speedbrake").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/switches/mode-switch").getValue()==6) and
		(fdm_node.getNode("systems/coursesystem/switches/a-vern-pos").getValue()>=0.95)  and
		(fdm_node.getNode("systems/coursesystem/flags/control-speedbrake").getValue()==1)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/speedbrake").setValue(
			fdm_node.getNode("systems/coursesystem/modes/hop/speedbrake").getValue()
		);
	}

	if	(
		(fdm_node.getNode("systems/coursesystem/flags/control-chute").getValue()==1) and
		(
			(fdm_node.getNode("gear/unit[1]/WOW").getValue()==1) or
			(fdm_node.getNode("gear/unit[2]/WOW").getValue()==1) or
			(
				(fdm_node.getNode("systems/radioaltimeter/indicated-alt-m").getValue()<2.5) and
				(fdm_node.getNode("systems/coursesystem/state/mode-two").getValue()==1)
			)
		)
	)
	{
		fdm_node.getNode("systems/coursesystem/control/chute").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/coursesystem/control/chute").setValue(0);
	}

	settimer(func coursesystem(), 1.0); 

}

# initialisation  -------------------------------------------------

coursesystem();
