# -----------------------------------------------------------------------
# Su-15 JSBSim hydraulic system simplified nasal analog

propulsion=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("propulsion/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("propulsion/time-sec").setValue(time_sec);
	fdm_node.getNode("propulsion/tick-sec").setValue(tick_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1)
		 and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("propulsion/serviceable").setValue(1);
	}

		#Left engine

		#Throttle

	throttle_input=0;

	if (fdm_node.getNode("systems/coursesystem/flags/control-engine").getValue()==0)
	{	
		throttle_input=fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue();
	}
	else
	{
		if (fdm_node.getNode("systems/rightpanel/reheat-left-switch").getValue()==1)
		{
			throttle_input=fdm_node.getNode("systems/coursesystem/timers/engine-pos").getValue();
		}
		else
		{
			if (fdm_node.getNode("systems/coursesystem/timers/engine-pos").getValue()>0.84)
			{
				throttle_input=0.84;
			}
			else
			{
				throttle_input=fdm_node.getNode("systems/coursesystem/timers/engine-pos").getValue();
			}
		}
	}

	throttle_input=
		interpol.lin_inter(
			[
				[0.0,		0.0],
				[0.1,		0.01],
				[0.21,	0.21],
				[0.85,	1.0],
				[1.0,		2.0]
			],
			throttle_input);

	throttle_pos=
		fdm_node.getNode("propulsion/engine[0]/throttle").getValue()+
		(
			throttle_input-
			fdm_node.getNode("propulsion/engine[0]/throttle").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue();

	fdm_node.getNode("propulsion/engine[0]/throttle-input").setValue(throttle_pos);

		#Starter

	starter=0;

		# on by ground start button
		
	if 
		(
			(
				(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
				and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-first-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginesstartpanel/engine-start-first-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/generator-first-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/engine-start-switch").getValue()==1)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()<=0.11)
				and (
					(fdm_node.getNode("systems/oxygen/left-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
					)
				)
			)
		)
	{
		starter=1;
	}

		# on by airstart switch

	if 
		(
			(
				(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
				and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-first-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginespanel/air-start-first-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/airstart-left-switch").getValue()==1)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()<=0.11)
				and (
					(fdm_node.getNode("systems/oxygen/left-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
					)
				)
			)
		)
	{
		starter=1;
	}

	fdm_node.getNode("propulsion/engine[0]/starter").setValue(starter);

		# maximum working altitude randomised

	h_max_rnd=
		fdm_node.getNode("propulsion/engine[0]/h-max").getValue()-
		fdm_node.getNode("propulsion/engine[0]/h-rnd").getValue()*rand();

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("propulsion/engine[0]/h-max-rnd").setValue(h_max_rnd);
	};

		# First engine cutoff, on by default
		
	cutoff=1;

		# off by startup sycle started by button
		
	if 
		(
			(
				(fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-first-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginesstartpanel/engine-start-first-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/generator-first-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/engine-start-switch").getValue()==1)
				and (fdm_node.getNode("systems/enginesstartpanel/gen-mode-switch").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[0]/n2").getValue()>=0.25)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()<=0.11)
				and (fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()>1.0)
				and (
					(fdm_node.getNode("systems/oxygen/left-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
					)
				)
			)
		)
	{
		cutoff=0;
	}

		# off by airstart switch

	if 
		(
			(
				(fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-first-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginespanel/air-start-first-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/airstart-left-switch").getValue()==1)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()<=0.11)
				and (fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()>1.0)
				and (
					(fdm_node.getNode("systems/oxygen/left-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
						)
				)
			)
		)
	{
		cutoff=0;
	}

		# off by engine running

	if 
		(
			(
				(fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-first-switch").getValue()==0)
				and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("propulsion/engine[0]/thrust-lbs").getValue()>0)
				and (fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()>1.0)
				and (
				 fdm_node.getNode("propulsion/engine[0]/bleed-intake").getValue()<
				 fdm_node.getNode("propulsion/engine[0]/bleed-cutoff").getValue()
				)
				and (
				 fdm_node.getNode("propulsion/engine[0]/h-max-set").getValue()>
				 fdm_node.getNode("position/h-sl-ft").getValue()
				)
			)
		)
	{
		cutoff=0;
	}

	if (
		fdm_node.getNode("propulsion/engine[0]/bleed-intake").getValue()>=
		fdm_node.getNode("propulsion/engine[0]/bleed-cutoff").getValue()
	)
	{
		fdm_node.getNode("propulsion/engine[0]/cutoff-reason").setValue(1);
	}

	fdm_node.getNode("propulsion/engine[0]/cutoff").setValue(cutoff);

		# first engine augmentation

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
			and (props.globals.getNode("engines/engine[0]/augmentation").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[0]/thrust-lbs").getValue()>0)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/augmentation").setValue(1);
	}
	else
	{
		fdm_node.getNode("propulsion/engine[0]/augmentation").setValue(0);
	}

		# first engine nozzle

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0)
			and (fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (
				fdm_node.getNode("systems/hydraulic/unit[0]/system-press").getValue()>
				fdm_node.getNode("systems/hydraulic/working-min").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/nozzle-command").setValue(
			fdm_node.getNode("propulsion/engine[0]/augmentation").getValue()
		);
	}

	nozzle_pos=
		fdm_node.getNode("propulsion/engine[0]/nozzle-pos").getValue()+
		(
			fdm_node.getNode("propulsion/engine[0]/nozzle-command").getValue()-
			fdm_node.getNode("propulsion/engine[0]/nozzle-pos").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue()*0.5;

	fdm_node.getNode("propulsion/engine[0]/nozzle-pos").setValue(nozzle_pos);
	fdm_node.getNode("propulsion/engine[0]/nozzle-perc").setValue(
		fdm_node.getNode("propulsion/engine[0]/nozzle-pos").getValue()
		*100
	);

		# nozzle moving

	if
		(
			(
				fdm_node.getNode("propulsion/engine[0]/nozzle-pos").getValue()>
				fdm_node.getNode("propulsion/engine[0]/nozzle-command").getValue()+0.01
			)
			or
			(
				fdm_node.getNode("propulsion/engine[0]/nozzle-pos").getValue()<
				fdm_node.getNode("propulsion/engine[0]/nozzle-command").getValue()-0.01
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/nozzle-moving").setValue(1);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[0]/nozzle-moving").setValue(0);
	}

		# first engine intake

	fdm_node.getNode("propulsion/engine[0]/intake-auto-pos").setValue(
		interpol.sqr_inter(
			[
				[0.000,	30.000,	65.000,	100.000],
				[0.000,	0.000,	0.000,	0.000],
				[0.390,	0.000,	0.000,	0.000],
				[0.400,	0.100,	0.100,	0.100],
				[1.500,	0.100,	0.100,	0.100],
				[1.650,	1.000,	0.500,	0.370],
				[1.825,	1.000,	1.000,	0.685],
				[2.000,	1.000,	1.000,	1.000]
			],
			fdm_node.getNode("velocities/mach").getValue(),
			fdm_node.getNode("propulsion/engine[0]/n1").getValue()
		)
	);

	intake_command=fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue();

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (
				fdm_node.getNode("systems/hydraulic/unit[0]/system-press").getValue()>
				fdm_node.getNode("systems/hydraulic/working-min").getValue()
			)
			and (fdm_node.getNode("systems/enginespanel/intake-left-switch").getValue()==-1)
			and (fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()>0.1)
		)
	{	
		intake_command=0;
	}

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (
				fdm_node.getNode("systems/hydraulic/unit[0]/system-press").getValue()>
				fdm_node.getNode("systems/hydraulic/working-min").getValue()
			)
			and (fdm_node.getNode("systems/enginespanel/intake-left-switch").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()<0.9)
		)
	{	
		intake_command=1;
	}

	fdm_node.getNode("propulsion/engine[0]/intake-command").setValue(intake_command);

	intake_input=fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue();	

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/rightpanel/intake-left-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()==1)
			and (fdm_node.getNode("systems/enginespanel/intake-mode-left-switch").getValue()==0)
		)
	{	
		intake_input=fdm_node.getNode("propulsion/engine[0]/intake-auto-pos").getValue();	
	}

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/rightpanel/intake-left-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()==1)
			and (fdm_node.getNode("systems/enginespanel/intake-mode-left-switch").getValue()==1)
		)
	{	
		intake_input=fdm_node.getNode("propulsion/engine[0]/intake-command").getValue();
	}

	fdm_node.getNode("propulsion/engine[0]/intake-input").setValue(intake_input);

	intake_pos=
		fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()+
		(
			fdm_node.getNode("propulsion/engine[0]/intake-input").getValue()-
			fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue()*0.125;

	fdm_node.getNode("propulsion/engine[0]/intake-pos").setValue(intake_pos);
	fdm_node.getNode("propulsion/engine[0]/intake-perc").setValue(intake_pos*100);

		# intake moving

	if
		(
			(
				fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()>
				(fdm_node.getNode("propulsion/engine[0]/intake-input").getValue()+0.01)
			)
			or
			(
				fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()<
				(fdm_node.getNode("propulsion/engine[0]/intake-input").getValue()-0.01)
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/intake-moving").setValue(1);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[0]/intake-moving").setValue(0);
	}

		#smoothing beta to avoid counting problems

	fdm_node.getNode("propulsion/beta-smoothed-rad").setValue(
		fdm_node.getNode("propulsion/beta-smoothed-rad").getValue()+
		(
			fdm_node.getNode("aero/beta-rad").getValue()
			-fdm_node.getNode("propulsion/beta-smoothed-rad").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue()*0.1
	);

		# first engine bleed

		# aerodinamical shadow due to sideslip

	fdm_node.getNode("propulsion/engine[0]/intake-shadow-pos").setValue(
		interpol.lin_inter(
			[
				[-0.1,	1.0],
				[-0.05,	0.0],
				[0.0,		0.0]	
			],
			fdm_node.getNode("propulsion/beta-smoothed-rad").getValue()
		)
	);

		# intake shadowed position

	if
		(
			(fdm_node.getNode("velocities/mach").getValue()>=1.0)
			and
			(
				fdm_node.getNode("propulsion/engine[0]/intake-shadow-pos").getValue()>
				fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/intake-shadowed-pos").setValue(
			fdm_node.getNode("propulsion/engine[0]/intake-shadow-pos").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[0]/intake-shadowed-pos").setValue(
			fdm_node.getNode("propulsion/engine[0]/intake-pos").getValue()
		);
	}

		# bleed due incorrect intake position 

	fdm_node.getNode("propulsion/engine[0]/bleed-intake").setValue(
		abs(
			fdm_node.getNode("propulsion/engine[0]/intake-auto-pos").getValue()-
			fdm_node.getNode("propulsion/engine[0]/intake-shadowed-pos").getValue()
		)
	);

		# bleed due incorrect intake position
		# and jet flap maintenance 

	fdm_node.getNode("propulsion/engine[0]/bleed").setValue(
		fdm_node.getNode("propulsion/engine[0]/bleed-intake").getValue()+
		(
			fdm_node.getNode("surfaces/flap/unit[0]/jet-factor").getValue()*
			fdm_node.getNode("propulsion/engine[0]/jet-flap-bleed-factor").getValue()
		)
	);

		# oil pressure

	fdm_node.getNode("propulsion/engine[0]/oil-press-calc").setValue(
		(
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[30.0,	1.0],
					[100.0,	4.0]	
				],
				fdm_node.getNode("propulsion/engine[0]/n1").getValue()
			)+
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[60.0,	1.0],
					[100.0,	4.0]	
				],
				fdm_node.getNode("propulsion/engine[0]/n2").getValue()
			)
		)/2
	);

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/oil-press").setValue(
			fdm_node.getNode("propulsion/engine[0]/oil-press-calc").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[0]/oil-press").setValue(0);
	}

		# temperature

	fdm_node.getNode("propulsion/engine[0]/temp-c").setValue(
		(
			props.globals.getNode("engines/engine[0]/egt-degf").getValue()
			-32.0
		)*0.55555
	);

		# melting timer

	melt_init=
		-0.25+
		(-0.75)*rand();

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		or (fdm_node.getNode("propulsion/init").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/engine[0]/melt-timer-init").setValue(melt_init);
	};

	melt_timer_input=0;

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/melt-timer").getValue()>0)
			and (
				fdm_node.getNode("propulsion/engine[0]/temp-c").getValue()>
				fdm_node.getNode("propulsion/engine[0]/melting-temp-c").getValue()
			)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		melt_timer_input=
			fdm_node.getNode("propulsion/engine[0]/melt-timer-init").getValue();
	}

	if
		(
			(fdm_node.getNode("breakage/serviceable").getValue()==0)
			or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		melt_timer_input=
			fdm_node.getNode("propulsion/engine[0]/melt-time-sec").getValue()-
			fdm_node.getNode("propulsion/engine[0]/melt-timer").getValue();
	}

	fdm_node.getNode("propulsion/engine[0]/melt-timer-input").setValue(melt_timer_input);

	fdm_node.getNode("propulsion/engine[0]/melt-timer").setValue(
		fdm_node.getNode("propulsion/engine[0]/melt-timer").getValue()+
		fdm_node.getNode("propulsion/engine[0]/melt-timer-input").getValue()
		*fdm_node.getNode("propulsion/tick-sec").getValue()
	);

		# burning

		# on by melting 

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
			and (fdm_node.getNode("propulsion/engine[0]/melt-timer").getValue()<=0)
			and	(fdm_node.getNode("breakage/serviceable").getValue()==1)
			and	(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/burning").setValue(1);
	}

		# on by g overload 

	if
		(
			(
				fdm_node.getNode("breakage/g-soft").getValue()>
				fdm_node.getNode("propulsion/engine[0]/g-max-set").getValue()
			)
			and	(fdm_node.getNode("breakage/serviceable").getValue()==1)
			and	(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/burning").setValue(1);
	}

		# off by repair or extinguishing

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==1)
			or (fdm_node.getNode("breakage/serviceable").getValue()==0)
			or	(fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/burning").setValue(0);
	}

	burn_init=
		-0.1+
		(-0.5)*rand();

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		or (fdm_node.getNode("propulsion/init").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/engine[0]/burnout-timer-init").setValue(burn_init);
	}

	burnout_timer_input=0;

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/burnout-timer").getValue()>0)
			and (fdm_node.getNode("propulsion/engine[0]/burning").getValue()==1)
		)
	{	
		burnout_timer_input=
			fdm_node.getNode("propulsion/engine[0]/burnout-timer-init").getValue();
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{	
		burnout_timer_input=
			fdm_node.getNode("propulsion/engine[0]/burnout-time-sec").getValue()-
			fdm_node.getNode("propulsion/engine[0]/burnout-timer").getValue();
	}

	fdm_node.getNode("propulsion/engine[0]/burnout-timer-input").setValue(
		burnout_timer_input);
	
	fdm_node.getNode("propulsion/engine[0]/burnout-timer").setValue(
		fdm_node.getNode("propulsion/engine[0]/burnout-timer").getValue()+
		fdm_node.getNode("propulsion/engine[0]/burnout-timer-input").getValue()
		*fdm_node.getNode("propulsion/tick-sec").getValue()
	);

		# g force randomised

	g_max_init=
		fdm_node.getNode("propulsion/engine[0]/g-max").getValue()-
		fdm_node.getNode("propulsion/engine[0]/g-rnd").getValue()*rand();

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		or (fdm_node.getNode("propulsion/init").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/engine[0]/g-max-set").setValue(g_max_init);
	}

		# breaking

	broken=fdm_node.getNode("propulsion/engine[0]/broken").getValue();
	breakage_reason=0;

			# on by overburning

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/extinguished").getValue()==0)
			and (fdm_node.getNode("propulsion/engine[0]/burnout-timer").getValue()<=0)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		broken=1;
		breakage_reason=1;
	}

			# on by g overload

	if
		(
			(
				fdm_node.getNode("breakage/g-soft").getValue()>
				fdm_node.getNode("propulsion/engine[0]/g-max-set").getValue()
			)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		broken=1;
		breakage_reason=2;
	}

			# on by tail hit

	if
		(
			(fdm_node.getNode("contact/unit[12]/WOW").getValue()==1)
			and (
				fdm_node.getNode("breakage/g-soft").getValue()>
				fdm_node.getNode("propulsion/engine[0]/g-max-tail").getValue()
			)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		broken=1;
		breakage_reason=3;
	}

			# off by repair

	if
		(
			(fdm_node.getNode("breakage/serviceable").getValue()==0)
			or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		broken=0;
		breakage_reason=0;
	}

	fdm_node.getNode("propulsion/engine[0]/broken").setValue(broken);
	fdm_node.getNode("propulsion/engine[0]/breakage-reason").setValue(breakage_reason);

		# extinguishing

		# off by repair

	if
		(
			(fdm_node.getNode("breakage/serviceable").getValue()==0)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/extinguisher-input").setValue(0);
	}

			# on by command

	if
		(
			(fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("systems/leftpanel/fire-valve-first-switch").getValue()==1)
			and (fdm_node.getNode("systems/leftpanel/extinguishing-switch").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/extinguisher-input").setValue(1);
	}

	fdm_node.getNode("propulsion/engine[0]/extinguisher-pos").setValue(
		fdm_node.getNode("propulsion/engine[0]/extinguisher-pos").getValue()+
		(
			fdm_node.getNode("propulsion/engine[0]/extinguisher-input").getValue()-
			fdm_node.getNode("propulsion/engine[0]/extinguisher-pos").getValue()
		)
		*fdm_node.getNode("propulsion/tick-sec").getValue()
		*0.2
	);

			# off by repair

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/extinguisher-pos").getValue()<0.9)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/extinguished").setValue(0);
	}

			# on by extinguishing or repair

	if
		(
			(fdm_node.getNode("propulsion/engine[0]/extinguisher-pos").getValue()>=0.9)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[0]/extinguished").setValue(1);
	}

		#Right engine

		#Throttle

	throttle_input=0;

	if (fdm_node.getNode("systems/coursesystem/flags/control-engine").getValue()==0)
	{	
		throttle_input=fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue();
	}
	else
	{
		if (fdm_node.getNode("systems/rightpanel/reheat-right-switch").getValue()==1)
		{
			throttle_input=fdm_node.getNode("systems/coursesystem/timers/engine-pos").getValue();
		}
		else
		{
			if (fdm_node.getNode("systems/coursesystem/timers/engine-pos").getValue()>0.84)
			{
				throttle_input=0.84;
			}
			else
			{
				throttle_input=fdm_node.getNode("systems/coursesystem/timers/engine-pos").getValue();
			}
		}
	}

	throttle_input=
		interpol.lin_inter(
			[
				[0.0,		0.0],
				[0.1,		0.01],
				[0.21,	0.21],
				[0.85,	1.0],
				[1.0,		2.0]
			],
			throttle_input);

	throttle_pos=
		fdm_node.getNode("propulsion/engine[1]/throttle").getValue()+
		(
			throttle_input-
			fdm_node.getNode("propulsion/engine[1]/throttle").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue();

	fdm_node.getNode("propulsion/engine[1]/throttle-input").setValue(throttle_pos);

		#Starter

	starter=0;

		# on by ground start button
		
	if 
		(
			(
				(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
				and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-second-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginesstartpanel/engine-start-second-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/generator-second-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/engine-start-switch").getValue()==1)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()<=0.11)
				and (
					(fdm_node.getNode("systems/oxygen/right-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
					)
				)
			)
		)
	{
		starter=1;
	}

		# on by airstart switch

	if 
		(
			(
				(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
				and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-second-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginespanel/air-start-second-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/airstart-right-switch").getValue()==1)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()<=0.11)
				and (
					(fdm_node.getNode("systems/oxygen/right-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
					)
				)
			)
		)
	{
		starter=1;
	}

	fdm_node.getNode("propulsion/engine[1]/starter").setValue(starter);

		# maximum working altitude randomised

	h_max_rnd=
		fdm_node.getNode("propulsion/engine[1]/h-max").getValue()-
		fdm_node.getNode("propulsion/engine[1]/h-rnd").getValue()*rand();

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("propulsion/engine[1]/h-max-rnd").setValue(h_max_rnd);
	};

		# First engine cutoff, on by default
		
	cutoff=1;

		# off by startup sycle started by button
		
	if 
		(
			(
				(fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-second-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginesstartpanel/engine-start-second-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/generator-second-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/engine-start-switch").getValue()==1)
				and (fdm_node.getNode("systems/enginesstartpanel/gen-mode-switch").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[1]/n2").getValue()>=0.25)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()<=0.11)
				and (fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()>1.0)
				and (
					(fdm_node.getNode("systems/oxygen/right-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
					)
				)
			)
		)
	{
		cutoff=0;
	}

		# off by airstart switch

	if 
		(
			(
				(fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-second-switch").getValue()==0)
				and (fdm_node.getNode("systems/enginespanel/air-start-second-switch").getValue()==1)
				and (fdm_node.getNode("systems/rightpanel/airstart-right-switch").getValue()==1)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()<=0.11)
				and (fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()>1.0)
				and (
					(fdm_node.getNode("systems/oxygen/right-start-cons").getValue()==0)
					or
					(
						(fdm_node.getNode("systems/oxygen/serviceable").getValue()==1)
						and (
							fdm_node.getNode("systems/oxygen/system-press").getValue()>
							fdm_node.getNode("systems/oxygen/airstart-min").getValue()
						)
						)
				)
			)
		)
	{
		cutoff=0;
	}

		# off by engine running

	if 
		(
			(
				(fdm_node.getNode("propulsion/serviceable").getValue()==1)
				and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
				and (fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
				and (fdm_node.getNode("systems/leftpanel/fire-valve-second-switch").getValue()==0)
				and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()>=0.09)
				and (fdm_node.getNode("propulsion/engine[1]/thrust-lbs").getValue()>0)
				and (fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()>1.0)
				and (
				 fdm_node.getNode("propulsion/engine[1]/bleed-intake").getValue()<
				 fdm_node.getNode("propulsion/engine[1]/bleed-cutoff").getValue()
				)
				and (
				 fdm_node.getNode("propulsion/engine[1]/h-max-set").getValue()>
				 fdm_node.getNode("position/h-sl-ft").getValue()
				)
			)
		)
	{
		cutoff=0;
	}

	if (
		fdm_node.getNode("propulsion/engine[1]/bleed-intake").getValue()>=
		fdm_node.getNode("propulsion/engine[1]/bleed-cutoff").getValue()
	)
	{
		fdm_node.getNode("propulsion/engine[1]/cutoff-reason").setValue(1);
	}

	fdm_node.getNode("propulsion/engine[1]/cutoff").setValue(cutoff);

		# first engine augmentation

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
			and (props.globals.getNode("engines/engine[1]/augmentation").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[1]/thrust-lbs").getValue()>0)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/augmentation").setValue(1);
	}
	else
	{
		fdm_node.getNode("propulsion/engine[1]/augmentation").setValue(0);
	}

		# first engine nozzle

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0)
			and (fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (
				fdm_node.getNode("systems/hydraulic/unit[1]/system-press").getValue()>
				fdm_node.getNode("systems/hydraulic/working-min").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/nozzle-command").setValue(
			fdm_node.getNode("propulsion/engine[1]/augmentation").getValue()
		);
	}

	nozzle_pos=
		fdm_node.getNode("propulsion/engine[1]/nozzle-pos").getValue()+
		(
			fdm_node.getNode("propulsion/engine[1]/nozzle-command").getValue()-
			fdm_node.getNode("propulsion/engine[1]/nozzle-pos").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue()*0.5;

	fdm_node.getNode("propulsion/engine[1]/nozzle-pos").setValue(nozzle_pos);
	fdm_node.getNode("propulsion/engine[1]/nozzle-perc").setValue(
		fdm_node.getNode("propulsion/engine[1]/nozzle-pos").getValue()
		*100
	);

		# nozzle moving

	if
		(
			(
				fdm_node.getNode("propulsion/engine[1]/nozzle-pos").getValue()>
				fdm_node.getNode("propulsion/engine[1]/nozzle-command").getValue()+0.01
			)
			or
			(
				fdm_node.getNode("propulsion/engine[1]/nozzle-pos").getValue()<
				fdm_node.getNode("propulsion/engine[1]/nozzle-command").getValue()-0.01
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/nozzle-moving").setValue(1);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[1]/nozzle-moving").setValue(0);
	}

		# first engine intake

	fdm_node.getNode("propulsion/engine[1]/intake-auto-pos").setValue(
		interpol.sqr_inter(
			[
				[0.000,	30.000,	65.000,	100.000],
				[0.000,	0.000,	0.000,	0.000],
				[0.390,	0.000,	0.000,	0.000],
				[0.400,	0.100,	0.100,	0.100],
				[1.500,	0.100,	0.100,	0.100],
				[1.650,	1.000,	0.500,	0.370],
				[1.825,	1.000,	1.000,	0.685],
				[2.000,	1.000,	1.000,	1.000]
			],
			fdm_node.getNode("velocities/mach").getValue(),
			fdm_node.getNode("propulsion/engine[1]/n1").getValue()
		)
	);

	intake_command=fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue();

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (
				fdm_node.getNode("systems/hydraulic/unit[1]/system-press").getValue()>
				fdm_node.getNode("systems/hydraulic/working-min").getValue()
			)
			and (fdm_node.getNode("systems/enginespanel/intake-right-switch").getValue()==-1)
			and (fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()>0.1)
		)
	{	
		intake_command=0;
	}

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (
				fdm_node.getNode("systems/hydraulic/unit[1]/system-press").getValue()>
				fdm_node.getNode("systems/hydraulic/working-min").getValue()
			)
			and (fdm_node.getNode("systems/enginespanel/intake-right-switch").getValue()==1)
			and (fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()<0.9)
		)
	{	
		intake_command=1;
	}

	fdm_node.getNode("propulsion/engine[1]/intake-command").setValue(intake_command);

	intake_input=fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue();	

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/rightpanel/intake-right-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()==1)
			and (fdm_node.getNode("systems/enginespanel/intake-mode-right-switch").getValue()==0)
		)
	{	
		intake_input=fdm_node.getNode("propulsion/engine[1]/intake-auto-pos").getValue();	
	}

	if
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/electrical/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/rightpanel/intake-right-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()==1)
			and (fdm_node.getNode("systems/enginespanel/intake-mode-right-switch").getValue()==1)
		)
	{	
		intake_input=fdm_node.getNode("propulsion/engine[1]/intake-command").getValue();
	}

	fdm_node.getNode("propulsion/engine[1]/intake-input").setValue(intake_input);

	intake_pos=
		fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()+
		(
			fdm_node.getNode("propulsion/engine[1]/intake-input").getValue()-
			fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()
		)*fdm_node.getNode("propulsion/tick-sec").getValue()*0.125;

	fdm_node.getNode("propulsion/engine[1]/intake-pos").setValue(intake_pos);
	fdm_node.getNode("propulsion/engine[1]/intake-perc").setValue(intake_pos*100);

		# intake moving

	if
		(
			(
				fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()>
				(fdm_node.getNode("propulsion/engine[1]/intake-input").getValue()+0.01)
			)
			or
			(
				fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()<
				(fdm_node.getNode("propulsion/engine[1]/intake-input").getValue()-0.01)
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/intake-moving").setValue(1);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[1]/intake-moving").setValue(0);
	}

		# first engine bleed

		# aerodinamical shadow due to sideslip

	fdm_node.getNode("propulsion/engine[1]/intake-shadow-pos").setValue(
		interpol.lin_inter(
			[
				[0.0,		0.0],
				[0.05,	0.0],
				[0.1,		1.0]	
			],
			fdm_node.getNode("propulsion/beta-smoothed-rad").getValue()
		)
	);

		# intake shadowed position

	if
		(
			(fdm_node.getNode("velocities/mach").getValue()>=1.0)
			and
			(
				fdm_node.getNode("propulsion/engine[1]/intake-shadow-pos").getValue()>
				fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/intake-shadowed-pos").setValue(
			fdm_node.getNode("propulsion/engine[1]/intake-shadow-pos").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[1]/intake-shadowed-pos").setValue(
			fdm_node.getNode("propulsion/engine[1]/intake-pos").getValue()
		);
	}

		# bleed due incorrect intake position 

	fdm_node.getNode("propulsion/engine[1]/bleed-intake").setValue(
		abs(
			fdm_node.getNode("propulsion/engine[1]/intake-auto-pos").getValue()-
			fdm_node.getNode("propulsion/engine[1]/intake-shadowed-pos").getValue()
		)
	);

		# bleed due incorrect intake position
		# and jet flap maintenance 

	fdm_node.getNode("propulsion/engine[1]/bleed").setValue(
		fdm_node.getNode("propulsion/engine[1]/bleed-intake").getValue()+
		(
			fdm_node.getNode("surfaces/flap/unit[1]/jet-factor").getValue()*
			fdm_node.getNode("propulsion/engine[1]/jet-flap-bleed-factor").getValue()
		)
	);

		# oil pressure

	fdm_node.getNode("propulsion/engine[1]/oil-press-calc").setValue(
		(
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[30.0,	1.0],
					[100.0,	4.0]	
				],
				fdm_node.getNode("propulsion/engine[1]/n1").getValue()
			)+
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[60.0,	1.0],
					[100.0,	4.0]	
				],
				fdm_node.getNode("propulsion/engine[1]/n2").getValue()
			)
		)/2
	);

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/oil-press").setValue(
			fdm_node.getNode("propulsion/engine[1]/oil-press-calc").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/engine[1]/oil-press").setValue(0);
	}

		# temperature

	fdm_node.getNode("propulsion/engine[1]/temp-c").setValue(
		(
			props.globals.getNode("engines/engine[1]/egt-degf").getValue()
			-32.0
		)*0.55555
	);

		# melting timer

	melt_init=
		-0.25+
		(-0.75)*rand();

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		or (fdm_node.getNode("propulsion/init").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/engine[1]/melt-timer-init").setValue(melt_init);
	};

	melt_timer_input=0;

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/melt-timer").getValue()>0)
			and (
				fdm_node.getNode("propulsion/engine[1]/temp-c").getValue()>
				fdm_node.getNode("propulsion/engine[1]/melting-temp-c").getValue()
			)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		melt_timer_input=
			fdm_node.getNode("propulsion/engine[1]/melt-timer-init").getValue();
	}

	if
		(
			(fdm_node.getNode("breakage/serviceable").getValue()==0)
			or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		melt_timer_input=
			fdm_node.getNode("propulsion/engine[1]/melt-time-sec").getValue()-
			fdm_node.getNode("propulsion/engine[1]/melt-timer").getValue();
	}

	fdm_node.getNode("propulsion/engine[1]/melt-timer-input").setValue(melt_timer_input);

	fdm_node.getNode("propulsion/engine[1]/melt-timer").setValue(
		fdm_node.getNode("propulsion/engine[1]/melt-timer").getValue()+
		fdm_node.getNode("propulsion/engine[1]/melt-timer-input").getValue()
		*fdm_node.getNode("propulsion/tick-sec").getValue()
	);

		# burning

		# on by melting 

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
			and (fdm_node.getNode("propulsion/engine[1]/melt-timer").getValue()<=0)
			and	(fdm_node.getNode("breakage/serviceable").getValue()==1)
			and	(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/burning").setValue(1);
	}

		# on by g overload 

	if
		(
			(
				fdm_node.getNode("breakage/g-soft").getValue()>
				fdm_node.getNode("propulsion/engine[1]/g-max-set").getValue()
			)
			and	(fdm_node.getNode("breakage/serviceable").getValue()==1)
			and	(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/burning").setValue(1);
	}

		# off by repair or extinguishing

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==1)
			or (fdm_node.getNode("breakage/serviceable").getValue()==0)
			or	(fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/burning").setValue(0);
	}

	burn_init=
		-0.1+
		(-0.5)*rand();

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		or (fdm_node.getNode("propulsion/init").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/engine[1]/burnout-timer-init").setValue(burn_init);
	}

	burnout_timer_input=0;

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/burnout-timer").getValue()>0)
			and (fdm_node.getNode("propulsion/engine[1]/burning").getValue()==1)
		)
	{	
		burnout_timer_input=
			fdm_node.getNode("propulsion/engine[1]/burnout-timer-init").getValue();
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{	
		burnout_timer_input=
			fdm_node.getNode("propulsion/engine[1]/burnout-time-sec").getValue()-
			fdm_node.getNode("propulsion/engine[1]/burnout-timer").getValue();
	}

	fdm_node.getNode("propulsion/engine[1]/burnout-timer-input").setValue(
		burnout_timer_input);
	
	fdm_node.getNode("propulsion/engine[1]/burnout-timer").setValue(
		fdm_node.getNode("propulsion/engine[1]/burnout-timer").getValue()+
		fdm_node.getNode("propulsion/engine[1]/burnout-timer-input").getValue()
		*fdm_node.getNode("propulsion/tick-sec").getValue()
	);

		# g force randomised

	g_max_init=
		fdm_node.getNode("propulsion/engine[1]/g-max").getValue()-
		fdm_node.getNode("propulsion/engine[1]/g-rnd").getValue()*rand();

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		or (fdm_node.getNode("propulsion/init").getValue()==0)
	)
	{
		fdm_node.getNode("propulsion/engine[1]/g-max-set").setValue(g_max_init);
	}

		# breaking

	broken=fdm_node.getNode("propulsion/engine[1]/broken").getValue();
	breakage_reason=0;

			# on by overburning

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/extinguished").getValue()==0)
			and (fdm_node.getNode("propulsion/engine[1]/burnout-timer").getValue()<=0)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		broken=1;
		breakage_reason=1;
	}

			# on by g overload

	if
		(
			(
				fdm_node.getNode("breakage/g-soft").getValue()>
				fdm_node.getNode("propulsion/engine[1]/g-max-set").getValue()
			)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		broken=1;
		breakage_reason=2;
	}

			# on by tail hit

	if
		(
			(fdm_node.getNode("contact/unit[12]/WOW").getValue()==1)
			and (
				fdm_node.getNode("breakage/g-soft").getValue()>
				fdm_node.getNode("propulsion/engine[1]/g-max-tail").getValue()
			)
			and (fdm_node.getNode("breakage/serviceable").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		broken=1;
		breakage_reason=3;
	}

			# off by repair

	if
		(
			(fdm_node.getNode("breakage/serviceable").getValue()==0)
			or (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		broken=0;
		breakage_reason=0;
	}

	fdm_node.getNode("propulsion/engine[1]/broken").setValue(broken);
	fdm_node.getNode("propulsion/engine[1]/breakage-reason").setValue(breakage_reason);

		# extinguishing

			# off by repair

	if
		(
			(fdm_node.getNode("breakage/serviceable").getValue()==0)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/extinguisher-input").setValue(0);
	}

			# on by command

	if
		(
			(fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("systems/leftpanel/fire-valve-second-switch").getValue()==1)
			and (fdm_node.getNode("systems/leftpanel/extinguishing-switch").getValue()==1)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/extinguisher-input").setValue(1);
	}

	fdm_node.getNode("propulsion/engine[1]/extinguisher-pos").setValue(
		fdm_node.getNode("propulsion/engine[1]/extinguisher-pos").getValue()+
		(
			fdm_node.getNode("propulsion/engine[1]/extinguisher-input").getValue()-
			fdm_node.getNode("propulsion/engine[1]/extinguisher-pos").getValue()
		)
		*fdm_node.getNode("propulsion/tick-sec").getValue()
		*0.2
	);

			# off by repair

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/extinguisher-pos").getValue()<0.9)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/extinguished").setValue(0);
	}

			# on by extinguishing or repair

	if
		(
			(fdm_node.getNode("propulsion/engine[1]/extinguisher-pos").getValue()>=0.9)
			and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{	
		fdm_node.getNode("propulsion/engine[1]/extinguished").setValue(1);
	}
	# Tanks

	# Left engine service tank expence in pounds 

	fdm_node.getNode("propulsion/tank[0]/expence-lbs").setValue(
		fdm_node.getNode("propulsion/tank[0]/capacity-lbs").getValue()-
		fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()
	);

	# Right engine service tank expence in pounds

	fdm_node.getNode("propulsion/tank[1]/expence-lbs").setValue(
		fdm_node.getNode("propulsion/tank[1]/capacity-lbs").getValue()-
		fdm_node.getNode("propulsion/tank[1]/contents-lbs").getValue()
	);

	#Summar expence in pounds

	fdm_node.getNode("propulsion/expence-lbs").setValue(
		fdm_node.getNode("propulsion/tank[0]/expence-lbs").getValue()+
		fdm_node.getNode("propulsion/tank[1]/expence-lbs").getValue()
	);

	#Got some fuel

	fuel_presented=0;

	if
		(
			(
				fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[3]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[3]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/expence-lbs").getValue()
			)
			and
			(
				fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fuel_presented=1;
	}

	fdm_node.getNode("propulsion/fuel-presented").setValue(fuel_presented);

	# Transfer is allowed

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("propulsion/fuel-presented").getValue()==1)
			and (fdm_node.getNode("systems/rightpanel/transfer-pump-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("systems/gascontrol/unit[0]/lever-pos").getValue()>=0.009)
		)
	{	
		fdm_node.getNode("propulsion/transfer-left").setValue(1);
	}
	else
	{	
		fdm_node.getNode("propulsion/transfer-left").setValue(0);
	}

	if
		(
			(fdm_node.getNode("propulsion/serviceable").getValue()==1)
			and (fdm_node.getNode("propulsion/fuel-presented").getValue()==1)
			and (fdm_node.getNode("systems/rightpanel/transfer-pump-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			and (fdm_node.getNode("systems/gascontrol/unit[1]/lever-pos").getValue()>=0.009)
		)
	{	
		fdm_node.getNode("propulsion/transfer-right").setValue(1);
	}
	else
	{	
		fdm_node.getNode("propulsion/transfer-right").setValue(0);
	}

	# Left engine service tank transfer in pounds,
	#	with refill option

	fdm_node.getNode("propulsion/tank[0]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[0]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()
		)
		+(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
		(
			fdm_node.getNode("propulsion/transfer-left").getValue()
			*fdm_node.getNode("propulsion/tank[0]/expence-lbs").getValue()
		)
	);

	# Right engine service tank transfer in pounds

	fdm_node.getNode("propulsion/tank[1]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[1]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[1]/contents-lbs").getValue()
		)
		+(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
		(
			fdm_node.getNode("propulsion/transfer-left").getValue()
			*fdm_node.getNode("propulsion/tank[1]/expence-lbs").getValue()
		)
	);

	# Update tanks

	fdm_node.getNode("propulsion/tank[0]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[0]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[1]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[1]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
	);

	# Set tank from which first engine and its transfer tank gets fuel from.
	#	Left engine preference order 7..8..2..5..6..4..3  -->

	if
		(
			fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()>
			fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
		)
	{	
		fdm_node.getNode("propulsion/tank[7]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[7]/transfer-first-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[8]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[8]/transfer-first-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[2]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[2]/transfer-first-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[5]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[5]/transfer-first-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[6]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[6]/transfer-first-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[4]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[4]/transfer-first-lbs").setValue(0);
	}
	
	if
		(
			(
				fdm_node.getNode("propulsion/tank[3]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[3]/transfer-first-lbs").setValue(
			fdm_node.getNode("propulsion/tank[0]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[3]/transfer-first-lbs").setValue(0);
	}	

	#	Right engine preference order 8..7..2..6..5..4..3

	if
		(
			(
				fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[8]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[8]/transfer-second-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[7]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[7]/transfer-second-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[2]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[2]/transfer-second-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[6]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[6]/transfer-second-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[5]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[5]/transfer-second-lbs").setValue(0);
	}

	if
		(
			(
				fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[4]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[4]/transfer-second-lbs").setValue(0);
	}
	
	if
		(
			(
				fdm_node.getNode("propulsion/tank[3]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
			and (
				fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()<=
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)
	{	
		fdm_node.getNode("propulsion/tank[3]/transfer-second-lbs").setValue(
			fdm_node.getNode("propulsion/tank[1]/transfer-lbs").getValue()
		);
	}
	else
	{	
		fdm_node.getNode("propulsion/tank[3]/transfer-second-lbs").setValue(0);
	}

	# Count sum of transfers for each tank.

	fdm_node.getNode("propulsion/tank[2]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[2]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()
		)+
		fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()*
			-1.0*
			(fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)+
		-(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
			(1-fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue())*
		(
			fdm_node.getNode("propulsion/tank[2]/transfer-first-lbs").getValue()
			+fdm_node.getNode("propulsion/tank[2]/transfer-second-lbs").getValue()
		)
	);

	fdm_node.getNode("propulsion/tank[3]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[3]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[3]/contents-lbs").getValue()
		)
		-(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
		(
			fdm_node.getNode("propulsion/tank[3]/transfer-first-lbs").getValue()
			+fdm_node.getNode("propulsion/tank[3]/transfer-second-lbs").getValue()
		)
	);

	fdm_node.getNode("propulsion/tank[4]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[4]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()
		)
		-(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
		(
			fdm_node.getNode("propulsion/tank[4]/transfer-first-lbs").getValue()
			+fdm_node.getNode("propulsion/tank[4]/transfer-second-lbs").getValue()
		)
	);

	fdm_node.getNode("propulsion/tank[5]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[5]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()
		)+
		fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()*
			-1.0*
			(fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)+
		-(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
			(1-fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue())*
		(
			fdm_node.getNode("propulsion/tank[5]/transfer-first-lbs").getValue()
			+fdm_node.getNode("propulsion/tank[5]/transfer-second-lbs").getValue()
		)
	);

	fdm_node.getNode("propulsion/tank[6]/transfer-lbs").setValue(
		fdm_node.getNode("systems/refill/on-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank[6]/capacity-lbs").getValue()
			-fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()
		)+
		fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue()*
		(
			fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()*
			-1.0*
			(fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()>
				fdm_node.getNode("propulsion/tank-leftover-lbs").getValue()
			)
		)+
		-(1-fdm_node.getNode("systems/refill/on-switch").getValue())*
			(1-fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue())*
		(
			fdm_node.getNode("propulsion/tank[6]/transfer-first-lbs").getValue()
			+fdm_node.getNode("propulsion/tank[6]/transfer-second-lbs").getValue()
		)
	);

	fdm_node.getNode("propulsion/tank[7]/transfer-lbs").setValue(
			# Refill if existed, not dropped, and comanded so
		(
			fdm_node.getNode("systems/refill/on-switch").getValue()
			*fdm_node.getNode("propulsion/tank[7]/existed").getValue()
			*(1-fdm_node.getNode("propulsion/tank[7]/drop").getValue())
			*(
				fdm_node.getNode("propulsion/tank[7]/capacity-lbs").getValue()
				-fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()
			)
		)
			# Flush at drop 
		+(
			(-1)
			*fdm_node.getNode("propulsion/tank[7]/existed").getValue()
			*fdm_node.getNode("propulsion/tank[7]/drop").getValue()
			*fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()
		)
			# Flush at nonexistence 
		+(
			(-1)
			*(1-fdm_node.getNode("propulsion/tank[7]/existed").getValue())
			*fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()
		)
			#Normal using
		+(
			(-1)
			*fdm_node.getNode("propulsion/tank[7]/existed").getValue()
			*(1-fdm_node.getNode("systems/refill/on-switch").getValue())
			*(1-fdm_node.getNode("propulsion/tank[7]/drop").getValue())
			*(
				fdm_node.getNode("propulsion/tank[7]/transfer-first-lbs").getValue()
				+fdm_node.getNode("propulsion/tank[7]/transfer-second-lbs").getValue()
			)
		)
	);

	fdm_node.getNode("propulsion/tank[8]/transfer-lbs").setValue(
			# Refill if existed, not dropped, and comanded so
		(
			fdm_node.getNode("systems/refill/on-switch").getValue()
			*fdm_node.getNode("propulsion/tank[8]/existed").getValue()
			*(1-fdm_node.getNode("propulsion/tank[8]/drop").getValue())
			*(
				fdm_node.getNode("propulsion/tank[8]/capacity-lbs").getValue()
				-fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()
			)
		)
			# Flush at drop 
		+(
			(-1)
			*fdm_node.getNode("propulsion/tank[8]/existed").getValue()
			*fdm_node.getNode("propulsion/tank[8]/drop").getValue()
			*fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()
		)
			# Flush at nonexistence 
		+(
			(-1)
			*(1-fdm_node.getNode("propulsion/tank[8]/existed").getValue())
			*fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()
		)
			#Normal using
		+(
			(-1)
			*fdm_node.getNode("propulsion/tank[8]/existed").getValue()
			*(1-fdm_node.getNode("systems/refill/on-switch").getValue())
			*(1-fdm_node.getNode("propulsion/tank[8]/drop").getValue())
			*(
				fdm_node.getNode("propulsion/tank[8]/transfer-first-lbs").getValue()
				+fdm_node.getNode("propulsion/tank[8]/transfer-second-lbs").getValue()
			)
		)
	);

	# External tanks are droppable

	drop=fdm_node.getNode("propulsion/tank[7]/drop").getValue();

	if
		(
			(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
			and (fdm_node.getNode("propulsion/tank[7]/existed").getValue()==1)
		)
	{	
		drop=0;
	}

	if
		(
			(
				(fdm_node.getNode("propulsion/tank[7]/existed").getValue()==1)
				and (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			)
			and
			(
				(fdm_node.getNode("systems/rightpanel/drop-switch").getValue()==1)
				or (fdm_node.getNode("systems/rightpanel/emergency-drop-switch").getValue()==1)
			)
			and
			(
				(fdm_node.getNode("systems/chutepanel/drop-tanks-switch").getValue()==1)
				or (fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue()==1)
			)
		)
	{	
		drop=1;
	}

	fdm_node.getNode("propulsion/tank[7]/drop").setValue(drop);

	state=fdm_node.getNode("propulsion/tank[7]/state").getValue();

	if
		(
			(fdm_node.getNode("propulsion/tank[7]/existed").getValue()==1)
			and (fdm_node.getNode("propulsion/tank[7]/drop").getValue()==0)
			and (fdm_node.getNode("breakage/exploded").getValue()==0)
			and (fdm_node.getNode("contact/unit[8]/WOW").getValue()==0)
		)
	{	
		state=1;
	}

	if
		(
			(fdm_node.getNode("propulsion/tank[7]/existed").getValue()==0)
			or (fdm_node.getNode("propulsion/tank[7]/drop").getValue()==1)
			or (fdm_node.getNode("breakage/exploded").getValue()==1)
			or (fdm_node.getNode("contact/unit[8]/WOW").getValue()==1)
		)
	{	
		state=0;
	}

	fdm_node.getNode("propulsion/tank[7]/state").setValue(state);

	drop=fdm_node.getNode("propulsion/tank[8]/drop").getValue();

	if
		(
			(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
			and (fdm_node.getNode("propulsion/tank[8]/existed").getValue()==1)
		)
	{	
		drop=0;
	}

	if
		(
			(
				(fdm_node.getNode("propulsion/tank[8]/existed").getValue()==1)
				and (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
				and (fdm_node.getNode("systems/electrical/on").getValue()==1)
			)
			and
			(
				(fdm_node.getNode("systems/rightpanel/drop-switch").getValue()==1)
				or (fdm_node.getNode("systems/rightpanel/emergency-drop-switch").getValue()==1)
			)
			and
			(
				(fdm_node.getNode("systems/chutepanel/drop-tanks-switch").getValue()==1)
				or (fdm_node.getNode("systems/middlepanels/drop-tanks-switch").getValue()==1)
			)
		)
	{	
		drop=1;
	}

	fdm_node.getNode("propulsion/tank[8]/drop").setValue(drop);

	state=fdm_node.getNode("propulsion/tank[8]/state").getValue();

	if
		(
			(fdm_node.getNode("propulsion/tank[8]/existed").getValue()==1)
			and (fdm_node.getNode("propulsion/tank[8]/drop").getValue()==0)
			and (fdm_node.getNode("breakage/exploded").getValue()==0)
			and (fdm_node.getNode("contact/unit[9]/WOW").getValue()==0)
		)
	{	
		state=1;
	}

	if
		(
			(fdm_node.getNode("propulsion/tank[8]/existed").getValue()==0)
			or (fdm_node.getNode("propulsion/tank[8]/drop").getValue()==1)
			or (fdm_node.getNode("breakage/exploded").getValue()==1)
			or (fdm_node.getNode("contact/unit[9]/WOW").getValue()==1)
		)
	{	
		state=0;
	}

	fdm_node.getNode("propulsion/tank[8]/state").setValue(state);

	# update propetries here, then transfer these to FG root ones at root loop

	fdm_node.getNode("propulsion/tank[2]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[2]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[2]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[3]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[3]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[3]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[4]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[4]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[4]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[5]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[5]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[5]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[6]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[6]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[6]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[7]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[7]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[7]/transfer-lbs").getValue()
	);

	fdm_node.getNode("propulsion/tank[8]/update-lbs").setValue(
		fdm_node.getNode("propulsion/tank[8]/contents-lbs").getValue()
		+fdm_node.getNode("propulsion/tank[8]/transfer-lbs").getValue()
	);

	# indication

	if (props.globals.getNode("sim/freeze/replay-state").getValue()==0)
	{	

		fdm_node.getNode("propulsion/engine[0]/starter-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/starter").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/cutoff-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/cutoff").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/temp-c-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/temp-c").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/temp-c-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/temp-c").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/augmentation-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/augmentation").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/burning-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/burning").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/broken-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/broken").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/nozzle-pos-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/nozzle-perc").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/intake-pos-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/intake-perc").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/n1-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/n1").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/n2-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/n2").getValue()
		);

		fdm_node.getNode("propulsion/engine[0]/thrust-lbs-ind").setValue(
			fdm_node.getNode("propulsion/engine[0]/thrust-lbs").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/starter-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/starter").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/cutoff-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/cutoff").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/temp-c-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/temp-c").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/temp-c-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/temp-c").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/augmentation-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/augmentation").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/burning-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/burning").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/broken-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/broken").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/nozzle-pos-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/nozzle-perc").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/intake-pos-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/intake-perc").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/n1-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/n1").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/n2-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/n2").getValue()
		);

		fdm_node.getNode("propulsion/engine[1]/thrust-lbs-ind").setValue(
			fdm_node.getNode("propulsion/engine[1]/thrust-lbs").getValue()
		);

		fdm_node.getNode("propulsion/tank[7]/state-ind").setValue(
			fdm_node.getNode("propulsion/tank[7]/state").getValue()
		);

		fdm_node.getNode("propulsion/tank[8]/state-ind").setValue(
			fdm_node.getNode("propulsion/tank[8]/state").getValue()
		);

	}

	# Additional nozzle radius calculaitions

	fdm_node.getNode("propulsion/engine[0]/nozzle-radius-ind").setValue(
		(
			(
				0.39222
				-0.4179
				*math.sin(
					interpol.lin_inter(
						[
							[0,		17.81],
							[28,	14.37],
							[46,	10.86],
							[64,	6.78],
							[82,	2.99],
							[100,	0.0]
						],
						fdm_node.getNode("propulsion/engine[0]/nozzle-pos-ind").getValue()
					)*0.017453
				)
			)
		)/0.39222
	);

	fdm_node.getNode("propulsion/engine[1]/nozzle-radius-ind").setValue(
		(
			(
				0.39222
				-0.4179
				*math.sin(
					interpol.lin_inter(
						[
							[0,		17.81],
							[28,	14.37],
							[46,	10.86],
							[64,	6.78],
							[82,	2.99],
							[100,	0.0]
						],
						fdm_node.getNode("propulsion/engine[1]/nozzle-pos-ind").getValue()
					)*0.017453
				)
			)
		)/0.39222
	);

	fdm_node.getNode("propulsion/init").setValue(1);

	settimer(func propulsion(), 0.2); 

}

# initialisation  -------------------------------------------------

#timer is used to asyncronize fps load with other nasal systems

settimer(func propulsion(), 0.37);
