# -----------------------------------------------------------------------
# R8R halfactive radar homing missile.

# missile position recalculation ----------------------------------------

# timer, common for physics calculations and radar

r8r_time=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");

	#time tick calculating

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("time-sec").getValue();
	if ((time_sec == nil) or
		(time_sec_prev == nil))
	{
		settimer(func r8r_time(), 1.0);
		return;
	}

	tick_sec=time_sec-time_sec_prev;

	#without time passng there is nothing to do

	if (tick_sec <= 0) 
	{
		settimer(func r8r_time(), 1.0);
		return;
	}

	fdm_node.getNode("time-sec").setValue(time_sec);
	fdm_node.getNode("tick-sec").setValue(tick_sec);

	r8r_math();
	aim_r8r();

	if (
		(fdm_node.getNode("state/flying").getValue() == 1) or
		(fdm_node.getNode("state/aimed").getValue() == 1)
	)
	{
		settimer(func r8r_time(), 0.2);
	}
	else
	{
		settimer(func r8r_time(), 1.0);
	}
	return;

}

# missile position recalculation ----------------------------------------

#just same as for R8T, only drag a bit smaller

r8r_math=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");

	#time tick receiving

	tick_sec=fdm_node.getNode("tick-sec").getValue();
	if (tick_sec == nil)
	{
		return;
	}

	#without time passng there is nothing to calculate

	if (tick_sec <= 0) 
	{
		return;
	}

	root_node=props.globals.getNode("");
	plane_node=props.globals.getNode("fdm/jsbsim");

	#offset positions speeds

	#Rotate offset mounted rocked point with plane,
	#to get new coordinates in north, east, up.

	#roll rotation

	n_m=fdm_node.getNode("offset/x-m").getValue();
	fdm_node.getNode("offset/neu/roll-rotated/n-m").setValue(n_m);

	e_m=fdm_node.getNode("offset/y-m").getValue()*
		math.cos(root_node.getNode("orientation/roll-deg").getValue()/57.2957795)+
		fdm_node.getNode("offset/z-m").getValue()*
		math.sin(root_node.getNode("orientation/roll-deg").getValue()/57.2957795);
	fdm_node.getNode("offset/neu/roll-rotated/e-m").setValue(e_m);

	u_m=(-1)*fdm_node.getNode("offset/y-m").getValue()*
		math.sin(root_node.getNode("orientation/roll-deg").getValue()/57.2957795)+
		fdm_node.getNode("offset/z-m").getValue()*
		math.cos(root_node.getNode("orientation/roll-deg").getValue()/57.2957795);
	fdm_node.getNode("offset/neu/roll-rotated/u-m").setValue(u_m);

	#pitch rotation

	n_m=fdm_node.getNode("offset/neu/roll-rotated/n-m").getValue()*
		math.cos(root_node.getNode("orientation/pitch-deg").getValue()/57.2957795)+
		(-1)*fdm_node.getNode("offset/neu/roll-rotated/u-m").getValue()*
		math.sin(root_node.getNode("orientation/pitch-deg").getValue()/57.2957795);
	fdm_node.getNode("offset/neu/pitch-rotated/n-m").setValue(n_m);

	e_m=fdm_node.getNode("offset/neu/roll-rotated/e-m").getValue();
	fdm_node.getNode("offset/neu/pitch-rotated/e-m").setValue(e_m);

	u_m=fdm_node.getNode("offset/neu/roll-rotated/n-m").getValue()*
		math.sin(root_node.getNode("orientation/pitch-deg").getValue()/57.2957795)+
		fdm_node.getNode("offset/neu/roll-rotated/u-m").getValue()*
		math.cos(root_node.getNode("orientation/pitch-deg").getValue()/57.2957795);
	fdm_node.getNode("offset/neu/pitch-rotated/u-m").setValue(u_m);

	#heading rotation

	n_m=fdm_node.getNode("offset/neu/pitch-rotated/n-m").getValue()*
		math.cos(root_node.getNode("orientation/heading-deg").getValue()/57.2957795)+
		(-1)*fdm_node.getNode("offset/neu/pitch-rotated/e-m").getValue()*
		math.sin(root_node.getNode("orientation/heading-deg").getValue()/57.2957795);
	fdm_node.getNode("offset/neu/heading-rotated/n-m").setValue(n_m);

	e_m=fdm_node.getNode("offset/neu/pitch-rotated/n-m").getValue()*
		math.sin(root_node.getNode("orientation/heading-deg").getValue()*57.2957795)+
		fdm_node.getNode("offset/neu/pitch-rotated/e-m").getValue()*
		math.cos(root_node.getNode("orientation/heading-deg").getValue()*57.2957795);
	fdm_node.getNode("offset/neu/heading-rotated/e-m").setValue(e_m);

	u_m=fdm_node.getNode("offset/neu/pitch-rotated/u-m").getValue();
	fdm_node.getNode("offset/neu/heading-rotated/u-m").setValue(u_m);

	#output

	n_m=fdm_node.getNode("offset/neu/heading-rotated/n-m").getValue();
	fdm_node.getNode("offset/neu/n-m").setValue(n_m);

	e_m=fdm_node.getNode("offset/neu/heading-rotated/e-m").getValue();
	fdm_node.getNode("offset/neu/e-m").setValue(e_m);

	u_m=fdm_node.getNode("offset/neu/heading-rotated/u-m").getValue();
	fdm_node.getNode("offset/neu/u-m").setValue(u_m);

	n_m=fdm_node.getNode("offset/neu/heading-rotated/n-m").getValue();
	fdm_node.getNode("offset/n-m").setValue(n_m);

	e_m=fdm_node.getNode("offset/neu/heading-rotated/e-m").getValue();
	fdm_node.getNode("offset/e-m").setValue(e_m);

	u_m=fdm_node.getNode("offset/neu/heading-rotated/u-m").getValue();
	fdm_node.getNode("offset/u-m").setValue(u_m);

	#calculated offset in lat, lon, alt

	offset_latitude_deg=root_node.getNode("position/latitude-deg").getValue()+
		fdm_node.getNode("offset/n-m").getValue()/111319;
	fdm_node.getNode("offset/neu/latitude-deg").setValue(offset_latitude_deg);

	offset_longitude_deg=root_node.getNode("position/longitude-deg").getValue()+
		(fdm_node.getNode("offset/e-m").getValue()/111319)/
		math.cos(root_node.getNode("position/latitude-deg").getValue()/57.2957795);
	fdm_node.getNode("offset/neu/longitude-deg").setValue(offset_longitude_deg);

	offset_elevation_ft=root_node.getNode("position/altitude-ft").getValue()+
		fdm_node.getNode("offset/u-m").getValue()*
		3.28083989;
	fdm_node.getNode("offset/neu/elevation-ft").setValue(offset_elevation_ft);

	#output with limit on strange case of polar or ocean flight

	if ((offset_longitude_deg >= -360) and
		(offset_longitude_deg < -180))
	{
		offset_longitude_deg=offset_longitude_deg+360;
		fdm_node.getNode("offset/longitude-deg").setValue(offset_longitude_deg);
	}
	else
	{
		if ((offset_longitude_deg >= -180) and
			(offset_longitude_deg <= 180))
		{
			fdm_node.getNode("offset/longitude-deg").setValue(offset_longitude_deg);
		}
		else
		{
			offset_longitude_deg=offset_longitude_deg-360;
			fdm_node.getNode("offset/longitude-deg").setValue(offset_longitude_deg);
		}
	}

	if ((offset_latitude_deg >= -360) and
		(offset_latitude_deg < -180))
	{
		offset_latitude_deg=offset_latitude_deg+360;
		fdm_node.getNode("offset/latitude-deg").setValue(offset_latitude_deg);
	}
	else
	{
		if ((offset_latitude_deg >= -180) and
			(offset_latitude_deg <= 180))
		{
			fdm_node.getNode("offset/latitude-deg").setValue(offset_latitude_deg);
		}
		else
		{
			offset_latitude_deg=offset_latitude_deg-360;
			fdm_node.getNode("offset/latitude-deg").setValue(offset_latitude_deg);
		}
	}

	fdm_node.getNode("offset/elevation-ft").setValue(offset_elevation_ft);

	#precount offset angles

	offset_pitch_rad=root_node.getNode("orientation/pitch-deg").getValue()/57.2957795+
		fdm_node.getNode("offset/pitch-deg").getValue()/
		57.2957795;
	fdm_node.getNode("offset/pitch-rad").setValue(offset_pitch_rad);

	#roll rotation is ommited due to simplification

#	offset_roll_rad=root_node.getNode("orientation/roll-deg").getValue()/57.2957795+
#		fdm_node.getNode("offset/roll-deg").getValue()/
#		57.2957795;

	offset_roll_rad=0;

	fdm_node.getNode("offset/roll-rad").setValue(offset_roll_rad);

	offset_yaw_rad=root_node.getNode("orientation/heading-deg").getValue()/57.2957795+
		fdm_node.getNode("offset/yaw-deg").getValue()/
		57.2957795;
	fdm_node.getNode("offset/yaw-rad").setValue(offset_yaw_rad);

# not flying missile does not need any calculations in that section
	if (fdm_node.getNode("state/flying").getValue() == 1)
	{

		#pre calculations, data needed for aerodynamics

		#summar speed

		summar_fps=math.pow((
			math.pow(fdm_node.getNode("velocities/fsu/f-fps").getValue(), 2)+
			math.pow(fdm_node.getNode("velocities/fsu/s-fps").getValue(), 2)+
			math.pow(fdm_node.getNode("velocities/fsu/u-fps").getValue(), 2)
			), 0.5);
		fdm_node.getNode("velocities/summar-fps").setValue(summar_fps);

		#mach number

		#At time it made, 2016, nasal can not interpolate value from table still,
		#so tables translated to equations,
		#with coefficients received by R polynomal interpolation.
		#Where y dependance on x seems to be too complex 
		#to be expressed by one formula, case is divided
		#on working parts by if..then construtctions.

		#As example, depending of Mach number on elevation was
		#divided on three parts, at two it is linear, at third is constant

		elevation_ft=fdm_node.getNode("elevation-ft").getValue();
		if (elevation_ft <= 35000)
		{
			mach=fdm_node.getNode("velocities/summar-fps").getValue()/
				(1.118e+03+(-4.119e-03)*elevation_ft);
		}
		else
		{
			if ((elevation_ft > 35000) and
				(elevation_ft <= 80000)
				)
			{
				mach=fdm_node.getNode("velocities/summar-fps").getValue()/968.0;
			}
			else
			{
				mach=fdm_node.getNode("velocities/summar-fps").getValue()/
					(9.245e+02+(6.632e-04)*elevation_ft);
			}
		}

		#Easier and better approach - own interpolation tables

		mach=
			fdm_node.getNode("velocities/summar-fps").getValue()/
			interpol.lin_inter(
				[
					[0,				1116],
					[5000,		1097],
					[10000,		1077],
					[15000,		1057],
					[20000,		1036],
					[25000,		1016],
					[30000,		994],
					[35000,		973],
					[40000,		968],
					[45000,		968],
					[50000,		968],
					[60000,		968],
					[70000,		970],
					[80000,		977],
					[90000,		984],
					[100000,	990],
					[150000,	1073],
					[200000,	1028],
					[250000,	944]
				],
				elevation_ft
			);

		fdm_node.getNode("velocities/mach").setValue(mach);	

		#dynamic pressure

		#As example, fit to initial data set was found at RKWard
		#by next code:

		#y <- my.data[["y"]]
		#x <- my.data[["x"]]
		#m <- nls(y~a+b*x^c+d*x^(2*c),start=list(a=0.002048, b=1, c=1, d=1))
		#plot
		#plot(x,y)
		#lines(x,predict(m),lty=2,col="red",lwd=3)
		#summary(m)
		
		qbar_psf=math.pow(fdm_node.getNode("velocities/summar-fps").getValue(), 2)*
			0.5*
			(2.392e-03+
				(-1.831e-07)*math.pow(math.abs(elevation_ft), 0.8957)+
				(3.608e-12)*math.pow(math.abs(elevation_ft), (0.8957*2))
			);

		#Easier and better approach - own interpolation tables

		qbar_psf=
			math.pow(fdm_node.getNode("velocities/summar-fps").getValue(), 2)*
			0.5*
			0.0001*
			interpol.lin_inter(
				[
					[0.0,			23.7700],
					[5000,		20.4800],
					[10000,		17.5600],
					[15000,		14.9600],
					[20000,		12.6700],
					[25000,		10.6600],
					[30000,		8.9100],
					[35000,		7.3800],
					[40000,		5.8700],
					[45000,		4.6200],
					[50000,		3.6400],
					[60000,		2.2600],
					[70000,		1.3900],
					[80000,		0.8600],
					[90000,		0.5600],
					[100000,	0.3300],
					[150000,	0.0370],
					[200000,	0.0053],
					[250000,	0.0007]
				],
				elevation_ft
			);

		fdm_node.getNode("aero/qbar-psf").setValue(qbar_psf);

		#alpha

		alpha_rad=(-1)*
			math.atan2(fdm_node.getNode("velocities/fsu/u-fps").getValue(),
				fdm_node.getNode("velocities/fsu/f-fps").getValue());
		fdm_node.getNode("aero/alpha-rad").setValue(alpha_rad);

		#speed of alpha changing is acounted as rough differential

		alpha_rad_prev=fdm_node.getNode("aero/alpha-rad-prev").getValue();
		alpha_rad_sec=(alpha_rad-alpha_rad_prev)/tick_sec;
		fdm_node.getNode("pids/alpha-rad-sec").setValue(alpha_rad_sec);
		fdm_node.getNode("aero/alpha-rad-prev").setValue(alpha_rad);

		#beta

		beta_rad=(-1)*
			math.atan2(fdm_node.getNode("velocities/fsu/s-fps").getValue(),
				fdm_node.getNode("velocities/fsu/f-fps").getValue());
		fdm_node.getNode("aero/beta-rad").setValue(beta_rad);

		beta_rad_prev=fdm_node.getNode("aero/beta-rad-prev").getValue();
		beta_rad_sec=(beta_rad-beta_rad_prev)/tick_sec;
		fdm_node.getNode("pids/beta-rad-sec").setValue(beta_rad_sec);
		fdm_node.getNode("aero/beta-rad-prev").setValue(beta_rad);

		#ci2vel

		ci2vel=fdm_node.getNode("data/wingchord-ft").getValue()/
			(fdm_node.getNode("velocities/summar-fps").getValue()*2);
		fdm_node.getNode("aero/ci2vel").setValue(ci2vel);

		#bi2vel

		bi2vel=fdm_node.getNode("data/wingspan-ft").getValue()/
			(fdm_node.getNode("velocities/summar-fps").getValue()*2);
		fdm_node.getNode("aero/bi2vel").setValue(bi2vel);

		#Control surfaces and missile moments are omitted at simplified nasal model.
		#Instead, maximum turn velocities are calculated on different
		#dynamical pressures, and it's postulated that model can make such turns
		#until it has power for controlled flight.

		#Automation is driven by proportional rule.

		elevator_norm=fdm_node.getNode("control/surfaces/elevator-norm").getValue();
		rudder_norm=fdm_node.getNode("control/surfaces/rudder-norm").getValue();

		#Roll rotation is ommited, implying missile is just stable

	}

	#engine and puffer are calculated always, as needed to reset
	#at not fling state

	#engine

	#start

	if (
		(fdm_node.getNode("engine/start").getValue()==0) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("state/launch").getValue()==1) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("engine/start").setValue(1);
	}

	if (
		(fdm_node.getNode("engine/start").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("state/launch").getValue()==0) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("engine/start").setValue(0);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("engine/start").setValue(0);
	}

	#started

	if (
		(fdm_node.getNode("engine/start").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==1) and
		(fdm_node.getNode("engine/started").getValue()==0) and
		(fdm_node.getNode("engine/finished").getValue()==0) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("engine/started").setValue(1);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("engine/started").setValue(0);
	}

	#Since stability is not accounted, it would be possible
	#to make rude fast drive engine. But to not rethink anything,
	#initial jsb working scheme is reserved,
	#with 5 seconds of work and smooth start and stop.

	#engine work timer

	if (fdm_node.getNode("engine/started").getValue()==1)
	{
		engine_working_pos=fdm_node.getNode("engine/working-pos").getValue();
		engine_working_sec=fdm_node.getNode("engine/working-sec").getValue();
		if (engine_working_pos<1)
		{
			engine_working_pos=engine_working_pos+tick_sec/fdm_node.getNode("data/engine-worktime-s").getValue();
			engine_working_sec=engine_working_sec+tick_sec;
		}
	}
	else
	{
		engine_working_pos=0;
		engine_working_sec=0;
	}

	fdm_node.getNode("engine/working-pos").setValue(engine_working_pos);
	fdm_node.getNode("engine/working-sec").setValue(engine_working_sec);

	#engine working flag

	if (
		(fdm_node.getNode("engine/started").getValue()==1) and
		(fdm_node.getNode("engine/finished").getValue()==0))
	{
		fdm_node.getNode("engine/working").setValue(1);
	}

	if (
		(fdm_node.getNode("engine/started").getValue()==0) or
		(fdm_node.getNode("engine/finished").getValue()==1))
	{
		fdm_node.getNode("engine/working").setValue(0);
	}

	#engine finished flag

	if (
		(fdm_node.getNode("engine/started").getValue()==1) and
		(fdm_node.getNode("engine/finished").getValue()==0) and
		(fdm_node.getNode("engine/working-pos").getValue()>=1) and
		(fdm_node.getNode("control/reset").getValue()==0))
	{
		fdm_node.getNode("engine/finished").setValue(1);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("engine/finished").setValue(0);
	}

	#puffer
			
	#Puffer is mechanical or pneumatic, taking 
	#a bit of intake turbine air, device which 
	#pushes down missile at launch,
	#to avoid collision with it.
	#It goes both at launch and drop.

	#start

	if (
		(fdm_node.getNode("puffer/start").getValue()==0) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("state/launch").getValue()==1) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("puffer/start").setValue(1);
	}

	if (
		(fdm_node.getNode("puffer/start").getValue()==0) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("state/drop").getValue()==1) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("puffer/start").setValue(1);
	}

	if (
		(fdm_node.getNode("puffer/start").getValue()==0) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("state/launch").getValue()==0) and
		(fdm_node.getNode("state/drop").getValue()==0) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("puffer/start").setValue(0);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("puffer/start").setValue(0);
	}

	#started

	if (
		(fdm_node.getNode("puffer/start").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==1) and
		(fdm_node.getNode("puffer/started").getValue()==0) and
		(fdm_node.getNode("puffer/finished").getValue()==0) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("puffer/started").setValue(1);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("puffer/started").setValue(0);
	}

	#puffer work timer
	#a bit prologed, since minimal nasal tick seems to be 0.1sec

	if (fdm_node.getNode("puffer/started").getValue()==1)
	{
		puffer_working_pos=fdm_node.getNode("puffer/working-pos").getValue();
		if (puffer_working_pos<1)
		{
			puffer_working_pos=puffer_working_pos+tick_sec*0.333;
		}
	}
	else
	{
		puffer_working_pos=0;
	}

	fdm_node.getNode("puffer/working-pos").setValue(puffer_working_pos);

	#puffer working flag

	if (
		(fdm_node.getNode("puffer/started").getValue()==1) and
		(fdm_node.getNode("puffer/finished").getValue()==0))
	{
		fdm_node.getNode("puffer/working").setValue(1);
	}

	if (
		(fdm_node.getNode("puffer/started").getValue()==0) or
		(fdm_node.getNode("puffer/finished").getValue()==1))
	{
		fdm_node.getNode("puffer/working").setValue(0);
	}

	#puffer finished flag

	if (
		(fdm_node.getNode("puffer/started").getValue()==1) and
		(fdm_node.getNode("puffer/finished").getValue()==0) and
		(fdm_node.getNode("puffer/working-pos").getValue()>=1) and
		(fdm_node.getNode("control/reset").getValue()==0))
	{
		fdm_node.getNode("puffer/finished").setValue(1);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("puffer/finished").setValue(0);
	}

# not flying missile does not need any calculations in that section

	if (fdm_node.getNode("state/flying").getValue() == 1)
	{

		#forces calculations

		#puffer force

		#initial

		fdm_node.getNode("forces/puffer/initial/forward-lbs").setValue(0);
		fdm_node.getNode("forces/puffer/initial/side-lbs").setValue(0);
		lift_lbs=(-1)*fdm_node.getNode("data/puffer-force-lbs").getValue()*
			fdm_node.getNode("puffer/working").getValue();
		fdm_node.getNode("forces/puffer/initial/lift-lbs").setValue(lift_lbs);

		#roll rotation

		forward_lbs=fdm_node.getNode("forces/puffer/initial/forward-lbs").getValue();
		fdm_node.getNode("forces/puffer/roll-rotated/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/puffer/initial/side-lbs").getValue()*
			math.cos(
				fdm_node.getNode("roll-rad").getValue()-
				root_node.getNode("orientation/roll-deg").getValue()/57.2957795)+
			(-1)*fdm_node.getNode("forces/puffer/initial/lift-lbs").getValue()*
			math.sin(
				fdm_node.getNode("roll-rad").getValue()-
				root_node.getNode("orientation/roll-deg").getValue()/57.2957795);
		fdm_node.getNode("forces/puffer/roll-rotated/side-lbs").setValue(side_lbs);

		lift_lbs=fdm_node.getNode("forces/puffer/initial/side-lbs").getValue()*
			math.sin(
				fdm_node.getNode("roll-rad").getValue()-
				root_node.getNode("orientation/roll-deg").getValue()/57.2957795)+
			fdm_node.getNode("forces/puffer/initial/lift-lbs").getValue()*
			math.cos(
				fdm_node.getNode("roll-rad").getValue()-
				root_node.getNode("orientation/roll-deg").getValue()/57.2957795);
		fdm_node.getNode("forces/puffer/roll-rotated/lift-lbs").setValue(lift_lbs);

		#pitch rotation

		forward_lbs=fdm_node.getNode("forces/puffer/roll-rotated/forward-lbs").getValue()*
			math.cos(
				fdm_node.getNode("pitch-rad").getValue()-
				root_node.getNode("orientation/pitch-deg").getValue()/57.2957795)+
			fdm_node.getNode("forces/puffer/roll-rotated/lift-lbs").getValue()*
			math.sin(
				fdm_node.getNode("pitch-rad").getValue()-
				root_node.getNode("orientation/pitch-deg").getValue()/57.2957795);
		fdm_node.getNode("forces/puffer/pitch-rotated/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/puffer/roll-rotated/side-lbs").getValue();
		fdm_node.getNode("forces/puffer/pitch-rotated/side-lbs").setValue(side_lbs);

		lift_lbs=(-1)*fdm_node.getNode("forces/puffer/roll-rotated/forward-lbs").getValue()*
			math.sin(
				fdm_node.getNode("pitch-rad").getValue()-
				root_node.getNode("orientation/pitch-deg").getValue()/57.2957795)+
			fdm_node.getNode("forces/puffer/roll-rotated/lift-lbs").getValue()*
			math.cos(
				fdm_node.getNode("pitch-rad").getValue()-
				root_node.getNode("orientation/pitch-deg").getValue()/57.2957795);
		fdm_node.getNode("forces/puffer/pitch-rotated/lift-lbs").setValue(lift_lbs);

		#heading rotation

		forward_lbs=fdm_node.getNode("forces/puffer/pitch-rotated/forward-lbs").getValue()*
			math.cos(
				fdm_node.getNode("yaw-rad").getValue()-
				root_node.getNode("orientation/heading-deg").getValue()/57.2957795)+
			(-1)*fdm_node.getNode("forces/puffer/pitch-rotated/side-lbs").getValue()*
			math.sin(
				fdm_node.getNode("yaw-rad").getValue()-
				root_node.getNode("orientation/heading-deg").getValue()/57.2957795);
		fdm_node.getNode("forces/puffer/heading-rotated/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/puffer/pitch-rotated/forward-lbs").getValue()*
			math.sin(
				fdm_node.getNode("yaw-rad").getValue()-
				root_node.getNode("orientation/heading-deg").getValue()/57.2957795)+
			fdm_node.getNode("forces/puffer/pitch-rotated/side-lbs").getValue()*
			math.cos(
				fdm_node.getNode("yaw-rad").getValue()-
				root_node.getNode("orientation/heading-deg").getValue()/57.2957795);
		fdm_node.getNode("forces/puffer/heading-rotated/side-lbs").setValue(side_lbs);

		lift_lbs=fdm_node.getNode("forces/puffer/pitch-rotated/lift-lbs").getValue();
		fdm_node.getNode("forces/puffer/heading-rotated/lift-lbs").setValue(lift_lbs);

		#output

		forward_lbs=fdm_node.getNode("forces/puffer/heading-rotated/forward-lbs").getValue();
		fdm_node.getNode("forces/puffer/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/puffer/heading-rotated/side-lbs").getValue();
		fdm_node.getNode("forces/puffer/side-lbs").setValue(side_lbs);

		lift_lbs=fdm_node.getNode("forces/puffer/heading-rotated/lift-lbs").getValue();
		fdm_node.getNode("forces/puffer/lift-lbs").setValue(lift_lbs);

		#gravity

		#Gravity force is vector of weight lbs pointing down.
		#Recalculate it to three vectors according to
		#missile rotation. Note that yaw rotation
		#does not matter there.

		#initial

		fdm_node.getNode("forces/gravity/initial/forward-lbs").setValue(0);
		fdm_node.getNode("forces/gravity/initial/side-lbs").setValue(0);
		lift_lbs=(-1)*fdm_node.getNode("data/weight-lbs").getValue();
		fdm_node.getNode("forces/gravity/initial/lift-lbs").setValue(lift_lbs);

		#pitch rotation

		forward_lbs=fdm_node.getNode("forces/gravity/initial/forward-lbs").getValue()*
			math.cos(fdm_node.getNode("pitch-rad").getValue())+
			fdm_node.getNode("forces/gravity/initial/lift-lbs").getValue()*
			math.sin(fdm_node.getNode("pitch-rad").getValue());
		fdm_node.getNode("forces/gravity/pitch-rotated/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/gravity/initial/side-lbs").getValue();
		fdm_node.getNode("forces/gravity/pitch-rotated/side-lbs").setValue(side_lbs);

		lift_lbs=(-1)*fdm_node.getNode("forces/gravity/initial/forward-lbs").getValue()*
			math.sin(fdm_node.getNode("pitch-rad").getValue())+
			fdm_node.getNode("forces/gravity/initial/lift-lbs").getValue()*
			math.cos(fdm_node.getNode("pitch-rad").getValue());
		fdm_node.getNode("forces/gravity/pitch-rotated/lift-lbs").setValue(lift_lbs);

		#roll rotation

		forward_lbs=fdm_node.getNode("forces/gravity/pitch-rotated/forward-lbs").getValue();
		fdm_node.getNode("forces/gravity/roll-rotated/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/gravity/pitch-rotated/side-lbs").getValue()*
			math.cos(fdm_node.getNode("roll-rad").getValue())+
			(-1)*fdm_node.getNode("forces/gravity/pitch-rotated/lift-lbs").getValue()*
			math.sin(fdm_node.getNode("roll-rad").getValue());
		fdm_node.getNode("forces/gravity/roll-rotated/side-lbs").setValue(side_lbs);

		lift_lbs=fdm_node.getNode("forces/gravity/pitch-rotated/side-lbs").getValue()*
			math.sin(fdm_node.getNode("roll-rad").getValue())+
			fdm_node.getNode("forces/gravity/pitch-rotated/lift-lbs").getValue()*
			math.cos(fdm_node.getNode("roll-rad").getValue());
		fdm_node.getNode("forces/gravity/roll-rotated/lift-lbs").setValue(lift_lbs);

		#output

		forward_lbs=fdm_node.getNode("forces/gravity/roll-rotated/forward-lbs").getValue();
		fdm_node.getNode("forces/gravity/forward-lbs").setValue(forward_lbs);

		side_lbs=fdm_node.getNode("forces/gravity/roll-rotated/side-lbs").getValue();
		fdm_node.getNode("forces/gravity/side-lbs").setValue(side_lbs);

		lift_lbs=fdm_node.getNode("forces/gravity/roll-rotated/lift-lbs").getValue();
		fdm_node.getNode("forces/gravity/lift-lbs").setValue(lift_lbs);

		#Engine force is pointed forward directly,
		#but it's possible to add similar calculations to make rotated nozzle.
		#Though it would be needed with maneurable missile only anyway.

		#Note that force of it depends on second of worktime
		#as defined earlier, and softened to avoid overgs
		#at start and finish.

		#Also, it's three part, as it was with
		#Mach on elevation depending account

		if (engine_working_sec <= 0.15)
		{
			engine_norm=engine_working_sec*33.333;
		}
		else
		{
			if ((engine_working_sec > 0.15) and
				(engine_working_pos < 0.15)
				)
			{
				engine_norm=1.0;
			}
			else
			{
				engine_norm=-0.186486+0.177799/engine_working_pos;
			}
		}
		engine_lbs=engine_norm*
			fdm_node.getNode("state/flying").getValue()*
			fdm_node.getNode("engine/working").getValue()*
			fdm_node.getNode("data/engine-force-lbs").getValue();
		fdm_node.getNode("forces/engine-lbs").setValue(engine_lbs);

		#drag force

		#Here comes tricky part. As way to calculate 3D regression on two independend values
		#didnot give results at R, dependance of forces at angles and Mach numbers is
		#calculated by two parts.

		#At first drag dependence on angle was calculated
		#via lm regression at R, for all data 2.0Mach.

		#Formula: y ~ (a + c * x + b * x^2)

		#Parameters:
		#  Estimate Std. Error t value Pr(>|t|)    
		#a 0.022125   0.006521   3.393  0.00796 ** 
		#b 0.812844   0.022270  36.499 4.31e-11 ***

		#where y=coeff, x=alpha.
		#c went out to be not meaningful and was dropped.

		#Then dependence of drag on Mach was calculated,
		#at angle alpha=0rad, at oversonic only.

		#Formula: y ~ a + b * x + c * x^2

		#Parameters:
		#    Estimate Std. Error t value Pr(>|t|)    
		#a  3.393e-02  6.234e-04   54.42 3.96e-08 ***
		#b -9.492e-03  4.595e-04  -20.66 4.92e-06 ***
		#c  9.490e-04  7.519e-05   12.62 5.55e-05 ***

		#where y=coeff, x=mach.

		#Then, resulted formula should be something as

		#Formula: z ~ a + (b * y + c * y^2) * (d + x^2)
		#where z=coeff, y=mach, x=alpha.

		#Data was put at table of
		#x=alpha y=mach z=coeff 
		#form, all oversonic values for alpha_rad=0,
		#all oversonic values for alpha_rad=0.1745,
		#all values for mach=2.0,
		#and more or less correct results was received for that 
		#major cases altogether

		#Formula: z ~ a + (b * y + c * y^2) * (d + x^2)

		#Parameters:
		#  Estimate Std. Error t value Pr(>|t|)    
		#a  0.05271    0.01331   3.959 0.001013 ** 
		#b  0.55401    0.03624  15.286 2.29e-11 ***
		#c -0.07009    0.01661  -4.219 0.000578 ***
		#d -0.04590    0.01575  -2.914 0.009668 **

		#At subsonic, as missile meaningfully 
		#works at oversonic only, result was approximated roughly as
		#constant.

		if (mach >= 1.0)
		{
			drag_coeff=0.03314+(0.55401*mach-0.07009*math.pow(mach,2))*
				(-0.02696 + math.pow(alpha_rad,2));
		}
		else
		{
			drag_coeff=0.03314+(0.55401-0.07009)*
				(-0.02696 + math.pow(alpha_rad,2));
		}

		#Thats it.

		#Easier and better approach - own interpolation tables

		drag_coeff=
			interpol.sqr_inter(
				[
					[0.0000,		0.0000,	0.3000,	0.4000,	0.5000,	0.9000,	1.1000,	1.5000,	2.0000,	2.5000,	3.0000,	3.5000,	4.0000,	5.0000],
					[-0.7854,		0.0000,	0.7872,	0.7586,	0.7282,	0.6692,	0.7072,	0.6087,	0.5102,	0.7314,	0.9525,	0.9920,	1.0270,	1.0977],
					[-0.5236,		0.0000,	0.5292,	0.5099,	0.4887,	0.4482,	0.3899,	0.3310,	0.2721,	0.3361,	0.4000,	0.3766,	0.3615,	0.3729],
					[-0.3491,		0.0000,	0.2597,	0.2518,	0.2439,	0.2281,	0.1657,	0.1480,	0.1303,	0.1380,	0.1457,	0.1405,	0.1345,	0.1299],
					[-0.1745,		0.0000,	0.0551,	0.0534,	0.0519,	0.0487,	0.0488,	0.0437,	0.0387,	0.0362,	0.0336,	0.0319,	0.0307,	0.0289],
					[-0.0873,		0.0000,	0.0180,	0.0173,	0.0167,	0.0154,	0.0247,	0.0216,	0.0184,	0.0161,	0.0139,	0.0126,	0.0121,	0.0114],
					[0.0000,		0.0000,	0.0095,	0.0090,	0.0086,	0.0077,	0.0186,	0.0156,	0.0125,	0.0105,	0.0084,	0.0073,	0.0071,	0.0069],
					[0.0873,		0.0000,	0.0180,	0.0173,	0.0167,	0.0154,	0.0247,	0.0216,	0.0184,	0.0161,	0.0139,	0.0126,	0.0121,	0.0114],
					[0.1745,		0.0000,	0.0551,	0.0534,	0.0519,	0.0487,	0.0488,	0.0437,	0.0387,	0.0362,	0.0336,	0.0319,	0.0307,	0.0289],
					[0.3491,		0.0000,	0.2597,	0.2518,	0.2439,	0.2281,	0.1657,	0.1480,	0.1303,	0.1380,	0.1457,	0.1405,	0.1345,	0.1299],
					[0.5236,		0.0000,	0.5292,	0.5099,	0.4887,	0.4482,	0.3899,	0.3310,	0.2721,	0.3361,	0.4000,	0.3766,	0.3615,	0.3729],
					[0.7854,		0.0000,	0.4264,	0.4206,	0.4150,	0.4036,	0.7072,	0.6087,	0.5102,	0.7314,	0.9525,	0.9920,	1.0270,	1.0977]
				],
				alpha_rad,
				mach
			);

		aero_drag_lbs=fdm_node.getNode("aero/qbar-psf").getValue()*
			fdm_node.getNode("data/Sw-sqft").getValue()*
			drag_coeff;
		fdm_node.getNode("forces/aero-drag-lbs").setValue(aero_drag_lbs);

		#summar forward force

		forward_lbs=fdm_node.getNode("forces/gravity/forward-lbs").getValue()+
			fdm_node.getNode("forces/puffer/forward-lbs").getValue()+
			fdm_node.getNode("forces/engine-lbs").getValue()+
			(-1)*fdm_node.getNode("forces/aero-drag-lbs").getValue();
		fdm_node.getNode("forces/forward-lbs").setValue(forward_lbs);

		#aerodynamical lift force

		#Dependance on alpha at that case looks as coeff=a*alpha_rad+b*alpha_rad^3
		#formula.
		#As of Mach, both
		#coeff ~ (a+b/mach)
		#coeff ~ (a+b*mach+c*mach^2)
		#proposed results of similar quality,
		#but first looking more realistic.
		#So, at resulted crosstable,
		#at now including all data

		#Formula: coeff ~ (a + b/mach) * (alpha + c * alpha^3)

		#Parameters:
		#  Estimate Std. Error t value Pr(>|t|)    
		#a  0.45114    0.07768   5.808 2.67e-05 ***
		#b  1.25729    0.15585   8.067 4.97e-07 ***
		#c -0.14855    0.04912  -3.024  0.00806 ** 

		#That was become quite close to source, +-10%.

		if (mach >= 1.0)
		{
			lift_coeff=(0.45114+1.25729/mach)*
				(alpha_rad-0.14855*math.pow(alpha_rad, 3));
		}
		else
		{
			lift_coeff=(0.45114+1.25729)*
				(alpha_rad-0.14855*math.pow(alpha_rad, 3));
		}

		#Easier and better approach - own interpolation tables

		lift_coeff=
			interpol.sqr_inter(
				[
					[0.0,			0.3000,		0.4000,		0.5000,		0.9000,		1.1000,		1.5000,		2.0000,		2.5000,		3.0000,		3.5000,		4.0000,		5.0000],
					[-0.7854,	-0.9651,	-0.9627,	-0.9587,	-0.9523,	-1.1896,	-0.9737,	-0.7578,	-0.7359,	-1.0140,	-0.9712,	-0.9415,	-0.8959],
					[-0.5236,	-0.8200,	-0.8183,	-0.8149,	-0.8098,	-0.9997,	-0.8194,	-0.6391,	-0.5895,	-0.6863,	-0.6189,	-0.5753,	-0.5368],
					[-0.3491,	-0.5774,	-0.5784,	-0.5793,	-0.5812,	-0.6355,	-0.5412,	-0.4469,	-0.4164,	-0.4069,	-0.3723,	-0.3441,	-0.3081],
					[-0.1745,	-0.2514,	-0.2523,	-0.2534,	-0.2554,	-0.2943,	-0.2531,	-0.2119,	-0.1937,	-0.1679,	-0.1536,	-0.1425,	-0.1258],
					[-0.0873,	-0.1094,	-0.1098,	-0.1103,	-0.1112,	-0.1336,	-0.1169,	-0.1002,	-0.0910,	-0.0776,	-0.0692,	-0.0623,	-0.0521],
					[0.0000,	0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000,		0.0000],
					[0.0873,	0.1094,		0.1098,		0.1103,		0.1112,		0.1336,		0.1169,		0.1002,		0.0910,		0.0776,		0.0692,		0.0623,		0.0521],
					[0.1745,	0.2514,		0.2523,		0.2534,		0.2554,		0.2943,		0.2531,		0.2119,		0.1937,		0.1679,		0.1536,		0.1425,		0.1258],
					[0.3491,	0.5774,		0.5784,		0.5793,		0.5812,		0.6355,		0.5412,		0.4469,		0.4164,		0.4069,		0.3723,		0.3441,		0.3081],
					[0.5236,	0.8200,		0.8183,		0.8149,		0.8098,		0.9997,		0.8194,		0.6391,		0.5895,		0.6863,		0.6189,		0.5753,		0.5368],
					[0.7854,	0.6785,		0.6856,		0.6931,		0.7077,		1.1896,		0.9737,		0.7578,		0.7359,		1.0140,		0.9712,		0.9415,		0.8959]
				],
				alpha_rad,
				mach
			);

		aero_lift_lbs=fdm_node.getNode("aero/qbar-psf").getValue()*
			fdm_node.getNode("data/Sw-sqft").getValue()*
			lift_coeff;
		fdm_node.getNode("forces/aero-lift-lbs").setValue(aero_lift_lbs);

		#summar lift force

		lift_lbs=fdm_node.getNode("forces/gravity/lift-lbs").getValue()+
			fdm_node.getNode("forces/puffer/lift-lbs").getValue()+
			fdm_node.getNode("forces/aero-lift-lbs").getValue();
		fdm_node.getNode("forces/lift-lbs").setValue(lift_lbs);

		#force to alpha rate is omitted, since
		#whole missile works at 0.1sec tick with nasal,
		#and rates could be enormously high

		#aerodynamical side force is accounted quite same as lift, just with beta

		if (mach >= 1.0)
		{
			side_coeff=(0.45114+1.25729/mach)*
				(beta_rad-0.14855*math.pow(beta_rad, 3));
		}
		else
		{
			side_coeff=(0.45114+1.25729)*
				(beta_rad-0.14855*math.pow(beta_rad, 3));
		}

		aero_side_lbs=fdm_node.getNode("aero/qbar-psf").getValue()*
			fdm_node.getNode("data/Sw-sqft").getValue()*
			side_coeff;
		fdm_node.getNode("forces/aero-side-lbs").setValue(aero_side_lbs);

		#summar side force

		side_lbs=fdm_node.getNode("forces/gravity/side-lbs").getValue()+
			fdm_node.getNode("forces/puffer/side-lbs").getValue()+
			fdm_node.getNode("forces/aero-side-lbs").getValue();
		fdm_node.getNode("forces/side-lbs").setValue(side_lbs);

		#Moments, g forces, angular accelerations, are omitted also.
		#Instead, maximum rotation speed is calculated, by next approach:
		#controlability of missile is reduced with qbar increasing,
		#since power of pistons moving controllable surfaces is limited,
		#while forces caused by fixed surfaces are increasing only.
		#So, rougly, angular_velocity=const/qbar.
		#By tests, angular_velocity_rad_sec=contr_surf_norm*0.5/(qbar-psf/3333)
		#if qbar>3333
		#and 0.5 at other case.
		#Quite simply.

		#In sake of simplification, here it converted to simple limiter
		#which implies what missile has automatics
		#pushing surfaces to the limit until needed angular speed is reached

		#As of uncontrollable flight, missile tends to return to alpha=0, beta=0,
		#as more as greater qbar is, but, since maximal tick is 0.1, that
		#velocity can not be greater than alpha/2, to avoid 
		#jumps around zero.

		if (elevator_norm!=0)
		{
			if (qbar_psf>3333)
			{
				pitch_rad_sec=elevator_norm*0.5;
				if (pitch_rad_sec < ((-1)*qbar_psf/3333))
				{
					pitch_rad_sec=(-1)*qbar_psf/3333;
				}
				if (pitch_rad_sec > (qbar_psf/3333))
				{
					pitch_rad_sec=qbar_psf/3333;
				}
			}
			else
			{
				if (mach>0.3)
				{
					pitch_rad_sec=elevator_norm*0.5;
				}
				else
				{
					pitch_rad_sec=-0.5*alpha_rad;
				}
			}
		}
		else
		{
			pitch_rad_sec=-0.5*alpha_rad;
		}
		fdm_node.getNode("velocities/pitch-rad-sec").setValue(pitch_rad_sec);

		if (rudder_norm!=0)
		{
			if (qbar_psf>3333)
			{
				yaw_rad_sec=rudder_norm*0.5;
				if (yaw_rad_sec < ((-1)*qbar_psf/3333))
				{
					yaw_rad_sec=(-1)*qbar_psf/3333;
				}
				if (yaw_rad_sec > (qbar_psf/3333))
				{
					yaw_rad_sec=qbar_psf/3333;
				}
			}
			else
			{
				if (mach>0.3)
				{
					yaw_rad_sec=rudder_norm*0.5;
				}
				else
				{
					yaw_rad_sec=-0.5*beta_rad;
				}
			}
		}
		else
		{
			yaw_rad_sec=-0.5*beta_rad;
		}
		fdm_node.getNode("velocities/yaw-rad-sec").setValue(yaw_rad_sec);

		#angles with offsets, if missile is not flying
		#then it is rotated with plane,
		#and angles are set by offsets

		#angles integrals
	
		pitch_rad=fdm_node.getNode("pids/pitch-rad").getValue();
		pitch_rad_sec=fdm_node.getNode("velocities/pitch-rad-sec").getValue();
		pitch_rad=pitch_rad+pitch_rad_sec*tick_sec;
		fdm_node.getNode("pids/pitch-rad").setValue(pitch_rad);

		pitch_rad_sec=fdm_node.getNode("pids/pitch-rad-sec").getValue();
		pitch_rad_sec=pitch_rad_sec+(-pitch_rad_sec+fdm_node.getNode("velocities/pitch-rad-sec").getValue())*0.5;
		fdm_node.getNode("pids/pitch-rad-sec").setValue(pitch_rad_sec);

		roll_rad=fdm_node.getNode("pids/roll-rad").getValue();
		roll_rad_sec=fdm_node.getNode("velocities/roll-rad-sec").getValue();
		roll_rad=roll_rad+roll_rad_sec*tick_sec;
		# Roll rotation is omitted due to simplification
		roll_rad=0;
		fdm_node.getNode("pids/roll-rad").setValue(roll_rad);

		yaw_rad=fdm_node.getNode("pids/yaw-rad").getValue();
		yaw_rad_sec=fdm_node.getNode("velocities/yaw-rad-sec").getValue();
		yaw_rad=yaw_rad+yaw_rad_sec*tick_sec;
		fdm_node.getNode("pids/yaw-rad").setValue(yaw_rad);

		yaw_rad_sec=fdm_node.getNode("pids/yaw-rad-sec").getValue();
		yaw_rad_sec=yaw_rad_sec+(-yaw_rad_sec+fdm_node.getNode("velocities/yaw-rad-sec").getValue())*0.5;
		fdm_node.getNode("pids/yaw-rad-sec").setValue(yaw_rad_sec);

		fdm_node.getNode("pitch-rad").setValue(pitch_rad);
		fdm_node.getNode("roll-rad").setValue(roll_rad);
		fdm_node.getNode("yaw-rad").setValue(yaw_rad);

		fdm_node.getNode("pitch-rad").setValue(
			fdm_node.getNode("pids/pitch-rad").getValue());
		fdm_node.getNode("roll-rad").setValue(
			fdm_node.getNode("pids/roll-rad").getValue());
		fdm_node.getNode("yaw-rad").setValue(
			fdm_node.getNode("pids/yaw-rad").getValue());

	}
	else
	{

		fdm_node.getNode("pids/pitch-rad").setValue(offset_pitch_rad);
		fdm_node.getNode("pids/roll-rad").setValue(offset_roll_rad);
		fdm_node.getNode("pids/yaw-rad").setValue(offset_yaw_rad);

		fdm_node.getNode("pitch-rad").setValue(offset_pitch_rad);
		fdm_node.getNode("roll-rad").setValue(offset_roll_rad);
		fdm_node.getNode("yaw-rad").setValue(offset_yaw_rad);

	}

	pitch_deg=fdm_node.getNode("pitch-rad").getValue()*57.2957795;
	roll_deg=fdm_node.getNode("roll-rad").getValue()*57.2957795;
	yaw_deg=fdm_node.getNode("yaw-rad").getValue()*57.2957795;

	fdm_node.getNode("pitch-deg").setValue(pitch_deg);
	fdm_node.getNode("roll-deg").setValue(roll_deg);
	fdm_node.getNode("yaw-deg").setValue(yaw_deg);
	fdm_node.getNode("heading-deg").setValue(yaw_deg);

	if (fdm_node.getNode("state/flying").getValue()==1)
	{

		#linear accelerations of own flight

		forward_fps2=(
				(fdm_node.getNode("forces/forward-lbs").getValue()/
				fdm_node.getNode("data/weight-lbs").getValue())*
			32.174049*fdm_node.getNode("state/flying").getValue());
		fdm_node.getNode("accelerations/forward-fps2").setValue(forward_fps2);

		lift_fps2=(
				(fdm_node.getNode("forces/lift-lbs").getValue()/
				fdm_node.getNode("data/weight-lbs").getValue())*
			32.174049*fdm_node.getNode("state/flying").getValue());
		fdm_node.getNode("accelerations/lift-fps2").setValue(lift_fps2);

		side_fps2=(
				(fdm_node.getNode("forces/side-lbs").getValue()/
				fdm_node.getNode("data/weight-lbs").getValue())*
			32.174049*fdm_node.getNode("state/flying").getValue());
		fdm_node.getNode("accelerations/side-fps2").setValue(side_fps2);

		#Resulted accelerations are in coordinates related to missile:
		#forward, lift, side.To get positions shifts is needed to
		#rotate these accelerations to neu, to get neu speeds,
		#then neu shifts, then neu position.

		#roll rotation

		n_fps2=fdm_node.getNode("accelerations/forward-fps2").getValue();
		fdm_node.getNode("accelerations/neu/roll-rotated/n-fps2").setValue(n_fps2);

		e_fps2=fdm_node.getNode("accelerations/lift-fps2").getValue()*
			math.sin(fdm_node.getNode("roll-rad").getValue())+
			fdm_node.getNode("accelerations/side-fps2").getValue()*
			math.cos(fdm_node.getNode("roll-rad").getValue());
		fdm_node.getNode("accelerations/neu/roll-rotated/e-fps2").setValue(e_fps2);

		u_fps2=fdm_node.getNode("accelerations/lift-fps2").getValue()*
			math.cos(fdm_node.getNode("roll-rad").getValue())+
			(-1)*fdm_node.getNode("accelerations/side-fps2").getValue()*
			math.sin(fdm_node.getNode("roll-rad").getValue());
		fdm_node.getNode("accelerations/neu/roll-rotated/u-fps2").setValue(u_fps2);

		#pitch rotation

		n_fps2=fdm_node.getNode("accelerations/neu/roll-rotated/n-fps2").getValue()*
			math.cos(fdm_node.getNode("pitch-rad").getValue())+
			(-1)*fdm_node.getNode("accelerations/neu/roll-rotated/u-fps2").getValue()*
			math.sin(fdm_node.getNode("pitch-rad").getValue());
		fdm_node.getNode("accelerations/neu/pitch-rotated/n-fps2").setValue(n_fps2);

		e_fps2=fdm_node.getNode("accelerations/neu/roll-rotated/e-fps2").getValue();
		fdm_node.getNode("accelerations/neu/pitch-rotated/e-fps2").setValue(e_fps2);

		u_fps2=fdm_node.getNode("accelerations/neu/roll-rotated/n-fps2").getValue()*
			math.sin(fdm_node.getNode("pitch-rad").getValue())+
			fdm_node.getNode("accelerations/neu/roll-rotated/u-fps2").getValue()*
			math.cos(fdm_node.getNode("pitch-rad").getValue());
		fdm_node.getNode("accelerations/neu/pitch-rotated/u-fps2").setValue(u_fps2);

		#heading rotation

		n_fps2=fdm_node.getNode("accelerations/neu/pitch-rotated/n-fps2").getValue()*
			math.cos(fdm_node.getNode("yaw-rad").getValue())+
			(-1)*fdm_node.getNode("accelerations/neu/pitch-rotated/e-fps2").getValue()*
			math.sin(fdm_node.getNode("yaw-rad").getValue());
		fdm_node.getNode("accelerations/neu/heading-rotated/n-fps2").setValue(n_fps2);

		e_fps2=fdm_node.getNode("accelerations/neu/pitch-rotated/n-fps2").getValue()*
			math.sin(fdm_node.getNode("yaw-rad").getValue())+
			fdm_node.getNode("accelerations/neu/pitch-rotated/e-fps2").getValue()*
			math.cos(fdm_node.getNode("yaw-rad").getValue());
		fdm_node.getNode("accelerations/neu/heading-rotated/e-fps2").setValue(e_fps2);

		u_fps2=fdm_node.getNode("accelerations/neu/pitch-rotated/u-fps2").getValue();
		fdm_node.getNode("accelerations/neu/heading-rotated/u-fps2").setValue(u_fps2);

		#output

		fdm_node.getNode("accelerations/n-fps2").setValue(n_fps2);
		fdm_node.getNode("accelerations/e-fps2").setValue(e_fps2);
		fdm_node.getNode("accelerations/u-fps2").setValue(u_fps2);

		#speeds of own flight in neu,
		#accounted by simple integrators

		n_fps=fdm_node.getNode("pids/n-fps").getValue();
		n_fps_2=fdm_node.getNode("accelerations/n-fps2").getValue();
		n_fps=n_fps+n_fps_2*tick_sec;
		fdm_node.getNode("pids/n-fps").setValue(n_fps);

		e_fps=fdm_node.getNode("pids/e-fps").getValue();
		e_fps_2=fdm_node.getNode("accelerations/e-fps2").getValue();
		e_fps=e_fps+e_fps_2*tick_sec;
		fdm_node.getNode("pids/e-fps").setValue(e_fps);

		u_fps=fdm_node.getNode("pids/u-fps").getValue();
		u_fps_2=fdm_node.getNode("accelerations/u-fps2").getValue();
		u_fps=u_fps+u_fps_2*tick_sec;
		fdm_node.getNode("pids/u-fps").setValue(u_fps);
	}
	else
	{

		#Again, if missile is attached, then it's needed to bring speeds
		#of missile to speeds of plane.

		fdm_node.getNode("accelerations/n-fps2").setValue(0);
		fdm_node.getNode("accelerations/e-fps2").setValue(0);
		fdm_node.getNode("accelerations/u-fps2").setValue(0);

		n_fps=root_node.getNode("velocities/speed-north-fps").getValue();
		fdm_node.getNode("pids/n-fps").setValue(n_fps);

		e_fps=root_node.getNode("velocities/speed-east-fps").getValue();
		fdm_node.getNode("pids/e-fps").setValue(e_fps);

		u_fps=root_node.getNode("velocities/vertical-speed-fps").getValue();
		fdm_node.getNode("pids/u-fps").setValue(u_fps);

	}

	#convert fps to lat-deg/sec, lon-deg/sec

	lat_degps=fdm_node.getNode("pids/n-fps").getValue()/365219;
	fdm_node.getNode("velocities/neu/lat-degps").setValue(lat_degps);

	lon_degps=fdm_node.getNode("pids/e-fps").getValue()/365219/
		math.cos(fdm_node.getNode("pids/latitude-deg").getValue()/57.2957795);
	fdm_node.getNode("velocities/neu/lon-degps").setValue(lon_degps);

	fdm_node.getNode("velocities/neu/u-fps").setValue(u_fps);

	#position integrator inputs

	fdm_node.getNode("velocities/lat-degps").setValue(lat_degps);
	fdm_node.getNode("velocities/lon-degps").setValue(lon_degps);
	fdm_node.getNode("velocities/u-fps").setValue(u_fps);

	if (fdm_node.getNode("state/flying").getValue()==1)
	{
		#If missile is flying then position is calculated by integrators.

		latitude_deg=fdm_node.getNode("pids/latitude-deg").getValue();
		lat_degps=fdm_node.getNode("velocities/lat-degps").getValue();
		latitude_deg=latitude_deg+lat_degps*tick_sec;
		fdm_node.getNode("pids/latitude-deg").setValue(latitude_deg);

		longitude_deg=fdm_node.getNode("pids/longitude-deg").getValue();
		lon_degps=fdm_node.getNode("velocities/lon-degps").getValue();
		longitude_deg=longitude_deg+lon_degps*tick_sec;
		fdm_node.getNode("pids/longitude-deg").setValue(longitude_deg);
			
		elevation_ft=fdm_node.getNode("pids/elevation-ft").getValue();
		u_fps=fdm_node.getNode("velocities/u-fps").getValue();
		elevation_ft=elevation_ft+u_fps*tick_sec;
		fdm_node.getNode("pids/elevation-ft").setValue(elevation_ft);

		fdm_node.getNode("latitude-deg").setValue(latitude_deg);
		fdm_node.getNode("longitude-deg").setValue(longitude_deg);
		fdm_node.getNode("elevation-ft").setValue(elevation_ft);

		#Since missile data is updated by rough 0.1sec timer,
		#some interpolation is needed.

		#interpolate(fdm_node.getNode("latitude-inter-deg").getPath(),	latitude_deg, 0.1);
		#interpolate(fdm_node.getNode("longitude-inter-deg").getPath(),	longitude_deg, 0.1);
		#interpolate(fdm_node.getNode("elevation-inter-ft").getPath(),	elevation_ft, 0.1);

		fdm_node.getNode("latitude-inter-deg").setValue(latitude_deg);
		fdm_node.getNode("longitude-inter-deg").setValue(longitude_deg);
		fdm_node.getNode("elevation-inter-ft").setValue(elevation_ft);

	}
	else
	{
		#If missile is not flying then position is equal to offset one,
		#also integrators are equalied to it.
		if (fdm_node.getNode("state/prepared").getValue()==1)
		{

			fdm_node.getNode("latitude-deg").setValue(offset_latitude_deg);
			fdm_node.getNode("longitude-deg").setValue(offset_longitude_deg);
			fdm_node.getNode("elevation-ft").setValue(offset_elevation_ft);

			fdm_node.getNode("pids/latitude-deg").setValue(offset_latitude_deg);
			fdm_node.getNode("pids/longitude-deg").setValue(offset_longitude_deg);
			fdm_node.getNode("pids/elevation-ft").setValue(offset_elevation_ft);
		}
	}

	#To calculate alpha and other things,
	#it's needed to do convert initial speeds of plane,
	#or speeds of own missile flight, in neu, to
	#speeds of missile if forward, side, up coordinates.
	#Speeds of plane gotta be limited to reasonable values, to 
	#avoid nans at init, when it could be too high.

	#initial

	if (fdm_node.getNode("state/flying").getValue()==1)
	{
		fdm_node.getNode("velocities/fsu/initial/f-fps").setValue(n_fps);
		fdm_node.getNode("velocities/fsu/initial/s-fps").setValue(e_fps);
		fdm_node.getNode("velocities/fsu/initial/u-fps").setValue(u_fps);
	}
	else
	{
		v_north_fps=root_node.getNode("velocities/speed-north-fps").getValue();
		if (v_north_fps<-10000)
		{
			v_north_fps=-10000;
		}
		if (v_north_fps>10000)
		{
			v_north_fps=10000;
		}
		fdm_node.getNode("velocities/fsu/initial/f-fps").setValue(v_north_fps);

		v_east_fps=root_node.getNode("velocities/speed-east-fps").getValue();
		if (v_east_fps<-10000)
		{
			v_east_fps=-10000;
		}
		if (v_east_fps>10000)
		{
			v_east_fps=10000;
		}
		fdm_node.getNode("velocities/fsu/initial/s-fps").setValue(v_east_fps);

		v_down_fps=(-1)*root_node.getNode("velocities/vertical-speed-fps").getValue();
		if (v_down_fps<-10000)
		{
			v_down_fps=-10000;
		}
		if (v_down_fps>10000)
		{
			v_down_fps=10000;
		}
		v_up_fps=(-1)*v_down_fps;
		fdm_node.getNode("velocities/fsu/initial/u-fps").setValue(v_up_fps);
	}	

	#heading rotation

	f_fps=fdm_node.getNode("velocities/fsu/initial/f-fps").getValue()*
		math.cos(fdm_node.getNode("yaw-rad").getValue())+
		fdm_node.getNode("velocities/fsu/initial/s-fps").getValue()*
		math.sin(fdm_node.getNode("yaw-rad").getValue());
	fdm_node.getNode("velocities/fsu/heading-rotated/f-fps").setValue(f_fps);

	s_fps=fdm_node.getNode("velocities/fsu/initial/f-fps").getValue()*
		(-1)*math.sin(fdm_node.getNode("yaw-rad").getValue())+
		fdm_node.getNode("velocities/fsu/initial/s-fps").getValue()*
		math.cos(fdm_node.getNode("yaw-rad").getValue());
	fdm_node.getNode("velocities/fsu/heading-rotated/s-fps").setValue(s_fps);

	u_fps=fdm_node.getNode("velocities/fsu/initial/u-fps").getValue();
	fdm_node.getNode("velocities/fsu/heading-rotated/u-fps").setValue(u_fps);

	#pitch rotation

	f_fps=fdm_node.getNode("velocities/fsu/heading-rotated/f-fps").getValue()*
		math.cos(fdm_node.getNode("pitch-rad").getValue())+
		fdm_node.getNode("velocities/fsu/heading-rotated/u-fps").getValue()*
		math.sin(fdm_node.getNode("pitch-rad").getValue());
	fdm_node.getNode("velocities/fsu/pitch-rotated/f-fps").setValue(f_fps);

	s_fps=fdm_node.getNode("velocities/fsu/heading-rotated/s-fps").getValue();
	fdm_node.getNode("velocities/fsu/pitch-rotated/s-fps").setValue(s_fps);

	u_fps=fdm_node.getNode("velocities/fsu/heading-rotated/f-fps").getValue()*
		(-1)*math.sin(fdm_node.getNode("pitch-rad").getValue())+
		fdm_node.getNode("velocities/fsu/heading-rotated/u-fps").getValue()*
		math.cos(fdm_node.getNode("pitch-rad").getValue());
	fdm_node.getNode("velocities/fsu/pitch-rotated/u-fps").setValue(u_fps);

	#roll rotation

	f_fps=fdm_node.getNode("velocities/fsu/pitch-rotated/f-fps").getValue();
	fdm_node.getNode("velocities/fsu/roll-rotated/f-fps").setValue(f_fps);

	s_fps=fdm_node.getNode("velocities/fsu/pitch-rotated/s-fps").getValue()*
		math.cos(fdm_node.getNode("roll-rad").getValue())+
		fdm_node.getNode("velocities/fsu/pitch-rotated/u-fps").getValue()*
		(-1)*math.sin(fdm_node.getNode("roll-rad").getValue());
	fdm_node.getNode("velocities/fsu/roll-rotated/s-fps").setValue(s_fps);

	u_fps=fdm_node.getNode("velocities/fsu/pitch-rotated/s-fps").getValue()*
		math.sin(fdm_node.getNode("roll-rad").getValue())+
		fdm_node.getNode("velocities/fsu/pitch-rotated/u-fps").getValue()*
		math.cos(fdm_node.getNode("roll-rad").getValue());
	fdm_node.getNode("velocities/fsu/roll-rotated/u-fps").setValue(u_fps);

	#output

	#Note that  it starts to transfer values only after
	#whole craft init. Otherwise everything going to nans
	#due to initial overgs.

	if (fdm_node.getNode("control/init").getValue()==1)
	{
		fdm_node.getNode("velocities/fsu/f-fps").setValue(f_fps);
		fdm_node.getNode("velocities/fsu/s-fps").setValue(s_fps);
		fdm_node.getNode("velocities/fsu/u-fps").setValue(u_fps);
	}
	else
	{
		fdm_node.getNode("velocities/fsu/f-fps").setValue(1);
		fdm_node.getNode("velocities/fsu/s-fps").setValue(0);
		fdm_node.getNode("velocities/fsu/u-fps").setValue(0);
	}

	#control

	#Once missile is set, turn off reset command.
	#Part with angles is omitted, since 
	#angular velocities is not calculated, and 
	#these are set directly at offset case.

	if (
		(fdm_node.getNode("control/reset").getValue()==1) and
		(fdm_node.getNode("state/existed").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==0)
		)
	{
		fdm_node.getNode("control/reset").setValue(0);
	}

	#state

	#prepared flag

	if (
		(fdm_node.getNode("control/prepare").getValue()==1) and
		(fdm_node.getNode("state/existed").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("engine/working-pos").getValue()==0) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/prepared").setValue(1);
	}

	if (
		(fdm_node.getNode("control/prepare").getValue()==0) or
		(fdm_node.getNode("state/existed").getValue()==0) or
		(fdm_node.getNode("state/flying").getValue()==1) or
		(fdm_node.getNode("engine/working-pos").getValue()>0) or
		(fdm_node.getNode("control/reset").getValue()==1)
		)
	{
		fdm_node.getNode("state/prepared").setValue(0);
	}

	#aimed flag

	#R8R is aimed at normal mode if locked target id is not -1,
	#in fi-0 mode if target is not -1,
	#missile existed, not launched, and command to aim is set.

	if (
		(fdm_node.getNode("state/existed").getValue()==1) and
		(fdm_node.getNode("state/prepared").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("control/aim").getValue()==1) and
		(fdm_node.getNode("state/fi-0").getValue()==0) and
		(fdm_node.getNode("control/lock-id").getValue()!=-1) and
		(fdm_node.getNode("radar/id").getValue()!=-1) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/aimed").setValue(1);
	}

	if (
		(fdm_node.getNode("state/existed").getValue()==1) and
		(fdm_node.getNode("state/prepared").getValue()==1) and
		(fdm_node.getNode("state/flying").getValue()==0) and
		(fdm_node.getNode("control/aim").getValue()==1) and
		(fdm_node.getNode("state/fi-0").getValue()==1) and
		(fdm_node.getNode("radar/id").getValue()!=-1) and
		(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/aimed").setValue(1);
	}

	if (
		(fdm_node.getNode("state/existed").getValue()==0) or
		(fdm_node.getNode("state/prepared").getValue()==0) or
		(fdm_node.getNode("state/flying").getValue()==1) or
		(fdm_node.getNode("control/aim").getValue()==0) or
		(fdm_node.getNode("control/reset").getValue()==1) or
		(
			(fdm_node.getNode("state/fi-0").getValue()==0) and
			(fdm_node.getNode("control/lock-id").getValue()==-1)
		) or
		(
			(fdm_node.getNode("state/fi-0").getValue()==1) and
			(fdm_node.getNode("target/id").getValue()==-1)
		)	
		)
	{
		fdm_node.getNode("state/aimed").setValue(0);
	}

	#flying flag

	if (
			(
				(fdm_node.getNode("state/flying").getValue()==0) and
				(fdm_node.getNode("state/existed").getValue()==1) and
				(fdm_node.getNode("control/reset").getValue()==0)
			) and
			(
				(fdm_node.getNode("state/launch").getValue()==1) or
				(fdm_node.getNode("state/drop").getValue()==1)
			)
		)
	{
		fdm_node.getNode("state/flying").setValue(1);
	}


	if (
			(fdm_node.getNode("state/existed").getValue()==0) or
			(fdm_node.getNode("control/reset").getValue()==1)
		)
	{
		fdm_node.getNode("state/flying").setValue(0);
	}

	#launch flag

	if (
			(fdm_node.getNode("control/launch").getValue()==1) and
			(fdm_node.getNode("state/existed").getValue()==1) and
			(fdm_node.getNode("state/prepared").getValue()==1) and
			(fdm_node.getNode("state/aimed").getValue()==1) and
			(fdm_node.getNode("radar/distance-m").getValue()>2000) and
			(fdm_node.getNode("state/flying").getValue()==0) and
			(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/launch").setValue(1);
	}

	if (
			(fdm_node.getNode("state/existed").getValue()==0) or
			(fdm_node.getNode("state/flying").getValue()==1) or
			(fdm_node.getNode("control/reset").getValue()==1)
		)
	{
		fdm_node.getNode("state/launch").setValue(0);
	}

	#drop flag

	if (
			(fdm_node.getNode("control/drop").getValue()==1) and
			(fdm_node.getNode("state/existed").getValue()==1) and
			(fdm_node.getNode("state/flying").getValue()==0) and
			(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/drop").setValue(1);
	}

	if (
			(fdm_node.getNode("state/flying").getValue()==1) and
			(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/drop").setValue(0);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("state/drop").setValue(0);
	}

	#over-g is not calculated due to 0.1sec tick

	#ground hit flag

	if (
			(fdm_node.getNode("state/flying").getValue()==1) and
			(fdm_node.getNode("elevation-ft").getValue()<=0) and
			(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/hit-ground").setValue(1);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("state/hit-ground").setValue(0);
	}

	#existed flag

	#Note that over-g is not calculated at rough nasal version.

	if (
			(fdm_node.getNode("state/flying").getValue()==1) and
			(fdm_node.getNode("state/existed").getValue()==1) and
			(fdm_node.getNode("state/hit-ground").getValue()==1) and
			(fdm_node.getNode("control/reset").getValue()==0)
		)
	{
		fdm_node.getNode("state/existed").setValue(0);
	}

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("state/existed").setValue(1);
	}

	#drop of catch flag on reset

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("state/catch-id").setValue(-1);
	}

	#drop of catched flag on reset

	if (fdm_node.getNode("control/reset").getValue()==1)
	{
		fdm_node.getNode("target/catched").setValue(0);
	}

	#finished flag

	if (
			(fdm_node.getNode("state/hit-ground").getValue()==1) or
			(fdm_node.getNode("state/catch-id").getValue()!=-1)
		)
	{
		fdm_node.getNode("state/finished").setValue(1);
	}

	if (
			(fdm_node.getNode("state/hit-ground").getValue()==0) and
			(fdm_node.getNode("state/catch-id").getValue()==-1)
		)
	{
		fdm_node.getNode("state/finished").setValue(0);
	}

	#attached flag

	if (
			(fdm_node.getNode("state/flying").getValue()==1) or
			(fdm_node.getNode("state/existed").getValue()==0)
		)
	{
		fdm_node.getNode("state/attached").setValue(0);
	}

	if (
			(fdm_node.getNode("state/flying").getValue()==0) and
			(fdm_node.getNode("state/existed").getValue()==1)
		)
	{
		fdm_node.getNode("state/attached").setValue(1);
	}

	#state for replay

	if (props.globals.getNode("sim/freeze/replay-state").getValue()==0)
	{
		fdm_node.getNode("state/attached-ind").setValue(
			fdm_node.getNode("state/attached").getValue());
	}

	#weight for plane pointmass

	if (fdm_node.getNode("state/attached").getValue()==1)
	{
		plane_node.getNode("inertia/pointmass-weight-lbs[1]").setValue(470.0);
	}
	else
	{
		plane_node.getNode("inertia/pointmass-weight-lbs[1]").setValue(0.0);
	}

	return;

}


# current target position calculation function ---------------------------

r8r_target=func(fdm_node, node)
{

# not prepared or flying missile does not care about target

	if (
		(fdm_node.getNode("state/prepared").getValue()==0) and
		(fdm_node.getNode("state/flying").getValue()==0)
	)
	{
		return;
	}

# get missile position and angles

	coord=geo.Coord.new();
	elevation_m=fdm_node.getNode("elevation-ft").getValue() * 0.3048;
	coord.set_latlon(
		fdm_node.getNode("latitude-deg").getValue(),
		fdm_node.getNode("longitude-deg").getValue(),
		elevation_m);

	pitch_deg=fdm_node.getNode("pitch-deg").getValue();
	roll_deg=fdm_node.getNode("roll-deg").getValue();
	heading_deg=fdm_node.getNode("heading-deg").getValue();

	pitch_rad=pitch_deg * 57.2957795;
	roll_rad=roll_deg * 57.2957795;
	heading_rad=heading_deg * 57.2957795;

#	get target position and angles

	mp_coord=geo.Coord.new();
	mp_altitude_ft=node.getNode("position/altitude-ft").getValue();
	mp_altitude_m=mp_altitude_ft * 0.3048;;
	mp_latitude_deg=node.getNode("position/latitude-deg").getValue();
	mp_longitude_deg=node.getNode("position/longitude-deg").getValue();
	mp_coord.set_latlon(mp_latitude_deg, 
		mp_longitude_deg, 
		mp_altitude_m);

	mp_pitch_deg=node.getNode("orientation/pitch-deg").getValue();
	mp_roll_deg=node.getNode("orientation/roll-deg").getValue();
	mp_heading_deg=node.getNode("orientation/true-heading-deg").getValue();

	course_deg=coord.course_to(mp_coord);
	distance_m=coord.direct_distance_to(mp_coord);

	if (heading_deg>180)
	{
			heading_deg=heading_deg-360;
	}

#	Aiming has three modes. 0, small target, means missile goes
#	in mp point as is. 1, medium, and 2, big, makes missile
# go not into that point, but into medium point of wing
# which is left from misile view

	if (fdm_node.getNode("control/target-size").getValue() != 0)
	{

		if (fdm_node.getNode("control/target-size").getValue() == 1)
		{
			delta_y_m=-15;
			delta_x_m=0;
			delta_z_m=0;
		}
		else
		{
			delta_y_m=-5;
			delta_x_m=0;
			delta_z_m=0;
		}
								
# Recalculate target point position

# Rotate to get deltas in north, east, up
			
		delta_n_roll=delta_x_m;
		delta_e_roll=delta_y_m*math.cos(roll_rad)+delta_z_m*math.sin(roll_rad);
		delta_u_roll=-delta_y_m*math.sin(roll_rad)+delta_z_m*cos(roll_rad);
		delta_n_pitch=delta_n_roll*math.cos(pitch_rad)-delta_u_roll*math.sin(pitch_rad);
		delta_e_pitch=delta_e_roll;
		delta_u_pitch=delta_n_roll*math.sin(pitch_rad)+delta_u_roll*math.cos(pitch_rad);
		delta_n=delta_n_pitch*math.cos(heading_rad)-delta_e_pitch*math.sin(heading_rad);
		delta_e=delta_n_pitch*math.sin(heading_rad)+delta_e_pitch*math.cos(heading_rad);
		delta_u=delta_u_pitch;

# Count aim posiion in latlon

		mp_altitude_m=mp_altitude_m+delta_u_pitch;
		mp_latitude_deg=mp_latitude_deg+delta_n/111319;
		if (mp_latitude_deg<0)
		{
			mp_latitude_deg=mp_latitude_deg+360;
		}
		if (mp_latitude_deg>360)
		{
			mp_latitude_deg=mp_latitude_deg-360;
		}
		mp_longitude_deg=mp_longitude_deg+
			(delta_e/111319)/cos(mp_latitude_deg/57.2957795);
		if (mp_longitude_deg<0)
		{
			mp_longitude_deg=mp_longitude_deg+360;
		}
		if (mp_longitude_deg>360)
		{
			mp_longitude_deg=mp_longitude_deg-360;
		}
		mp_coord.set_latlon(mp_latitude_deg, 
			mp_longitude_deg, 
			mp_altitude_m);
	}

# update target data records

	mp_altitude_ft=mp_altitude_m / 0.3048;

	fdm_node.getNode("target/id").setValue(
		node.getNode("id").getValue());
	fdm_node.getNode("target/latitude-deg").setValue(mp_coord.lat());
	fdm_node.getNode("target/longitude-deg").setValue(mp_coord.lon());
	fdm_node.getNode("target/altitude-ft").setValue(mp_altitude_ft);
	fdm_node.getNode("target/pitch-deg").setValue(mp_pitch_deg);
	fdm_node.getNode("target/roll-deg").setValue(mp_roll_deg);
	fdm_node.getNode("target/heading-deg").setValue(mp_heading_deg);

}

# radar --------------------------------------------------------------------

# halfactive radar of missile checks target visibility
# sees targets only lightened by radar of plane
# returns -1 if not visible, at other case
# returns mp_id, alfa_deg, beta_deg, distance_m 

r8r_radar=func(fdm_node, node)
{
	var return_array=[-1,0,0,0];

# not prepared or flying missile does not care about target

	if (
		(fdm_node.getNode("state/prepared").getValue()==0) and
		(fdm_node.getNode("state/flying").getValue()==0)
	)
	{
		return return_array;
	}

	#time tick receiving

	tick_sec=fdm_node.getNode("tick-sec").getValue();
	if (tick_sec == nil)
	{
		return  return_array;
	}

	#without time passng there is nothing to calculate

	if (tick_sec <= 0) 
	{
		return return_array;
	}

# get missile position and angles

	coord=geo.Coord.new();
	elevation_m=fdm_node.getNode("elevation-ft").getValue() * 0.3048;
	coord.set_latlon(
		fdm_node.getNode("latitude-deg").getValue(),
		fdm_node.getNode("longitude-deg").getValue(),
		elevation_m);

	pitch_deg=fdm_node.getNode("pitch-deg").getValue();
	roll_deg=fdm_node.getNode("roll-deg").getValue();
	heading_deg=fdm_node.getNode("heading-deg").getValue();

	if (heading_deg>180)
	{
		heading_deg=heading_deg-360;
	}

#	get target position and angles

	mp_coord=geo.Coord.new();
	mp_altitude_ft=node.getNode("position/altitude-ft").getValue();
	mp_altitude_m=mp_altitude_ft * 0.3048;;
	mp_latitude_deg=node.getNode("position/latitude-deg").getValue();
	mp_longitude_deg=node.getNode("position/longitude-deg").getValue();
	mp_coord.set_latlon(mp_latitude_deg, 
		mp_longitude_deg, 
		mp_altitude_m);

	mp_pitch_deg=node.getNode("orientation/pitch-deg").getValue();
	mp_roll_deg=node.getNode("orientation/roll-deg").getValue();
	mp_heading_deg=node.getNode("orientation/true-heading-deg").getValue();

	if (mp_heading_deg>180)
	{
		mp_heading_deg=mp_heading_deg-360;
	}

	delta_heading=abs(heading_deg-mp_heading_deg);
	delta_pitch=abs(pitch_deg-mp_pitch_deg);

	if (mpclash.check_sight(node) == 0)
	{

#	target not lightened by radar of plane is not visible

		return return_array;
	}
	
	mp_pitch_rad=mp_pitch_deg * 57.2957795;
	mp_roll_rad=mp_roll_deg * 57.2957795;
	mp_heading_rad=mp_heading_deg * 57.2957795;

#	count distance

	distance_m=coord.direct_distance_to(mp_coord);

	if (distance_m>fdm_node.getNode("data/range-m").getValue())
	{

# too far target is not visible

		return return_array;
	}

# check if target is hidden behind mountain

	for (j=1; j<10; j+=1)
	{
		ground_latitude_deg=coord.lat()+(mp_coord.lat()-coord.lat())*j/10;
		ground_longitude_deg=coord.lon()+(mp_coord.lon()-coord.lon())*j/10;
		line_altitude_m=coord.alt()+(mp_coord.alt()-coord.alt())*j/10;
		ground_altitude_m=geo.elevation(ground_latitude_deg, ground_longitude_deg);
		if ((ground_altitude_m!=nil) and
			(line_altitude_m!=nil))
			if (ground_altitude_m>line_altitude_m)
			{

# target hidden behind mountain is not visible

				return return_array;
			}
	}

	course_deg=coord.course_to(mp_coord);
	if (course_deg>180)
	{
		course_deg=course_deg-360;
	}

# Calculate angles to taget in vertical and horizontal plane

	distance_m=coord.direct_distance_to(mp_coord);

	beta_init_deg=course_deg-heading_deg;
	if (beta_init_deg>180)
	{
		beta_init_deg=beta_init_deg-360;
	}
	if (beta_init_deg<-180)
	{
		beta_init_deg=beta_init_deg+360;
	}

	if ((beta_init_deg>90) or
		(beta_init_deg<-90))
	{

# target at back semisphere is not visible

		return return_array;
	}

# Count angles from missile to target

	heights_rad=math.atan2((mp_altitude_m-coord.alt()), distance_m);
	heights_deg=heights_rad/math.pi*180;
	alpha_init_deg=heights_rad/math.pi*180-pitch_deg;
	alpha_init_rad=alpha_init_deg/180*math.pi;
	beta_init_rad=beta_init_deg/180*math.pi;
	alpha_init_vector=math.sin(alpha_init_rad);
	beta_init_vector=math.sin(beta_init_rad);
	sum_vector=math.sqrt(alpha_init_vector*alpha_init_vector+beta_init_vector*beta_init_vector);
	gamma_init_rad=math.atan2(beta_init_vector, alpha_init_vector);
	gamma_init_deg=gamma_init_rad/math.pi*180;
	gamma_rad=math.atan2(beta_init_vector, alpha_init_vector)-roll_deg/180*math.pi;
	gamma_deg=gamma_rad/math.pi*180;
	alpha_vector=sum_vector*math.cos(gamma_rad);
	beta_vector=sum_vector*math.sin(gamma_rad);
	if (alpha_vector>1)
	{
		alpha_vector=0.999999;
	}
	if (alpha_vector<-1)
	{
		alpha_vector=-0.999999;
	}
	if (beta_vector>1)
	{
		beta_vector=0.999999;
	}
	if (beta_vector<-1)
	{
		beta_vector=-0.999999;
	}
	alpha_side_vector=math.sqrt(1-math.pow(alpha_vector, 2));
	beta_side_vector=math.sqrt(1-math.pow(beta_vector, 2));
	alpha_rad=math.atan2(alpha_vector, alpha_side_vector);
	beta_rad=math.atan2(beta_vector, beta_side_vector);
	alpha_deg=alpha_rad/math.pi*180;
	beta_deg=beta_rad/math.pi*180;

	if ((alpha_deg>fdm_node.getNode("data/alpha-range-deg").getValue())
		or (alpha_deg<(-fdm_node.getNode("data/alpha-range-deg").getValue()))
		or (beta_deg>fdm_node.getNode("data/beta-range-deg").getValue())
		or (beta_deg<(-fdm_node.getNode("data/beta-range-deg").getValue())))
	{

# target beyond range degrees is not visible

		return return_array;
	}

	return_array[0]=node.getNode("id").getValue();
	return_array[1]=alpha_deg;
	return_array[2]=beta_deg;
	return_array[3]=distance_m;

	return return_array;
}

# ranger ---------------------------------------------------------

# ranger checks catch by two methods
# first is simple, by distance between points
# second a bit more complex, predicts if on next step
# missile would catch target with current approach
# third checked if trajectories crossed in one of 
# xy,xz,yz planes, and accouts disance at other axis,
# z,y,x respectively, between these two points of that cross
# but turned out to be too complex for virtuality

r8r_mp_ranger=func(fdm_node)
{
	return_value=0;

# get missile position

	coord=geo.Coord.new();
	elevation_ft=fdm_node.getNode("elevation-ft").getValue();
	elevation_m=elevation_ft * 0.3048;
	coord.set_latlon(
		fdm_node.getNode("latitude-deg").getValue(),
		fdm_node.getNode("longitude-deg").getValue(),
		elevation_m);

#	get target position

	mp_coord=geo.Coord.new();
	mp_altitude_ft=fdm_node.getNode("target/altitude-ft").getValue();
	mp_altitude_m=mp_altitude_ft * 0.3048;
	mp_coord.set_latlon(
		fdm_node.getNode("target/latitude-deg").getValue(),
		fdm_node.getNode("target/longitude-deg").getValue(),
		mp_altitude_m);

# not flying missile cant catch target

	if (fdm_node.getNode("state/flying").getValue() == 0)
	{
		fdm_node.getNode("ranger/elevation-ft").setValue(elevation_ft);
		fdm_node.getNode("ranger/latitude-deg").setValue(coord.lat());
		fdm_node.getNode("ranger/longitude-deg").setValue(coord.lon());
		fdm_node.getNode("ranger/mp-altitude-ft").setValue(mp_altitude_ft);
		fdm_node.getNode("ranger/mp-latitude-deg").setValue(mp_coord.lat());
		fdm_node.getNode("ranger/mp-longitude-deg").setValue(mp_coord.lon());
		return	return_value;
	}

#	count distance

	distance_m=coord.direct_distance_to(mp_coord);

	fdm_node.getNode("ranger/distance-m").setValue(distance_m);

#	simple catcher, never works

	if (fdm_node.getNode("data/catch-m").getValue()>distance_m)
	{
		print ("R8R catch, simple");
		return_value=1;
	}
	else
	{

#	complex catchers

		if ((fdm_node.getNode("ranger/id").getValue()!=-1)
			and (fdm_node.getNode("ranger/id").getValue()==
				fdm_node.getNode("target/id").getValue()))
		{

# get previous missile position

			prev_coord=geo.Coord.new();
			prev_elevation_ft=fdm_node.getNode("ranger/elevation-ft").getValue();
			prev_elevation_m=elevation_ft * 0.3048;
			prev_coord.set_latlon(
				fdm_node.getNode("ranger/latitude-deg").getValue(),
				fdm_node.getNode("ranger/longitude-deg").getValue(),
				prev_elevation_m);

#	get previous target position

			prev_mp_coord=geo.Coord.new();
			prev_mp_altitude_ft=fdm_node.getNode("ranger/mp-altitude-ft").getValue();
			prev_mp_altitude_m=prev_mp_altitude_ft * 0.3048;
			prev_mp_coord.set_latlon(
				fdm_node.getNode("ranger/mp-latitude-deg").getValue(), 
				fdm_node.getNode("ranger/mp-longitude-deg").getValue(),
				prev_mp_altitude_m);

			prev_distance_m=prev_coord.direct_distance_to(prev_mp_coord);

			if (prev_distance_m>distance_m)
			{
				step_m=prev_distance_m-distance_m;
				prev_step_m=fdm_node.getNode("ranger/step-m").getValue();
				if (prev_step_m!=0)
				{
					step_m=(step_m+prev_step_m)/2;
					fdm_node.getNode("ranger/step-m").setValue(step_m);
				}
				else
				{
					fdm_node.getNode("ranger/step-m").setValue(step_m);
				}
			}
			else
			{
				step_m=fdm_node.getNode("ranger/step-m").getValue();
			}

			if (step_m>0)
			{

#	Simple complex catcher, if missile gets to taget closer than calculated step

				if (
						(step_m>prev_distance_m)	or
						(step_m>distance_m)
					)
				{
					print ("R8R catch, stepped, step="~step_m~" dist="~distance_m~" prev="~prev_distance_m);
					return_value=1;
				}

#	Other simple complex catcher, if missile leaves target and distance is smaller than constant
#	Of course, it's fake one, but normal ones often not works at simulation with lags here and there

				if (prev_distance_m<distance_m)
				{
					if
						(
							(prev_distance_m<fdm_node.getNode("data/prepare-m").getValue()) or
							(prev_distance_m<(step_m*2))
						)
						{
							print ("R8R catch, prepared, step="~step_m~" dist="~distance_m~" prev="~prev_distance_m);
							return_value=1;
						}
						else
						{
							if (fdm_node.getNode("ranger/miss-m").getValue()==0)
							{
								print ("R8R miss, min_dist="~prev_distance_m);
								fdm_node.getNode("ranger/miss-m").setValue(prev_distance_m);
							}
						}
				}

#	Complex catcher, line to line cross calculation

#account at xyz cartesian coordinates

				y_x=(coord.y()-prev_coord.y())/(coord.x()-prev_coord.x());
				x_y=(coord.x()-prev_coord.x())/(coord.y()-prev_coord.y());
				x_z=(coord.x()-prev_coord.x())/(coord.z()-prev_coord.z());
				z_x=(coord.z()-prev_coord.z())/(coord.x()-prev_coord.x());
				z_y=(coord.z()-prev_coord.z())/(coord.y()-prev_coord.y());
				y_z=(coord.y()-prev_coord.y())/(coord.z()-prev_coord.z());
				const_y_x=prev_coord.y()-y_x*prev_coord.x();
				const_x_y=prev_coord.x()-x_y*prev_coord.y();
				const_x_z=prev_coord.x()-x_z*prev_coord.z();
				const_z_x=prev_coord.z()-z_x*prev_coord.x();
				const_z_y=prev_coord.z()-z_y*prev_coord.y();
				const_y_z=prev_coord.y()-y_z*prev_coord.z();

				mp_y_x=(mp_coord.y()-prev_mp_coord.y())/(mp_coord.x()-prev_mp_coord.x());
				mp_x_y=(mp_coord.x()-prev_mp_coord.x())/(mp_coord.y()-prev_mp_coord.y());
				mp_x_z=(mp_coord.x()-prev_mp_coord.x())/(mp_coord.z()-prev_mp_coord.z());
				mp_z_x=(mp_coord.z()-prev_mp_coord.z())/(mp_coord.x()-prev_mp_coord.x());
				mp_z_y=(mp_coord.z()-prev_mp_coord.z())/(mp_coord.y()-prev_mp_coord.y());
				mp_y_z=(mp_coord.y()-prev_mp_coord.y())/(mp_coord.z()-prev_mp_coord.z());
				mp_const_y_x=prev_mp_coord.y()-mp_y_x*prev_mp_coord.x();
				mp_const_x_y=prev_mp_coord.x()-mp_x_y*prev_mp_coord.y();
				mp_const_x_z=prev_mp_coord.x()-mp_x_z*prev_mp_coord.z();
				mp_const_z_x=prev_mp_coord.z()-mp_z_x*prev_mp_coord.x();
				mp_const_z_y=prev_mp_coord.z()-mp_z_y*prev_mp_coord.y();
				mp_const_y_z=prev_mp_coord.y()-mp_y_z*prev_mp_coord.z();

				x_cross_at_y=(mp_const_y_x-const_y_x)/(y_x-mp_y_x);
				x_cross_at_z=(mp_const_z_x-const_z_x)/(z_x-mp_z_x);
				y_cross_at_z=(mp_const_z_y-const_z_y)/(z_y-mp_z_y);

# check if trajectories crossed at yx plane

				if (
							(
								(x_cross_at_y>coord.x()) and 
								(x_cross_at_y<prev_coord.x())
							) or
							(
								(x_cross_at_y<coord.x()) and 
								(x_cross_at_y>prev_coord.x())
							)
						)
				{

# check distance between cross points at z, counting z by x

					z_cross_xy=z_x*x_cross_at_y+const_z_x;
					mp_z_cross_xy=mp_z_x*x_cross_at_y+mp_const_z_x;
					c_distance_m=abs(z_cross_xy-mp_z_cross_xy);
					if (step_m>c_distance_m)
					{
						print ("R8R z_cross_xy catch, calc distance="~c_distance_m~" step distance="~step_m);
						return_value=1;
					}
				}

# check if trajectories crossed at zx plane

				if (
							(
								(x_cross_at_z>coord.x()) and 
								(x_cross_at_z<prev_coord.x())
							) or
							(
								(x_cross_at_z<coord.x()) and 
								(x_cross_at_z>prev_coord.x())
							)
						)
				{

# check distance between cross points at y, counting y by x

					y_cross_xz=y_x*x_cross_at_z+const_y_x;
					mp_y_cross_xz=mp_y_x*x_cross_at_z+mp_const_y_x;
					c_distance_m=abs(y_cross_xz-mp_y_cross_xz);
					if (step_m>c_distance_m)
					{
						print ("R8R y_cross_zx catch, calc distance="~c_distance_m~" step distance="~step_m);
						return_value=1;
					}
				}

# check if trajectories crossed at zy plane

				if (
							(
								(y_cross_at_z>coord.y()) and 
								(y_cross_at_z<prev_coord.y())
							) or
							(
								(y_cross_at_z<coord.y()) and 
								(y_cross_at_z>prev_coord.y())
							)
						)
				{

# check distance between cross points at x, counting x by y

					x_cross_yz=x_y*y_cross_at_z+const_x_y;
					mp_x_cross_yz=mp_x_y*y_cross_at_z+mp_const_x_y;
					c_distance_m=abs(x_cross_yz-mp_x_cross_yz);
					if (step_m>c_distance_m)
					{
						print ("R8R x_cross_zy catch, calc distance="~c_distance_m~" step distance="~step_m);
						return_value=1;
					}
				}

			}

		}
	}

#	update ranger data

	fdm_node.getNode("ranger/id").setValue(fdm_node.getNode("target/id").getValue());
	fdm_node.getNode("ranger/elevation-ft").setValue(elevation_ft);
	fdm_node.getNode("ranger/latitude-deg").setValue(coord.lat());
	fdm_node.getNode("ranger/longitude-deg").setValue(coord.lon());
	fdm_node.getNode("ranger/mp-altitude-ft").setValue(mp_altitude_ft);
	fdm_node.getNode("ranger/mp-latitude-deg").setValue(mp_coord.lat());
	fdm_node.getNode("ranger/mp-longitude-deg").setValue(mp_coord.lon());

	return	return_value;
	
}

# fi-0 mode-------------------------------------------------------

# In that mode missile search for target by itsel,
# and aims at it.
# Mode works if missile is attached and switch is set,
# or then it flies and loses target.

r8r_fi_0=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");

	if (fdm_node.getNode("state/fi-0").getValue()==1)
	{

		distance_m=fdm_node.getNode("data/range-m").getValue()+1;
		target_id=-1;

		models_node=props.globals.getNode("ai/models");
		if (models_node.getNode("multiplayer[0]/id") != nil)
		{
			foreach (var node; models_node.getChildren("multiplayer"))
			{
				index=node.getIndex();
				if (index == nil)
				{
					index=0;
				}
				if (node.getNode("id") != nil)
				{
					target_array=r8r_radar(fdm_node, node);
					if (target_array[0]!=-1)
					{
						if (target_array[3]<distance_m)
						{
							target_id=target_array[0];
							distance_m=target_array[3];
						}
					}
				}
			}
		}

		fdm_node.getNode("target/id").setValue(target_id);

		if 	(
					(fdm_node.getNode("target/id").getValue() != -1) and
						(	
							(	(fdm_node.getNode("state/flying").getValue() == 0) and
							(fdm_node.getNode("control/fi-0").getValue() == 1)	
						) or
						(	
							(fdm_node.getNode("state/flying").getValue() == 1) and
							(fdm_node.getNode("target/id").getValue() == -1)	
						)
					)
				)
		{
			fdm_node.getNode("state/fi-0").setValue(1);
		}
		else
		{
			fdm_node.getNode("state/fi-0").setValue(0);
		}

	}

	settimer(func r8r_fi_0(), 1.0);
}

# main procedure -------------------------------------------------

aim_r8r=func()
{
	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");

# time tick receiving

	tick_sec=fdm_node.getNode("tick-sec").getValue();
	if ((tick_sec == nil) or (tick_sec == 0))
	{
		tick_sec=1.0;
	}

	target_existed=0;
	target_visible=0;

	if (fdm_node.getNode("state/existed").getValue() != 0)
	{

		if (fdm_node.getNode("state/flying").getValue() == 0)
		{
			if (fdm_node.getNode("control/fi-0").getValue()==0)
			{
				fdm_node.getNode("target/id").setValue(
					fdm_node.getNode("control/lock-id").getValue());
				fdm_node.getNode("state/fi-0").setValue(0);
			}
			else
			{
				fdm_node.getNode("state/fi-0").setValue(1);
			}
		}
		else
		{
			if (fdm_node.getNode("target/id").getValue()!=-1)
			{
				fdm_node.getNode("state/fi-0").setValue(0);
			}
			else
			{
				fdm_node.getNode("state/fi-0").setValue(1);
			}
		}

		if (fdm_node.getNode("target/id").getValue() != -1)
		{
			models_node=props.globals.getNode("ai/models");
			if (models_node.getNode("multiplayer[0]/id") != nil)
			{
				foreach (var node; models_node.getChildren("multiplayer"))
				{
					index=node.getIndex();
					if (index == nil)
					{
						index=0;
					}
					if (node.getNode("id") != nil)
					{
						if (node.getNode("id").getValue() == 
							fdm_node.getNode("target/id").getValue())
						{

							target_existed=1;

# update target data

							r8r_target(fdm_node, node);

# check if missile catched target

							if (r8r_mp_ranger(fdm_node, node)==1)
							{
								fdm_node.getNode("state/catch-id").setValue(node.getNode("id").getValue());
								fdm_node.getNode("target/catched").setValue(1);
								fdm_node.getNode("state/existed").setValue(0);
								mpclash.set_catch(node, 4, 0, 1);
								return;
							}

#	check if target is visible to radar of missile

							target_array=r8r_radar(fdm_node, node);
							if (target_array[0]!=-1)
							{

								target_visible=1;

#	as target visible, check if missile see it first time

								if 	(fdm_node.getNode("radar/id").getValue()!=target_array[0])
								{

# yes, set controls to flight to that point

									fdm_node.getNode("radar/pitch-to-deg").setValue(target_array[1]);
									fdm_node.getNode("radar/yaw-to-deg").setValue(target_array[2]);
									fdm_node.getNode("radar/distance-m").setValue(target_array[3]);
									fdm_node.getNode("radar/min-dist-m").setValue(target_array[3]);
									fdm_node.getNode("control/surfaces/elevator-norm").setValue(0);
									fdm_node.getNode("control/surfaces/rudder-norm").setValue(0);
									fdm_node.getNode("radar/pitch-cmd-deg-s").setValue(0);
									fdm_node.getNode("radar/yaw-cmd-deg-s").setValue(0);
								}
								else
								{

# not, account angles change
# and set controls to flight to point it awaited
# to be at next second

# prognosed angles calculation, taking in mind angles to target change
# and own missile angles change

									fdm_node.getNode("radar/pitch-cmd-deg-s").setValue(
										fdm_node.getNode("radar/pitch-cmd-deg-s").getValue()
										+(
											-fdm_node.getNode("radar/pitch-cmd-deg-s").getValue()
											+target_array[1]*0.1
											+(
												target_array[1]
												-fdm_node.getNode("radar/pitch-to-deg").getValue()
												+fdm_node.getNode("velocities/pitch-rad-sec").getValue()
													*57.2957795
													*tick_sec
											)/tick_sec*8.0
										)
									);

									fdm_node.getNode("control/surfaces/elevator-norm").setValue(
										interpol.lin_inter(
											[
												[-28.64788975,	-1.0],
												[0.0,						0.0],
												[28.64788975,		1.0]
											],
											fdm_node.getNode("radar/pitch-cmd-deg-s").getValue()
										)
									);

									fdm_node.getNode("radar/yaw-cmd-deg-s").setValue(
										fdm_node.getNode("radar/yaw-cmd-deg-s").getValue()
										+(
											-fdm_node.getNode("radar/yaw-cmd-deg-s").getValue()
											+target_array[2]*0.1
											+(
												target_array[2]
												-fdm_node.getNode("radar/yaw-to-deg").getValue()
												+fdm_node.getNode("velocities/yaw-rad-sec").getValue()
													*57.2957795
													*tick_sec
											)/tick_sec*8.0
										)
									);

									fdm_node.getNode("control/surfaces/rudder-norm").setValue(
										interpol.lin_inter(
											[
												[-28.64788975,	-1.0],
												[0.0,						0.0],
												[28.64788975,		1.0]
											],
											fdm_node.getNode("radar/yaw-cmd-deg-s").getValue()
										)
									);

								}

##								if (fdm_node.getNode("state/flying").getValue() == 1)
#								{
#									print(
#										"R8R "~
#										" tick="~sprintf("%02.2f", tick_sec)~
#										" dist="~sprintf("%i", target_array[3])~
#										" a_p="~sprintf("%02.2f", fdm_node.getNode("radar/pitch-to-deg").getValue())~
#										" a="~sprintf("%02.2f", target_array[1])~
#										" p_p="~sprintf("%02.2f", (fdm_node.getNode("radar/own-pitch-deg").getValue()))~
#										" p="~sprintf("%02.2f", (fdm_node.getNode("pitch-deg").getValue()))~
#										" a_c="~sprintf("%02.2f", fdm_node.getNode("radar/pitch-cmd-deg-s").getValue())~
#										" b="~sprintf("%02.2f", target_array[2])
#									);
#								}

								fdm_node.getNode("radar/id").setValue(target_array[0]);
								fdm_node.getNode("radar/pitch-to-deg").setValue(target_array[1]);
								fdm_node.getNode("radar/yaw-to-deg").setValue(target_array[2]);

								fdm_node.getNode("radar/distance-m").setValue(target_array[3]);
								fdm_node.getNode("radar/min-dist-m").setValue(target_array[3]);


							}
						}
					}
				}
			}
		}
	}

	if (target_existed==0)
	{

#	as target not existed, remove data of it

		fdm_node.getNode("target/id").setValue(-1);
		fdm_node.getNode("target/latitude-deg").setValue(0);
		fdm_node.getNode("target/longitude-deg").setValue(0);
		fdm_node.getNode("target/altitude-ft").setValue(0);
		fdm_node.getNode("target/pitch-deg").setValue(0);
		fdm_node.getNode("target/roll-deg").setValue(0);
		fdm_node.getNode("target/heading-deg").setValue(0);

# also remove data of ranger, and set its id to -1

		fdm_node.getNode("ranger/id").setValue(-1);
		fdm_node.getNode("ranger/distance-m").setValue(0);
		fdm_node.getNode("ranger/elevation-ft").setValue(0);
		fdm_node.getNode("ranger/latitude-deg").setValue(0);
		fdm_node.getNode("ranger/longitude-deg").setValue(0);
		fdm_node.getNode("ranger/mp-altitude-ft").setValue(0);
		fdm_node.getNode("ranger/mp-latitude-deg").setValue(0);
		fdm_node.getNode("ranger/mp-longitude-deg").setValue(0);
		fdm_node.getNode("ranger/miss-m").setValue(0);

		fdm_node.getNode("radar/pitch-cmd-deg-s").setValue(0);
		fdm_node.getNode("radar/yaw-cmd-deg-s").setValue(0);

		fdm_node.getNode("control/surfaces/elevator-norm").setValue(0);
		fdm_node.getNode("control/surfaces/rudder-norm").setValue(0);

	}

	if (target_visible==0)
	{

#	as target not visible, remove radar data of it,
# and set controls to straight flight

		fdm_node.getNode("radar/id").setValue(-1);
		fdm_node.getNode("radar/pitch-to-deg").setValue(0);
		fdm_node.getNode("radar/yaw-to-deg").setValue(0);
		fdm_node.getNode("radar/distance-m").setValue(0);
		fdm_node.getNode("radar/pitch-cmd-deg-s").setValue(0);
		fdm_node.getNode("radar/yaw-cmd-deg-s").setValue(0);
		fdm_node.getNode("control/surfaces/elevator-norm").setValue(0);
		fdm_node.getNode("control/surfaces/rudder-norm").setValue(0);
	}

}

# adds missile model by mpclash--------------------------------------

add_r8r_model=func
{
	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");

	var	object_array=[0,	0,	0,	0,	0,	0,	0,	0];
		#	type	of	object
	object_array[0]=4; #means R8R, by table at set file
		#	id	of	it,	0	for	first	one,	1	for	second,	etc
	object_array[1]=0;
		#path	to	control	node
	object_array[2]="fdm/jsbsim/systems/R8R/latitude-inter-deg";
	object_array[3]="fdm/jsbsim/systems/R8R/longitude-inter-deg";
	object_array[4]="fdm/jsbsim/systems/R8R/elevation-inter-ft";
	object_array[5]="fdm/jsbsim/systems/R8R/pitch-deg";
	object_array[6]="fdm/jsbsim/systems/R8R/roll-deg";
	object_array[7]="fdm/jsbsim/systems/R8R/heading-deg";
	mpclash.add_user_object(object_array);
	mpclash.remove_user_catches(4, 0);
	fdm_node.getNode("state/model-added").setValue(1);
}

# update listener  -------------------------------------------------

# update model listener, removes model if needed, otherwise
# updates its data

update_r8r_listener=func
{
	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");
	if (fdm_node.getNode("state/existed").getValue()==1)
	{

		if (fdm_node.getNode("control/reset").getValue()==1)
		{
			# remove missile catches
			mpclash.remove_user_catches(4, 0);
			# remove missile model
			mpclash.remove_user_object(4, 0);
			fdm_node.getNode("state/model-added").setValue(0);
		}

		if ((fdm_node.getNode("state/model-added").getValue()==0) and
			(fdm_node.getNode("state/flying").getValue()==1))
		{
			add_r8r_model();
		}

		# change missile effects
		if (fdm_node.getNode("state/flying").getValue()==1)
		{
			if (fdm_node.getNode("engine/working").getValue()==1)
			{
				var	effects_array=[1, 2, 8];
				mpclash.set_user_object_effects(4,	0, effects_array);
			}
			else
			{
				var	effects_array=[2, 8];
				mpclash.set_user_object_effects(4,	0, effects_array);
			}
		}
		else
		{
			var	effects_array=[];
			mpclash.set_user_object_effects(4,	0, effects_array);
		}

	}
	else
	{
		if (fdm_node.getNode("state/model-added").getValue()==1)
		{
			# remove missile model
			mpclash.remove_user_object(4, 0);
			fdm_node.getNode("state/model-added").setValue(0);
		}
	}
}

# init listener  -------------------------------------------------

#	init rocket model at craft init
#	add listener updates model data on each jsb data update

init_r8r_listener=func
{
	init_node=props.globals.getNode("fdm/jsbsim/init/init");
	if (init_node!=nil)
	{
		if (init_node.getValue()==1)
		{
			print("R8R init");
			fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");
			removelistener(fdm_node.getNode("state/listener-index").getValue());
			listener_index=setlistener("fdm/jsbsim/systems/R8R/elevation-ft", update_r8r_listener);
			fdm_node.getNode("state/listener-index").setValue(listener_index);
			fdm_node.getNode("control/init").setValue(1);
			r8r_time();
			r8r_fi_0();
		}
	}
}

# startup procedure  -------------------------------------------------

#	set listener which awaits craft init

await_craft_init=func
{
	listener_index=setlistener("fdm/jsbsim/init/init", init_r8r_listener);
	fdm_node=props.globals.getNode("fdm/jsbsim/systems/R8R");
	fdm_node.getNode("state/listener-index").setValue(listener_index);
	print("R8R awaiting init");
}

# initialisation  -------------------------------------------------

await_craft_init();
