#-----------------------------------------------------------------------
#Radiocompass

#Find nearest ndb station by selected frequency, then distance and angle to it
#findNavaidByFrequency seems to not work, it returns nil at all
#cases - if it was feede by frequency in herz, kiloherz, megaherz,
# and results of findNavaidsWithinRange.
#So findNavaidsWithinRange is used instead.

init_radiocompass_update=func
{
}

init_radiocompass_update();

stop_radiocompass_update=func
	{
	}

stations_update=func
	{
		coord=geo.aircraft_position();
		beacon_coord=geo.Coord.new();
		radiocompass_node=props.globals.getNode("fdm/jsbsim/systems/radiocompass");
		if (coord.is_defined()==1)
		{
			range = int(radiocompass_node.getNode("range-km").getValue()/1.852);
			navaids = findNavaidsWithinRange(range, "ndb");
			id=0;
			if (navaids!=nil)
			{
				foreach (var navaid; navaids)
				{
					if (navaid!=nil)			
					{
						if ((navaid.lat!=nil)
							and (navaid.lon!=nil)
							and (navaid.elevation!=nil))
						{
							beacon_coord.set_latlon(navaid.lat, navaid.lon, navaid.elevation);
							if ((beacon_coord.alt()!=nil)
								and (coord.alt()!=nil))
							{
								#check if beacon is hidden behind mountain
								hidden_by_mountain=0;
								for (i=0; i<10; i+=1)
								{
									ground_latitude_deg=coord.lat()+(beacon_coord.lat()-coord.lat())*i/10;
									ground_longitude_deg=coord.lon()+(beacon_coord.lon()-coord.lon())*i/10;
									line_altitude_m=coord.alt()+(beacon_coord.alt()-coord.alt())*i/10;
									ground_altitude_m=geo.elevation(ground_latitude_deg, ground_longitude_deg);
									if ((ground_altitude_m!=nil)
										and (line_altitude_m!=nil))
									if (ground_altitude_m>line_altitude_m)
									{
										hidden_by_mountain=1;
									}
								}
								if (hidden_by_mountain==0)
								{
									setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~id~"]/lat", navaid.lat);
									setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~id~"]/lon", navaid.lon);
									setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~id~"]/elevation", navaid.elevation);
									setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~id~"]/frequency", navaid.frequency);
									id=id+1;
								}
							}
						}
					}
				}
			}
			if (radiocompass_node.getNode("stations")!=nil)
			{
				foreach (var node; radiocompass_node.getNode("stations").getChildren("unit"))
				{
					if (node!=nil)
					{
						i=node.getIndex();
						if (i>=id)
						{
							setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~i~"]/lat", 0);
							setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~i~"]/lon", 0);
							setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~id~"]/elevation", 0);
							setprop("fdm/jsbsim/systems/radiocompass/stations/unit["~i~"]/frequency", 0);
						}
					}
				}
			}
		}
		settimer(stations_update, 60.0);
	}

stations_update();

radiocompass_update=func
	{
		coord=geo.aircraft_position();
		beacon_coord=geo.Coord.new();
		radiocompass_node=props.globals.getNode("fdm/jsbsim/systems/radiocompass");
		fdm_node=props.globals.getNode("fdm/jsbsim");

		#Serviceability

		if (
			(fdm_node.getNode("breakage/broken").getValue()==1)
			 and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
		{
			radiocompass_node.getNode("serviceable").setValue(0);
		}

		if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
		{
			radiocompass_node.getNode("serviceable").setValue(1);
		}

		#Controllability

		radiocompass_node.getNode("controllable").setValue(
			(1-fdm_node.getNode("breakage/pilot-knocked").getValue())
		);

		#On

		if (
			(radiocompass_node.getNode("selector-switch").getValue()>0)
			and (fdm_node.getNode("systems/rightpanel/radiocompass-switch").getValue()==1)
			and (fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()==1)
		)
		{
			radiocompass_node.getNode("on").setValue(1);
		}
		else
		{
			radiocompass_node.getNode("on").setValue(0);
		}

		#Switches

		if (
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("controllable").getValue()==1)
			and (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
		)
		{
			radiocompass_node.getNode("selector-command").setValue(
				radiocompass_node.getNode("selector-input").getValue()
			);
			radiocompass_node.getNode("tlg-command").setValue(
				radiocompass_node.getNode("tlg-input").getValue()
			);
			radiocompass_node.getNode("volume-vern-pos").setValue(
				radiocompass_node.getNode("volume-vern-input").getValue()
			);
		}

		if (
			(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		)
		{
			radiocompass_node.getNode("selector-command").setValue(0);
			radiocompass_node.getNode("tlg-command").setValue(0);
			radiocompass_node.getNode("volume-vern-command").setValue(0.5);
			radiocompass_node.getNode("program-input").setValue(0);
		}

		radiocompass_node.getNode("selector-pos").setValue(
			interpol.kin(
				radiocompass_node.getNode("selector-pos").getValue(),
				radiocompass_node.getNode("selector-command").getValue(),
				0.2,
				0.1
			)
		);

		radiocompass_node.getNode("tlg-pos").setValue(
			interpol.kin(
				radiocompass_node.getNode("tlg-pos").getValue(),
				radiocompass_node.getNode("tlg-command").getValue(),
				0.2,
				0.1
			)
		);

		if (
			(radiocompass_node.getNode("serviceable").getValue()==0)
			or (radiocompass_node.getNode("controllable").getValue()==0)
			or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		)
		{
			radiocompass_node.getNode("selector-input").setValue(
				radiocompass_node.getNode("selector-command").getValue()
			);
			radiocompass_node.getNode("tlg-input").setValue(
				radiocompass_node.getNode("tlg-command").getValue()
			);
			radiocompass_node.getNode("volume-vern-input").setValue(
				radiocompass_node.getNode("volume-vern-pos").getValue()
			);
		}

		radiocompass_node.getNode("selector-switch").setValue(
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[0.25,	0.0],
					[0.333,	1.0],
					[0.5,		1.0],
					[0.66,	1.0],
					[0.75,	2.0],
					[1.0,		2.0]
				],
				radiocompass_node.getNode("selector-pos").getValue()
			)
		);

		radiocompass_node.getNode("tlg-switch").setValue(
			radiocompass_node.getNode("tlg-pos").getValue()>0.5
		);

		if (
			(
				(radiocompass_node.getNode("selector-pos").getValue()>0.2)
				and (radiocompass_node.getNode("selector-pos").getValue()<0.4)
			)
			or (
				(radiocompass_node.getNode("selector-pos").getValue()>0.6)
				and (radiocompass_node.getNode("selector-pos").getValue()<0.8)
			)
			or (
				(radiocompass_node.getNode("tlg-pos").getValue()>0.25)
				and (radiocompass_node.getNode("tlg-pos").getValue()<0.75)
			)
		)
		{
			fdm_node.getNode("systems/sounds/click/on").setValue(1);
		}

		#Buttons

		diapason_change=-1;
		freq_change=0;

		foreach (var node; radiocompass_node.getChildren("unit"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			if (
				(radiocompass_node.getNode("serviceable").getValue()==1)
				and (radiocompass_node.getNode("controllable").getValue()==1)
			)
			{
				node.getNode("button-command").setValue(
					radiocompass_node.getNode("program-input").getValue()==index
				);
			}

			node.getNode("button-pos").setValue(
				interpol.kin(
					node.getNode("button-pos").getValue(),
					node.getNode("button-command").getValue(),
					0.2,
					0.1
				)
			);

			if (
				(node.getNode("button-pos").getValue()>0.75)
				and (radiocompass_node.getNode("on").getValue()==1)
			)
			{
				radiocompass_node.getNode("program").setValue(index);
			}

			if (
				(node.getNode("button-pos").getValue()>0.25)
				and (node.getNode("button-pos").getValue()<0.75)
			)
			{
				fdm_node.getNode("systems/sounds/click/on").setValue(1);
			}

		}

		foreach (var node; radiocompass_node.getChildren("unit"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			if (
				(radiocompass_node.getNode("program-stored").getValue()==index)
				and (
					radiocompass_node.getNode("program-stored").getValue()!=
					radiocompass_node.getNode("program").getValue()
				)
			)
			{
				node.getNode("diapason").setValue(
					radiocompass_node.getNode("diapason-switch").getValue()
				);
				node.getNode("freq").setValue(
					radiocompass_node.getNode("freq-pos").getValue()
				);
			}

			if (
				(radiocompass_node.getNode("program").getValue()==index)
				and (
					radiocompass_node.getNode("program-stored").getValue()!=
					radiocompass_node.getNode("program").getValue()
				)
			)
			{
				diapason_change=node.getNode("diapason").getValue();
				freq_change=node.getNode("freq").getValue();
			}

		}

		radiocompass_node.getNode("diapason-change").setValue(
			diapason_change
		);
		radiocompass_node.getNode("freq-change").setValue(
			freq_change
		);

		radiocompass_node.getNode("program-stored").setValue(
			radiocompass_node.getNode("program").getValue()
		);

		#Diapason shift

		radiocompass_node.getNode("diapason-shift").setValue(
			radiocompass_node.getNode("diapason-input").getValue()
			-radiocompass_node.getNode("diapason-stored").getValue()
		);

		radiocompass_node.getNode("diapason-handle-input").setValue(
			radiocompass_node.getNode("diapason-handle-input").getValue()
			+radiocompass_node.getNode("diapason-shift").getValue()
			*radiocompass_node.getNode("controllable").getValue()
		);

		radiocompass_node.getNode("diapason-handle-shift").setValue(
			radiocompass_node.getNode("diapason-handle-input").getValue()
			-radiocompass_node.getNode("diapason-handle-pos").getValue()
		);

		radiocompass_node.getNode("diapason-handle-pos").setValue(
			radiocompass_node.getNode("diapason-handle-pos").getValue()
			+radiocompass_node.getNode("diapason-handle-shift").getValue()
			*0.5
		);

		radiocompass_node.getNode("diapason-handle-shift").setValue(
			radiocompass_node.getNode("diapason-handle-input").getValue()
			-radiocompass_node.getNode("diapason-handle-pos").getValue()
		);

		pos_input=
			radiocompass_node.getNode("diapason-pos-input").getValue()
			+(
				radiocompass_node.getNode("diapason-shift").getValue()
				*radiocompass_node.getNode("on").getValue()
				*interpol.lin_inter(
					[
						[-1.0,	1.0],
						[0.0,		0.0]
					],
					radiocompass_node.getNode("diapason-change").getValue()
				)
			)
			+(
				(
					radiocompass_node.getNode("diapason-change").getValue()
					-radiocompass_node.getNode("diapason-pos-input").getValue()
				)
				*interpol.lin_inter(
					[
						[-1.0,	0.0],
						[0.0,		1.0]
					],
					radiocompass_node.getNode("diapason-change").getValue()
				)
			)
		;

		radiocompass_node.getNode("diapason-pos-input").setValue(
			interpol.lin_inter(
				[
					[0.0,	0.0],
					[7.0,	7.0]
				],
				pos_input
			)
		);

		radiocompass_node.getNode("diapason-pos-shift").setValue(
			radiocompass_node.getNode("diapason-pos-input").getValue()
			-radiocompass_node.getNode("diapason-pos").getValue()
		);

		radiocompass_node.getNode("diapason-pos").setValue(
			radiocompass_node.getNode("diapason-pos").getValue()
			+radiocompass_node.getNode("diapason-pos-shift").getValue()
			*0.5
		);

		radiocompass_node.getNode("diapason-switch").setValue(
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[0.25,	0.0],
					[0.75,	1.0],
					[1.25,	1.0],
					[1.75,	2.0],
					[2.25,	2.0],
					[2.75,	3.0],
					[3.25,	3.0],
					[3.75,	4.0],
					[4.25,	4.0],
					[4.75,	5.0],
					[5.25,	5.0],
					[5.75,	6.0],
					[6.25,	6.0],
					[6.75,	7.0],
					[7.0,		7.0]
				],
				radiocompass_node.getNode("diapason-pos").getValue()
			)
		);

		radiocompass_node.getNode("diapason-moving").setValue(
			radiocompass_node.getNode("diapason-pos-input").getValue()!=
			radiocompass_node.getNode("diapason-switch").getValue()
		);

		radiocompass_node.getNode("diapason-stored").setValue(
			radiocompass_node.getNode("diapason-input").getValue()
		);

		#Diapason limits

		radiocompass_node.getNode("freq-low-lim").setValue(
			interpol.sqr_inter(
				[
					[0.0,	0.0,		1.0],
					[0.0,	120.0,	0.0],
					[1.0,	280.0,	0.0],
					[2.0,	440.0,	0.0],
					[3.0,	600.0,	0.0],
					[4.0, 760.0,	0.0],
					[5.0,	920.0,	0.0],
					[6.0,	1080.0,	0.0],
					[7.0,	1240.0,	0.0]
				],
				radiocompass_node.getNode("diapason-switch").getValue(),
				radiocompass_node.getNode("diapason-moving").getValue()
			)
		);

		radiocompass_node.getNode("freq-high-lim").setValue(
			interpol.sqr_inter(
				[
					[0.0,	0.0,		1.0],
					[0.0,	280.0,	1400.0],
					[1.0,	440.0,	1400.0],
					[2.0,	600.0,	1400.0],
					[3.0, 760.0,	1400.0],
					[4.0,	920.0,	1400.0],
					[5.0,	1080.0,	1400.0],
					[6.0,	1240.0,	1400.0],
					[7.0,	1400.0,	1400.0]
				],
				radiocompass_node.getNode("diapason-switch").getValue(),
				radiocompass_node.getNode("diapason-moving").getValue()
			)
		);

		#Handles manual shift

		radiocompass_node.getNode("hard-handle-shift").setValue(
			(
				radiocompass_node.getNode("hard-handle-input").getValue()
				-radiocompass_node.getNode("hard-handle-stored").getValue()
			)*
			radiocompass_node.getNode("controllable").getValue()
		);

		radiocompass_node.getNode("soft-handle-shift").setValue(
			(
				radiocompass_node.getNode("soft-handle-input").getValue()
				-radiocompass_node.getNode("soft-handle-stored").getValue()
			)*
			radiocompass_node.getNode("controllable").getValue()
		);

		radiocompass_node.getNode("hard-handle-pos").setValue(
			radiocompass_node.getNode("hard-handle-pos").getValue()
			+radiocompass_node.getNode("hard-handle-shift").getValue()
			*0.5
		);

		radiocompass_node.getNode("soft-handle-pos").setValue(
			radiocompass_node.getNode("soft-handle-pos").getValue()
			+radiocompass_node.getNode("soft-handle-shift").getValue()
			*0.5
		);

		#Hard handle pin

		radiocompass_node.getNode("handle-pin-shift").setValue(
			interpol.sqr_inter(
				[
					[0.0,		0.0,	1.0],
					[-1.0,	5.0,	0.0],
					[0.0,		0.0,	-0.5],
					[1.0,		5.0,	0.0]
				],
				radiocompass_node.getNode("hard-handle-shift").getValue(),
				radiocompass_node.getNode("handle-pin-pid").getValue()
			)
		);

		radiocompass_node.getNode("handle-pin-pid").setValue(
			radiocompass_node.getNode("handle-pin-pid").getValue()
			+radiocompass_node.getNode("handle-pin-shift").getValue()
			*0.5
		);

		radiocompass_node.getNode("handle-pin-pos").setValue(
			interpol.sqr_inter(
				[
					[0.0,		-1.0, 0.0,	1.0],
					[0.0,		0.0,	0.0,	0.0],
					[0.01,	0.01,	1.0, 	0.01],
					[1.0,		1.0,	1.0, 	1.0]
				],
				radiocompass_node.getNode("handle-pin-pid").getValue(),
				radiocompass_node.getNode("hard-handle-shift").getValue()
			)
		);

		#Frequency shift

		radiocompass_node.getNode("freq-calc").setValue(
			(
				radiocompass_node.getNode("freq-pos").getValue()
				+radiocompass_node.getNode("hard-handle-shift").getValue()
				+radiocompass_node.getNode("soft-handle-shift").getValue()
			)
			*interpol.lin_inter(
				[
					[0.0,	1.0],
					[1.0,	0.0]
				],
				radiocompass_node.getNode("freq-change").getValue()
			)
			+radiocompass_node.getNode("freq-change").getValue()
			*interpol.lin_inter(
				[
					[0.0,	0.0],
					[1.0,	1.0]
				],
				radiocompass_node.getNode("freq-change").getValue()
			)
		);

		if (radiocompass_node.getNode("on").getValue()==1)
		{

			if (
				radiocompass_node.getNode("freq-calc").getValue()<=
				radiocompass_node.getNode("freq-low-lim").getValue()
			)
			{
				radiocompass_node.getNode("freq-pos").setValue(
					radiocompass_node.getNode("freq-low-lim").getValue()
				);
			}
			else
			{
				if (
					radiocompass_node.getNode("freq-calc").getValue()>=
					radiocompass_node.getNode("freq-high-lim").getValue()
				)
				{
					radiocompass_node.getNode("freq-pos").setValue(
						radiocompass_node.getNode("freq-high-lim").getValue()
					);
				}
				else
				{
					radiocompass_node.getNode("freq-pos").setValue(
						radiocompass_node.getNode("freq-calc").getValue()
					);
				}
			}

			if (
				radiocompass_node.getNode("freq-pid").getValue()<
				radiocompass_node.getNode("freq-low-lim").getValue()
			)
			{
				radiocompass_node.getNode("freq-pid").setValue(
					radiocompass_node.getNode("freq-low-lim").getValue()
				);
			}

			if (
				radiocompass_node.getNode("freq-pid").getValue()>
				radiocompass_node.getNode("freq-high-lim").getValue()
			)
			{
				radiocompass_node.getNode("freq-pid").setValue(
					radiocompass_node.getNode("freq-high-lim").getValue()
				);
			}

		}

		radiocompass_node.getNode("freq-shift").setValue(
			radiocompass_node.getNode("freq-pos").getValue()
			-radiocompass_node.getNode("freq-pid").getValue()
		);

		radiocompass_node.getNode("freq-shift").setValue(
			interpol.lin_inter(
				[
					[-1.0,	-1.0],
					[0.0,		0.0],
					[1.0,		1.0]
				],
				radiocompass_node.getNode("freq-shift").getValue()
			)
		);

		radiocompass_node.getNode("freq-pid").setValue(
			radiocompass_node.getNode("freq-pid").getValue()
			+radiocompass_node.getNode("freq-shift").getValue()
		);

		radiocompass_node.getNode("freq-int").setValue(
			int(radiocompass_node.getNode("freq-pid").getValue())
		);

		#Levers manual shift finalisation

		radiocompass_node.getNode("hard-handle-stored").setValue(
			radiocompass_node.getNode("hard-handle-input").getValue()
		);

		radiocompass_node.getNode("soft-handle-stored").setValue(
			radiocompass_node.getNode("soft-handle-input").getValue()
		);

		#Frequency discs positions

		radiocompass_node.getNode("freq-deg-calc").setValue(
			radiocompass_node.getNode("freq-int").getValue()
			-interpol.lin_inter(
				[
					[0.0,	120.0],
					[1.0,	280.0],
					[2.0,	440.0],
					[3.0,	600.0],
					[4.0, 760.0],
					[5.0,	920.0],
					[6.0,	1080.0],
					[7.0,	1240.0]
				],
				radiocompass_node.getNode("diapason-switch").getValue()
			)
		);

		radiocompass_node.getNode("freq-cover-disc-deg").setValue(
			interpol.lin_inter(
				[
					[0,		0],
					[5,		15.5],
					[10,	30.0],
					[15,	44.5],
					[20,	57.5],
					[25,	70.6],
					[30,	82.5],
					[35,	94.9],
					[40,	105.6],
					[45,	117.1],
					[50,	128.3],
					[55,	138.8],
					[60,	149.6],
					[65,	159.1],
					[70,	168.5],
					[75,	178.4],
					[80,	187.7],
					[85,	197.1],
					[90,	206],
					[95,	214.8],
					[100,	223.3],
					[105,	232],
					[110,	240],
					[115,	247.6],
					[120,	256.2],
					[125,	264],
					[130,	272.2],
					[135,	279.6],
					[140,	287.4],
					[145,	295],
					[150,	302.4],
					[155,	309.7],
					[160,	317.2]
				],
				radiocompass_node.getNode("freq-deg-calc").getValue()
			)
		);

		radiocompass_node.getNode("freq-disc-deg").setValue(
			radiocompass_node.getNode("freq-cover-disc-deg").getValue()
			+interpol.lin_inter(
				[
					[0,	0],
					[1,	45],
					[2,	90],
					[3,	135],
					[4,	180],
					[5,	225],
					[6,	270],
					[7,	315]
				],
				radiocompass_node.getNode("diapason-switch").getValue()
			)
		);

		#Receiver set up timer

		if (
			(radiocompass_node.getNode("freq-shift").getValue()>=0.5)
			or (radiocompass_node.getNode("freq-shift").getValue()<=-0.5)
			or (radiocompass_node.getNode("in-range").getValue()==0.0)
		)
		{
			radiocompass_node.getNode("receiver-set-input").setValue(1);
		}

		if (
			(radiocompass_node.getNode("freq-shift").getValue()>-0.5)
			and (radiocompass_node.getNode("freq-shift").getValue()<0.5)
			and (radiocompass_node.getNode("in-range").getValue()==1.0)
			and (radiocompass_node.getNode("receiver-set-pos").getValue()>0.95)
		)
		{
			radiocompass_node.getNode("receiver-set-input").setValue(0);
		}

		radiocompass_node.getNode("receiver-set-pos").setValue(
			interpol.kin(
				radiocompass_node.getNode("receiver-set-pos").getValue(),
				radiocompass_node.getNode("receiver-set-input").getValue(),
				0.2,
				0.1
			)
		);

		#Receiving quality needle

		receiver_ind_input=0;

		if (
			radiocompass_node.getNode("serviceable").getValue()==0
		)
		{
			receiver_ind_input=
				radiocompass_node.getNode("receiver-ind-pos").getValue();
		}

		if (
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("on").getValue()==1)
			and (radiocompass_node.getNode("in-range").getValue()==1)
			and (
				(radiocompass_node.getNode("selector-switch").getValue()==2)
				or (
					(radiocompass_node.getNode("selector-switch").getValue()==1)
					and (radiocompass_node.getNode("receiver-set-pos").getValue()==0)
				)
			)
		)
		{
			receiver_ind_input=1;
		}

		radiocompass_node.getNode("receiver-ind-input").setValue(
			receiver_ind_input
		);

		radiocompass_node.getNode("receiver-ind-pos").setValue(
			interpol.kin(
				radiocompass_node.getNode("receiver-ind-pos").getValue(),
				radiocompass_node.getNode("receiver-ind-input").getValue(),
				0.2,
				0.1
			)
		);

		#Main indicator needle

		if (
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("on").getValue()==1)
			and (radiocompass_node.getNode("selector-switch").getValue()==1)
			and (radiocompass_node.getNode("receiver-set-pos").getValue()==0)
			and (radiocompass_node.getNode("in-range").getValue()==1)
		)
		{
			radiocompass_node.getNode("out").setValue(1);
			radiocompass_node.getNode("out-deg").setValue(
				radiocompass_node.getNode("course-to-deg").getValue()
			);
			radiocompass_node.getNode("out-m").setValue(
				radiocompass_node.getNode("distance-to-m").getValue()
			);
		}
		else
		{
			radiocompass_node.getNode("out").setValue(0);
			radiocompass_node.getNode("out-deg").setValue(0);
			radiocompass_node.getNode("out-m").setValue(0);
		}

		#Sounds

		#Radio noise

		radiocompass_node.getNode("radio-noise").setValue(
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("on").getValue()==1)
			and (radiocompass_node.getNode("selector-switch").getValue()==2)
			and (radiocompass_node.getNode("receiver-ind-pos").getValue()==0)
		);

		radiocompass_node.getNode("radio-noise-vol").setValue(
			radiocompass_node.getNode("radio-noise").getValue()
			*radiocompass_node.getNode("volume-vern-pos").getValue()
			*(1-radiocompass_node.getNode("receiver-ind-pos").getValue())
		);

		#Radio morse

		radiocompass_node.getNode("radio-morse").setValue(
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("on").getValue()==1)
			and (radiocompass_node.getNode("selector-switch").getValue()==2)
			and (radiocompass_node.getNode("receiver-ind-pos").getValue()>0)
			and (radiocompass_node.getNode("tlg-switch").getValue()==1)
		);

		radiocompass_node.getNode("radio-morse-vol").setValue(
			radiocompass_node.getNode("radio-morse").getValue()
			*radiocompass_node.getNode("volume-vern-pos").getValue()
			*radiocompass_node.getNode("receiver-ind-pos").getValue()
		);

		#Tune

		radiocompass_node.getNode("radio-tune").setValue(
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("on").getValue()==1)
			and (radiocompass_node.getNode("selector-switch").getValue()==2)
			and (radiocompass_node.getNode("receiver-ind-pos").getValue()>0)
			and (radiocompass_node.getNode("tlg-switch").getValue()==0)
		);

		radiocompass_node.getNode("radio-tune-vol").setValue(
			radiocompass_node.getNode("radio-tune").getValue()
			*radiocompass_node.getNode("volume-vern-pos").getValue()
			*radiocompass_node.getNode("receiver-ind-pos").getValue()
		);

		#Frequency set motor

		radiocompass_node.getNode("radio-motor").setValue(
			(radiocompass_node.getNode("serviceable").getValue()==1)
			and (radiocompass_node.getNode("on").getValue()==1)
			and (
				(radiocompass_node.getNode("freq-shift-calc").getValue()>=0.1)
				or (radiocompass_node.getNode("freq-shift-calc").getValue()<=-0.1)
			)
		);

		#Get direction

		if (coord.is_defined()==1)
		{
			freq = radiocompass_node.getNode("freq-int").getValue()*100;
			id=-1;
			distance_m=-1;
			if (radiocompass_node.getNode("stations")!=nil)
			{
				foreach (var node; radiocompass_node.getNode("stations").getChildren("unit"))
				{
					if (node.getNode("frequency").getValue()==freq)
					{
						beacon_coord.set_latlon(node.getNode("lat").getValue(), 
							node.getNode("lon").getValue(),
							node.getNode("elevation").getValue());
						if ((distance_m>coord.distance_to(beacon_coord))
							or (distance_m==-1))
						{
							distance_m=coord.distance_to(beacon_coord);
							id = node.getIndex();
						}
					}
				}
			}
			if (id!=-1)
			{
				setprop("fdm/jsbsim/systems/radiocompass/in-range", 1);
				setprop("fdm/jsbsim/systems/radiocompass/distance-to-m", distance_m);
				setprop("fdm/jsbsim/systems/radiocompass/course-to-deg", coord.course_to(beacon_coord));
			}
			else
			{
				setprop("fdm/jsbsim/systems/radiocompass/in-range", 0);
				setprop("fdm/jsbsim/systems/radiocompass/distance-to-m", 0);
				setprop("fdm/jsbsim/systems/radiocompass/course-to-deg", 0);
			}
		}

		if (radiocompass_node.getNode("on")!=0)
		{
			settimer(radiocompass_update, 0.1);
		}
		else
		{
			settimer(radiocompass_update, 1.0);
		}

	}

radiocompass_update();
